package no.item.ntnu.arctis.examples.cityguide.block_addressserviceproxy;

import no.ntnu.item.arctis.runtime.Block;
import org.apache.log4j.xml.DOMConfigurator;
import no.ntnu.item.arctis.library.proxies.Address;
import no.ntnu.item.arctis.library.proxies.Message;


public class Block_AddressServiceProxy extends Block {


	static org.apache.log4j.Logger logger = org.apache.log4j.Logger.getLogger("Block_AddressServiceProxy.Class");
	
	public no.ntnu.item.arctis.library.proxies.Message message;

	public void found(Address addr) {
		System.out.println("Block_AddressServiceProxy is found.."+addr.toString());
		logger.warn("> "+ "in found, Block_AddressServiceProxy is found.."+addr.toString());
	}

	public void notfound() {
			System.out.println("Block_AddressServiceProxy is not found..");
			logger.warn("> "+ "in nofound, Block_AddressServiceProxy is no found..");
	}

	public Message createPinMessage() {
		System.out.println("creating pin msg at Block_AddressServiceProxy");
		logger.warn("> "+ "in createPinMessage, creating pin msg at Block_Address Service proxy..");
		
		Message m = new Message("Block_AddressServiceProxy");
		m.setPayload("");
		return m;
	}

	public String extractMessage(Message msg) {
	
		System.out.println("received message from Block_Address Service at Block_Address proxy......"+msg);
		
		
		if (msg.getPayload() instanceof String){	
			String  str = (String)  msg.getPayload();
			Address s = msg.getSender().getCopy();
			System.out.println("Sender Address is ......"+s);
			
			return str;
		}
		else {
			// to do
			return (String) msg.getPayload();
		}
	}

	public void startDiscover() {
			DOMConfigurator.configure("log4j.xml");
			logger.warn("> "+ "in startDiscover, starting to discover Block_Address Service");
	}
	

}
