package no.item.ntnu.arctis.examples.cityguide.cityguideserver.component;


public class CityGuideServiceSM extends no.ntnu.item.arctis.runtime.IStateMachine {


    protected no.ntnu.item.arctis.runtime.Scheduler scheduler;
    protected java.lang.String _stateMachineID;
    private final static int s_0 = 0, s_1 = 1;
    private java.lang.String _c1_City_Guide_Service_c2;
    private java.lang.String _c1_City_Guide_Service_c1;
    private java.lang.String _c1_City_Guide_Service_c3;
    private java.lang.String _c1_City_Guide_Service_c0;
    private no.item.ntnu.arctis.examples.cityguide.cityguideservice.CityGuideService _b003;
    private static java.util.Hashtable _alias = new java.util.Hashtable();
    private static int sessionCount = 0;

    public CityGuideServiceSM(no.ntnu.item.arctis.runtime.Scheduler scheduler, java.lang.String sessionID, java.lang.String parentSessionID) {
        super(sessionID, parentSessionID);
        this.scheduler = scheduler;
        ++ sessionCount;
    }


    protected void registerAlias(java.lang.String alias, java.lang.String sessionID){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided alias is null", null);
        if(sessionID==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided sessionID is null", null);
        if(_alias.containsKey(alias)) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("A session with alias " + alias + " already exists.", null);
        _alias.put(alias, sessionID);
    }

    public static java.lang.String findSession(java.lang.String alias){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Try to find session for null alias", null);
        String sessionID = (String) _alias.get(alias);
        if(sessionID==null) {
            if(!_alias.contains(alias)) {
        	       no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map does not contain alias " + alias, null);
            } else {
                no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map has a null entry for alias " + alias, null);
            }
        }
return sessionID;
    }

    public int getSessionCount(){
        return sessionCount;
    }

    public static java.util.Collection allSessions(){
        return _alias.values();
    }

    public int fireInitial(){
        _b003 = new no.item.ntnu.arctis.examples.cityguide.cityguideservice.CityGuideService();
        _b003.setBlockID("_b003", sessionID);
        _state = s_0;
        return CONSUME_SIGNAL;
    }

    public int fire(java.lang.Object _sender, java.lang.Object sessionID, java.lang.String _signalID, java.lang.Object _data){
        if(_signalID.equals("_c1_c1_MyAddress_Service_Proxy_ok")) {
            return handleSignal__c1_c1_MyAddress_Service_Proxy_ok(_sender, sessionID, _data);
        } else if(_signalID.equals("_c1_c0_Location_Service_Proxy_ok")) {
            return handleSignal__c1_c0_Location_Service_Proxy_ok(_sender, sessionID, _data);
        } else if(_signalID.equals("_c1_c0_Location_Service_Proxy_loc")) {
            return handleSignal__c1_c0_Location_Service_Proxy_loc(_sender, sessionID, _data);
        } else if(_signalID.equals("_c1_City_Guide_Service_fwdLoc")) {
            return handleSignal__c1_City_Guide_Service_fwdLoc(_sender, sessionID, _data);
        } else if(_signalID.equals("_c1_c2_Location_Aware_Quiz_Service_Proxy_ans")) {
            return handleSignal__c1_c2_Location_Aware_Quiz_Service_Proxy_ans(_sender, sessionID, _data);
        } else if(_signalID.equals("_c1_c0_Location_Service_Proxy_nok")) {
            return handleSignal__c1_c0_Location_Service_Proxy_nok(_sender, sessionID, _data);
        } else if(_signalID.equals("_c1_City_Guide_Service_stop")) {
            return handleSignal__c1_City_Guide_Service_stop(_sender, sessionID, _data);
        } else if(_signalID.equals("_c1_c3_Block_Address_Service_Proxy_ok")) {
            return handleSignal__c1_c3_Block_Address_Service_Proxy_ok(_sender, sessionID, _data);
        } else if(_signalID.equals("_c1_c3_Block_Address_Service_Proxy_str")) {
            return handleSignal__c1_c3_Block_Address_Service_Proxy_str(_sender, sessionID, _data);
        } else if(_signalID.equals("_c1_c1_MyAddress_Service_Proxy_str")) {
            return handleSignal__c1_c1_MyAddress_Service_Proxy_str(_sender, sessionID, _data);
        } else if(_signalID.equals("_c1_c2_Location_Aware_Quiz_Service_Proxy_ok")) {
            return handleSignal__c1_c2_Location_Aware_Quiz_Service_Proxy_ok(_sender, sessionID, _data);
        } else if(_signalID.equals("_c1_City_Guide_Service_userLoggedIn")) {
            return handleSignal__c1_City_Guide_Service_userLoggedIn(_sender, sessionID, _data);
        }
        return TRIGGER_UNKNOWN;
    }

    private int handleSignal__c1_c1_MyAddress_Service_Proxy_ok(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_1 || _state == s_0) {
            scheduler.startTimer(0, "t3", this);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c1_c0_Location_Service_Proxy_ok(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_1 || _state == s_0) {
            scheduler.startTimer(0, "t2", this);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c1_c0_Location_Service_Proxy_loc(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_1) {
            no.ntnu.item.arctis.library.objects.location.Location _c1_City_Guide_Service_loc = (no.ntnu.item.arctis.library.objects.location.Location) _data;
            _b003.tempLoc = _c1_City_Guide_Service_loc;
            if(_b003.process==true) {
                _b003.toggleProcess();
                _b003.loc = _b003.tempLoc;
                if(_b003.isTreasureAt(_b003.loc)==true) {
                    if(_b003.isFirst==true) {
                        _c1_City_Guide_Service_c2 = scheduler.createFreshSessionID();
                    java.util.Map<String, Object> _c1_City_Guide_Service_c2_data = new java.util.HashMap<String,Object>();
                    scheduler.sendToSession(this, _c1_City_Guide_Service_c2, "_c1_c2_Location_Aware_Quiz_Service_Proxy_start", _c1_City_Guide_Service_c2_data);
                        scheduler.sendToParent(this,"_c1_City_Guide_Service_loc", _b003.LocationToStr(_b003.tempLoc));
                        return CONSUME_SIGNAL;
                    } else {
                                    scheduler.sendToSession(this, _c1_City_Guide_Service_c2, "_c1_c2_Location_Aware_Quiz_Service_Proxy_reqQuiz", _b003.getQuestions(_b003.loc));
                        scheduler.sendToParent(this,"_c1_City_Guide_Service_loc", _b003.LocationToStr(_b003.tempLoc));
                        return CONSUME_SIGNAL;
                    }
                } else {
                    _b003.processTrue();
                    scheduler.sendToParent(this,"_c1_City_Guide_Service_loc", _b003.LocationToStr(_b003.tempLoc));
                    return CONSUME_SIGNAL;
                }
            } else {
                return CONSUME_SIGNAL;
            }
        } else if(_state == s_0) {
            no.ntnu.item.arctis.library.objects.location.Location _c1_City_Guide_Service_loc = (no.ntnu.item.arctis.library.objects.location.Location) _data;
            _b003.tempLoc = _c1_City_Guide_Service_loc;
            if(_b003.process==true) {
                _b003.toggleProcess();
                _b003.loc = _b003.tempLoc;
                if(_b003.isTreasureAt(_b003.loc)==true) {
                    if(_b003.isFirst==true) {
                        _c1_City_Guide_Service_c2 = scheduler.createFreshSessionID();
                    java.util.Map<String, Object> _c1_City_Guide_Service_c2_data = new java.util.HashMap<String,Object>();
                    scheduler.sendToSession(this, _c1_City_Guide_Service_c2, "_c1_c2_Location_Aware_Quiz_Service_Proxy_start", _c1_City_Guide_Service_c2_data);
                        return CONSUME_SIGNAL;
                    } else {
                                    scheduler.sendToSession(this, _c1_City_Guide_Service_c2, "_c1_c2_Location_Aware_Quiz_Service_Proxy_reqQuiz", _b003.getQuestions(_b003.loc));
                        return CONSUME_SIGNAL;
                    }
                } else {
                    _b003.processTrue();
                    return CONSUME_SIGNAL;
                }
            } else {
                return CONSUME_SIGNAL;
            }
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c1_City_Guide_Service_fwdLoc(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_1) {
            no.ntnu.item.arctis.library.objects.location.Location _b003_fwdLoc = (no.ntnu.item.arctis.library.objects.location.Location) _data;
            _b003.fwdLocUpdate(_b003_fwdLoc);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c1_c2_Location_Aware_Quiz_Service_Proxy_ans(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_0 || _state == s_1) {
            _b003.setIsFirst();
            _b003.processTrue();
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c1_c0_Location_Service_Proxy_nok(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_0 || _state == s_1) {
            _b003.retry();
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c1_City_Guide_Service_stop(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_1) {
            //TERMINATING SESSION VIA finished;
            -- sessionCount;
            return TERMINATE_MACHINE;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c1_c3_Block_Address_Service_Proxy_ok(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_0 || _state == s_1) {
            scheduler.restartTimer(0, "t1", this);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c1_c3_Block_Address_Service_Proxy_str(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_0) {
            java.lang.String _c1_City_Guide_Service_str = (java.lang.String) _data;
            return CONSUME_SIGNAL;
        } else if(_state == s_1) {
            java.lang.String _c1_City_Guide_Service_str = (java.lang.String) _data;
            scheduler.sendToParent(this,"_c1_City_Guide_Service_blockAddr", _b003.block_AddressToString(_c1_City_Guide_Service_str));
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c1_c1_MyAddress_Service_Proxy_str(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_0) {
            java.lang.String _c1_City_Guide_Service_str = (java.lang.String) _data;
            return CONSUME_SIGNAL;
        } else if(_state == s_1) {
            java.lang.String _c1_City_Guide_Service_str = (java.lang.String) _data;
            scheduler.sendToParent(this,"_c1_City_Guide_Service_strAddress", _b003.AddressToString(_c1_City_Guide_Service_str));
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c1_c2_Location_Aware_Quiz_Service_Proxy_ok(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_0 || _state == s_1) {
            scheduler.startTimer(0, "t0", this);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c1_City_Guide_Service_userLoggedIn(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_0) {
                    _data = ((java.util.Map<String, Object>) _data).get("_data");
            java.lang.String _b003_userLoggedIn = (java.lang.String) _data;
            _b003.setCred(_b003_userLoggedIn);
            _b003.treasures = _b003.getTreasures();
            _c1_City_Guide_Service_c0 = scheduler.createFreshSessionID();
                    java.util.Map<String, Object> _c1_City_Guide_Service_c0_data = new java.util.HashMap<String,Object>();
                    scheduler.sendToSession(this, _c1_City_Guide_Service_c0, "_c1_c0_Location_Service_Proxy_start", _c1_City_Guide_Service_c0_data);
            _c1_City_Guide_Service_c1 = scheduler.createFreshSessionID();
                    java.util.Map<String, Object> _c1_City_Guide_Service_c1_data = new java.util.HashMap<String,Object>();
                    scheduler.sendToSession(this, _c1_City_Guide_Service_c1, "_c1_c1_MyAddress_Service_Proxy_start", _c1_City_Guide_Service_c1_data);
            _c1_City_Guide_Service_c3 = scheduler.createFreshSessionID();
                    java.util.Map<String, Object> _c1_City_Guide_Service_c3_data = new java.util.HashMap<String,Object>();
                    scheduler.sendToSession(this, _c1_City_Guide_Service_c3, "_c1_c3_Block_Address_Service_Proxy_start", _c1_City_Guide_Service_c3_data);
            _state = s_1;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public int fireTimer(java.lang.String _timerID){
        if(_timerID.equals("t3")) {
            return handleTimer_t3();
        } else if(_timerID.equals("t2")) {
            return handleTimer_t2();
        } else if(_timerID.equals("t1")) {
            return handleTimer_t1();
        } else if(_timerID.equals("t0")) {
            return handleTimer_t0();
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t3(){
        if(_state == s_1 || _state == s_0) {
            scheduler.sendToSession(this, _c1_City_Guide_Service_c1, "_c1_c1_MyAddress_Service_Proxy_reqAdd", null);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t2(){
        if(_state == s_0 || _state == s_1) {
            scheduler.sendToSession(this, _c1_City_Guide_Service_c0, "_c1_c0_Location_Service_Proxy_reqLoc", null);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t1(){
        if(_state == s_1 || _state == s_0) {
            scheduler.sendToSession(this, _c1_City_Guide_Service_c3, "_c1_c3_Block_Address_Service_Proxy_reqAdd", null);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t0(){
        if(_state == s_0 || _state == s_1) {
                        scheduler.sendToSession(this, _c1_City_Guide_Service_c2, "_c1_c2_Location_Aware_Quiz_Service_Proxy_reqQuiz", _b003.getQuestions(_b003.loc));
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public java.lang.String getPartName(){
        return null;
    }

    public java.lang.String getId(){
        return this._stateMachineID;
    }
}
