package no.item.ntnu.arctis.examples.cityguide.cityguideserver.component;


public class ComponentSM extends no.ntnu.item.arctis.runtime.IStateMachine {


    protected no.ntnu.item.arctis.runtime.Scheduler scheduler;
    protected java.lang.String _stateMachineID;
    private final static int s_1 = 1, s_2 = 2;
    private java.lang.String _c2_Group_Manager_c0;
    private java.lang.String _c2_Group_Manager_c1;
    private java.lang.String _c2_Group_Manager_c3;
    private java.lang.String _c2_Group_Manager_c2;
    private no.item.ntnu.arctis.examples.cityguide.cityguideserver.component.Component _b000;
    private no.ntnu.item.arctis.library.proxies.proxyhost.ProxyHost _b001;
    private no.item.ntnu.arctis.examples.cityguide.webserver.WebServer _b065;
    private no.ntnu.item.arctis.library.proxies.actorrouter.ActorRouter _b002;
    private no.item.ntnu.arctis.examples.cityguide.groupmanager.GroupManager _b024;
    private static java.util.Hashtable _alias = new java.util.Hashtable();
    private static int sessionCount = 0;

    public ComponentSM(no.ntnu.item.arctis.runtime.Scheduler scheduler, java.lang.String sessionID, java.lang.String parentSessionID) {
        super(sessionID, parentSessionID);
        this.scheduler = scheduler;
        ++ sessionCount;
    }


    protected void registerAlias(java.lang.String alias, java.lang.String sessionID){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided alias is null", null);
        if(sessionID==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided sessionID is null", null);
        if(_alias.containsKey(alias)) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("A session with alias " + alias + " already exists.", null);
        _alias.put(alias, sessionID);
    }

    public static java.lang.String findSession(java.lang.String alias){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Try to find session for null alias", null);
        String sessionID = (String) _alias.get(alias);
        if(sessionID==null) {
            if(!_alias.contains(alias)) {
        	       no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map does not contain alias " + alias, null);
            } else {
                no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map has a null entry for alias " + alias, null);
            }
        }
return sessionID;
    }

    public int getSessionCount(){
        return sessionCount;
    }

    public static java.util.Collection allSessions(){
        return _alias.values();
    }

    public int fireInitial(){
        _b024 = new no.item.ntnu.arctis.examples.cityguide.groupmanager.GroupManager();
        _b024.setBlockID("_b024", sessionID);
        _b002 = new no.ntnu.item.arctis.library.proxies.actorrouter.ActorRouter();
        _b002.setBlockID("_b002", sessionID);
        _b065 = new no.item.ntnu.arctis.examples.cityguide.webserver.WebServer();
        _b065.setBlockID("_b065", sessionID);
        _b001 = new no.ntnu.item.arctis.library.proxies.proxyhost.ProxyHost("Client-129.241.205.88-4445-5539");
        _b001.setBlockID("_b001", sessionID);
        _b000 = new no.item.ntnu.arctis.examples.cityguide.cityguideserver.component.Component();
        _b000.setBlockID("_b000", sessionID);
        _b000.setRegistryAddress();
        no.ntnu.item.arctis.library.proxies.Address _b000_o1 = _b000.getLocalAddress();
        _b001.local = _b000_o1;
        _b002.startAfRouter(_b001.getProxyType());
        _b065.startWebServer();
        scheduler.startTimer(1000, "t0", this);
        _state = s_1;
        return CONSUME_SIGNAL;
    }

    public int fire(java.lang.Object _sender, java.lang.Object sessionID, java.lang.String _signalID, java.lang.Object _data){
        if(_signalID.equals("_c2_c3_GroupChat_Service_regOk")) {
            return handleSignal__c2_c3_GroupChat_Service_regOk(_sender, sessionID, _data);
        } else if(_signalID.equals("_c1_City_Guide_Service_strAddress")) {
            return handleSignal__c1_City_Guide_Service_strAddress(_sender, sessionID, _data);
        } else if(_signalID.equals("_c2_c0_Group_Positioning_Service_regOk")) {
            return handleSignal__c2_c0_Group_Positioning_Service_regOk(_sender, sessionID, _data);
        } else if(_signalID.equals("_c2_c1_Login_Service_loginOk")) {
            return handleSignal__c2_c1_Login_Service_loginOk(_sender, sessionID, _data);
        } else if(_signalID.equals("_c2_c1_Login_Service_regOk")) {
            return handleSignal__c2_c1_Login_Service_regOk(_sender, sessionID, _data);
        } else if(_signalID.equals("_c1_City_Guide_Service_blockAddr")) {
            return handleSignal__c1_City_Guide_Service_blockAddr(_sender, sessionID, _data);
        } else if(_signalID.equals("_c2_c2_IM_Service_regOk")) {
            return handleSignal__c2_c2_IM_Service_regOk(_sender, sessionID, _data);
        } else if(_signalID.equals("OUTBOUND__b001")) {
            return handleSignal_OUTBOUND__b001(_sender, sessionID, _data);
        } else if(_signalID.equals("_c1_City_Guide_Service_loc")) {
            return handleSignal__c1_City_Guide_Service_loc(_sender, sessionID, _data);
        } else if(_signalID.equals("AFMSG__b002")) {
            return handleSignal_AFMSG__b002(_sender, sessionID, _data);
        }
        return TRIGGER_UNKNOWN;
    }

    private int handleSignal__c2_c3_GroupChat_Service_regOk(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_2 || _state == s_1) {
            _b024.grpChatRegistered();
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c1_City_Guide_Service_strAddress(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_1) {
            java.lang.String _City_Guide_Server_strAddress = (java.lang.String) _data;
            return CONSUME_SIGNAL;
        } else if(_state == s_2) {
            java.lang.String _City_Guide_Server_strAddress = (java.lang.String) _data;
                        scheduler.sendToSession(this, _c2_Group_Manager_c2, "_c2_c2_IM_Service_userAddrUpdate", _City_Guide_Server_strAddress);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c2_c0_Group_Positioning_Service_regOk(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_1 || _state == s_2) {
            _b024.grpPosRegistered();
            scheduler.startTimer(0, "t1", this);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c2_c1_Login_Service_loginOk(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_1) {
            java.lang.String _c2_Group_Manager_loginOk = (java.lang.String) _data;
            return CONSUME_SIGNAL;
        } else if(_state == s_2) {
            java.lang.String _c2_Group_Manager_loginOk = (java.lang.String) _data;
            String _sessionID = scheduler.createFreshSessionID();
                    java.util.Map<String, Object> signalData = new java.util.HashMap<String,Object>();
                    signalData.put("_data", _c2_Group_Manager_loginOk);
                    scheduler.sendToSession(this, _sessionID, "_c1_City_Guide_Service_userLoggedIn", signalData, no.item.ntnu.arctis.examples.cityguide.cityguideservice.CityGuideService.getAlias(_c2_Group_Manager_loginOk));
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c2_c1_Login_Service_regOk(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_1) {
            _b024.loginRegistered();
            scheduler.restartTimer(0, "t3", this);
            return CONSUME_SIGNAL;
        } else if(_state == s_2) {
            _b024.loginRegistered();
            scheduler.startTimer(0, "t3", this);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c1_City_Guide_Service_blockAddr(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_2) {
            java.lang.String _City_Guide_Server_blockAddr = (java.lang.String) _data;
                        scheduler.sendToSession(this, _c2_Group_Manager_c3, "_c2_c3_GroupChat_Service_userGrpChtBlockID", _City_Guide_Server_blockAddr);
            return CONSUME_SIGNAL;
        } else if(_state == s_1) {
            java.lang.String _City_Guide_Server_blockAddr = (java.lang.String) _data;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c2_c2_IM_Service_regOk(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_1) {
            _b024.imRegistered();
            scheduler.startTimer(0, "t2", this);
            return CONSUME_SIGNAL;
        } else if(_state == s_2) {
            _b024.imRegistered();
            scheduler.restartTimer(0, "t2", this);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_OUTBOUND__b001(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_1 || _state == s_2) {
            no.ntnu.item.arctis.library.proxies.Message _b001_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b001.message = _b001_r0_message;
            if(_b001.isLocal()==true) {
                _b001.receive(_b001.message);
                return CONSUME_SIGNAL;
            } else {
                _b002.send2network(_b001.message);
                return CONSUME_SIGNAL;
            }
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c1_City_Guide_Service_loc(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_2) {
            java.lang.String _City_Guide_Server_loc = (java.lang.String) _data;
                        scheduler.sendToSession(this, _c2_Group_Manager_c0, "_c2_c0_Group_Positioning_Service_grpMemberLocUpdate", _City_Guide_Server_loc);
            return CONSUME_SIGNAL;
        } else if(_state == s_1) {
            java.lang.String _City_Guide_Server_loc = (java.lang.String) _data;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_AFMSG__b002(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_1 || _state == s_2) {
            no.ntnu.item.arctis.library.proxies.Message _b002_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b001.receive(_b002_r0_message);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public int fireTimer(java.lang.String _timerID){
        if(_timerID.equals("t3")) {
            return handleTimer_t3();
        } else if(_timerID.equals("t2")) {
            return handleTimer_t2();
        } else if(_timerID.equals("t1")) {
            return handleTimer_t1();
        } else if(_timerID.equals("t0")) {
            return handleTimer_t0();
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t3(){
        if(_state == s_2 || _state == s_1) {
            _c2_Group_Manager_c0 = scheduler.createFreshSessionID();
                    java.util.Map<String, Object> _c2_Group_Manager_c0_data = new java.util.HashMap<String,Object>();
                    _c2_Group_Manager_c0_data.put("_data", _b024.groups);
                    scheduler.sendToSession(this, _c2_Group_Manager_c0, "_c2_c0_Group_Positioning_Service_register", _c2_Group_Manager_c0_data);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t2(){
        if(_state == s_1 || _state == s_2) {
            _c2_Group_Manager_c3 = scheduler.createFreshSessionID();
                    java.util.Map<String, Object> _c2_Group_Manager_c3_data = new java.util.HashMap<String,Object>();
                    _c2_Group_Manager_c3_data.put("_data", _b024.groups);
                    scheduler.sendToSession(this, _c2_Group_Manager_c3, "_c2_c3_GroupChat_Service_start", _c2_Group_Manager_c3_data);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t1(){
        if(_state == s_2 || _state == s_1) {
            _c2_Group_Manager_c2 = scheduler.createFreshSessionID();
                    java.util.Map<String, Object> _c2_Group_Manager_c2_data = new java.util.HashMap<String,Object>();
                    _c2_Group_Manager_c2_data.put("_data", _b024.groups);
                    scheduler.sendToSession(this, _c2_Group_Manager_c2, "_c2_c2_IM_Service_start", _c2_Group_Manager_c2_data);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t0(){
        if(_state == s_1) {
            _b024.startGM();
            _c2_Group_Manager_c1 = scheduler.createFreshSessionID();
                    java.util.Map<String, Object> _c2_Group_Manager_c1_data = new java.util.HashMap<String,Object>();
                    _c2_Group_Manager_c1_data.put("_data", _b024.users);
                    scheduler.sendToSession(this, _c2_Group_Manager_c1, "_c2_c1_Login_Service_start", _c2_Group_Manager_c1_data);
            _state = s_2;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public java.lang.String getPartName(){
        return null;
    }

    public java.lang.String getId(){
        return this._stateMachineID;
    }
}
