package no.item.ntnu.arctis.examples.cityguide.cityguideserver.component;


public class GroupPositioningServiceSM extends no.ntnu.item.arctis.runtime.IStateMachine {


    protected no.ntnu.item.arctis.runtime.Scheduler scheduler;
    protected java.lang.String _stateMachineID;
    private final static int s_0 = 0, s_3 = 3, s_8 = 8, s_7 = 7, s_4 = 4;
    private no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy _b032;
    private no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy _b029;
    private no.ntnu.item.arctis.library.proxies.serverproxy.ServerProxy _b034;
    private no.item.ntnu.arctis.examples.cityguide.grouppositioningservice.GroupPositioningService _b025;
    private no.ntnu.item.arctis.library.discovery.deregisterservice.DeregisterService _b031;
    private no.ntnu.item.arctis.library.discovery.registerservice.RegisterService _b028;
    private no.ntnu.item.arctis.library.discovery.registerandderegisterservice.RegisterandDeregisterService _b027;
    private no.ntnu.item.arctis.library.discovery.genericservice.GenericService _b026;
    private static java.util.Hashtable _alias = new java.util.Hashtable();
    private static int sessionCount = 0;

    public GroupPositioningServiceSM(no.ntnu.item.arctis.runtime.Scheduler scheduler, java.lang.String sessionID, java.lang.String parentSessionID) {
        super(sessionID, parentSessionID);
        this.scheduler = scheduler;
        ++ sessionCount;
    }


    protected void registerAlias(java.lang.String alias, java.lang.String sessionID){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided alias is null", null);
        if(sessionID==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided sessionID is null", null);
        if(_alias.containsKey(alias)) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("A session with alias " + alias + " already exists.", null);
        _alias.put(alias, sessionID);
    }

    public static java.lang.String findSession(java.lang.String alias){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Try to find session for null alias", null);
        String sessionID = (String) _alias.get(alias);
        if(sessionID==null) {
            if(!_alias.contains(alias)) {
        	       no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map does not contain alias " + alias, null);
            } else {
                no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map has a null entry for alias " + alias, null);
            }
        }
return sessionID;
    }

    public int getSessionCount(){
        return sessionCount;
    }

    public static java.util.Collection allSessions(){
        return _alias.values();
    }

    public int fireInitial(){
        _b026 = new no.ntnu.item.arctis.library.discovery.genericservice.GenericService("grouppositioning");
        _b026.setBlockID("_b026", sessionID);
        _b027 = new no.ntnu.item.arctis.library.discovery.registerandderegisterservice.RegisterandDeregisterService();
        _b027.setBlockID("_b027", sessionID);
        _b028 = new no.ntnu.item.arctis.library.discovery.registerservice.RegisterService();
        _b028.setBlockID("_b028", sessionID);
        _b031 = new no.ntnu.item.arctis.library.discovery.deregisterservice.DeregisterService();
        _b031.setBlockID("_b031", sessionID);
        _b025 = new no.item.ntnu.arctis.examples.cityguide.grouppositioningservice.GroupPositioningService();
        _b025.setBlockID("_b025", sessionID);
        _b034 = new no.ntnu.item.arctis.library.proxies.serverproxy.ServerProxy();
        _b034.setBlockID("_b034", sessionID);
        _b029 = new no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy("", "");
        _b029.setBlockID("_b029", sessionID);
        _b032 = new no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy("", "");
        _b032.setBlockID("_b032", sessionID);
        _state = s_0;
        return CONSUME_SIGNAL;
    }

    public int fire(java.lang.Object _sender, java.lang.Object sessionID, java.lang.String _signalID, java.lang.Object _data){
        if(_signalID.equals("_c2_c0_Group_Positioning_Service_grpMemberLocUpdate")) {
            return handleSignal__c2_c0_Group_Positioning_Service_grpMemberLocUpdate(_sender, sessionID, _data);
        } else if(_signalID.equals("RECEIVE__b029")) {
            return handleSignal_RECEIVE__b029(_sender, sessionID, _data);
        } else if(_signalID.equals("_c2_c0_Group_Positioning_Service_register")) {
            return handleSignal__c2_c0_Group_Positioning_Service_register(_sender, sessionID, _data);
        } else if(_signalID.equals("RECEIVE__b034")) {
            return handleSignal_RECEIVE__b034(_sender, sessionID, _data);
        } else if(_signalID.equals("_c2_c0_Group_Positioning_Service_stop")) {
            return handleSignal__c2_c0_Group_Positioning_Service_stop(_sender, sessionID, _data);
        }
        return TRIGGER_UNKNOWN;
    }

    private int handleSignal__c2_c0_Group_Positioning_Service_grpMemberLocUpdate(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_3 || _state == s_8 || _state == s_4 || _state == s_7) {
            java.lang.String _b025_grpMemberLocUpdate = (java.lang.String) _data;
            _b025.updateGroupMemberLocation(_b025_grpMemberLocUpdate);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_RECEIVE__b029(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_3) {
            no.ntnu.item.arctis.library.proxies.Message _b029_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            java.lang.String _b028_o2 = _b028.getSignalID(_b029_r0_message);
            if(_b028_o2.equals("ok")) {
                _b029.unsubscribe();
                scheduler.sendToParent(this,"_c2_c0_Group_Positioning_Service_regOk", null);
                _b034.proxySessionID = _b026.serviceSessionID;
                _b034.subscribe();
                _state = s_7;
                return CONSUME_SIGNAL;
            } else if(_b028_o2.equals("failed")) {
                _b029.unsubscribe();
                _state = s_8;
                return CONSUME_SIGNAL;
            } else {
                _b028.unexpectedSignal(_b028_o2);
                return CONSUME_SIGNAL;
            }
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c2_c0_Group_Positioning_Service_register(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_0) {
                    _data = ((java.util.Map<String, Object>) _data).get("_data");
            java.util.Vector<no.ntnu.item.arctis.library.objects.user.Group> _b025_register = (java.util.Vector<no.ntnu.item.arctis.library.objects.user.Group>) _data;
            _b025.grps = _b025_register;
            _b026.createServiceSessionID();
            _b027.registerEntry = _b026.createRegisterEntry();
            _b028.registerEntry = _b027.registerEntry;
            _b029.remote = _b028.getRegisterAddress();
            _b029.subscribe();
            scheduler.startTimer(0, "t0", this);
            _state = s_3;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_RECEIVE__b034(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_7) {
            no.ntnu.item.arctis.library.proxies.Message _b034_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b025.message = _b034_r0_message;
            _b034.send(_b025.createMessage(_b025.getGroupMemberLocations(_b025.message)));
            _state = s_4;
            return CONSUME_SIGNAL;
        } else if(_state == s_4) {
            no.ntnu.item.arctis.library.proxies.Message _b034_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b025.message = _b034_r0_message;
            _b034.send(_b025.createMessage(_b025.getGroupMemberLocations(_b025.message)));
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c2_c0_Group_Positioning_Service_stop(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_8 || _state == s_7 || _state == s_4 || _state == s_3) {
            //TERMINATING SESSION VIA regFailed;
            -- sessionCount;
            return TERMINATE_MACHINE;
        }
        return DISCARD_SIGNAL;
    }

    public int fireTimer(java.lang.String _timerID){
        if(_timerID.equals("t1")) {
            return handleTimer_t1();
        } else if(_timerID.equals("t0")) {
            return handleTimer_t0();
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t1(){
        if(_state == s_3) {
            _b029.unsubscribe();
            _state = s_8;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t0(){
        if(_state == s_3) {
            _b029.send(_b028.createRegisterMessage());
            scheduler.startTimer(10000, "t1", this);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public java.lang.String getPartName(){
        return null;
    }

    public java.lang.String getId(){
        return this._stateMachineID;
    }
}
