package no.item.ntnu.arctis.examples.cityguide.cityguideserver.component;


public class IMServiceSM extends no.ntnu.item.arctis.runtime.IStateMachine {


    protected no.ntnu.item.arctis.runtime.Scheduler scheduler;
    protected java.lang.String _stateMachineID;
    private final static int s_0 = 0, s_4 = 4, s_1 = 1, s_8 = 8, s_6 = 6, s_10 = 10;
    private no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy _b052;
    private no.ntnu.item.arctis.library.discovery.registerandderegisterservice.RegisterandDeregisterService _b047;
    private no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy _b049;
    private no.ntnu.item.arctis.library.proxies.serverproxy.ServerProxy _b054;
    private no.item.ntnu.arctis.examples.cityguide.imservice.IMService _b045;
    private no.ntnu.item.arctis.library.discovery.deregisterservice.DeregisterService _b051;
    private no.ntnu.item.arctis.library.discovery.genericservice.GenericService _b046;
    private no.ntnu.item.arctis.library.discovery.registerservice.RegisterService _b048;
    private static java.util.Hashtable _alias = new java.util.Hashtable();
    private static int sessionCount = 0;

    public IMServiceSM(no.ntnu.item.arctis.runtime.Scheduler scheduler, java.lang.String sessionID, java.lang.String parentSessionID) {
        super(sessionID, parentSessionID);
        this.scheduler = scheduler;
        ++ sessionCount;
    }


    protected void registerAlias(java.lang.String alias, java.lang.String sessionID){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided alias is null", null);
        if(sessionID==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided sessionID is null", null);
        if(_alias.containsKey(alias)) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("A session with alias " + alias + " already exists.", null);
        _alias.put(alias, sessionID);
    }

    public static java.lang.String findSession(java.lang.String alias){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Try to find session for null alias", null);
        String sessionID = (String) _alias.get(alias);
        if(sessionID==null) {
            if(!_alias.contains(alias)) {
        	       no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map does not contain alias " + alias, null);
            } else {
                no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map has a null entry for alias " + alias, null);
            }
        }
return sessionID;
    }

    public int getSessionCount(){
        return sessionCount;
    }

    public static java.util.Collection allSessions(){
        return _alias.values();
    }

    public int fireInitial(){
        _b048 = new no.ntnu.item.arctis.library.discovery.registerservice.RegisterService();
        _b048.setBlockID("_b048", sessionID);
        _b046 = new no.ntnu.item.arctis.library.discovery.genericservice.GenericService("InstantMessaging");
        _b046.setBlockID("_b046", sessionID);
        _b051 = new no.ntnu.item.arctis.library.discovery.deregisterservice.DeregisterService();
        _b051.setBlockID("_b051", sessionID);
        _b045 = new no.item.ntnu.arctis.examples.cityguide.imservice.IMService();
        _b045.setBlockID("_b045", sessionID);
        _b054 = new no.ntnu.item.arctis.library.proxies.serverproxy.ServerProxy();
        _b054.setBlockID("_b054", sessionID);
        _b049 = new no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy("", "");
        _b049.setBlockID("_b049", sessionID);
        _b047 = new no.ntnu.item.arctis.library.discovery.registerandderegisterservice.RegisterandDeregisterService();
        _b047.setBlockID("_b047", sessionID);
        _b052 = new no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy("", "");
        _b052.setBlockID("_b052", sessionID);
        _state = s_0;
        return CONSUME_SIGNAL;
    }

    public int fire(java.lang.Object _sender, java.lang.Object sessionID, java.lang.String _signalID, java.lang.Object _data){
        if(_signalID.equals("RECEIVE__b054")) {
            return handleSignal_RECEIVE__b054(_sender, sessionID, _data);
        } else if(_signalID.equals("_c2_c2_IM_Service_start")) {
            return handleSignal__c2_c2_IM_Service_start(_sender, sessionID, _data);
        } else if(_signalID.equals("_c2_c2_IM_Service_stop")) {
            return handleSignal__c2_c2_IM_Service_stop(_sender, sessionID, _data);
        } else if(_signalID.equals("SEND__b045")) {
            return handleSignal_SEND__b045(_sender, sessionID, _data);
        } else if(_signalID.equals("_c2_c2_IM_Service_userAddrUpdate")) {
            return handleSignal__c2_c2_IM_Service_userAddrUpdate(_sender, sessionID, _data);
        } else if(_signalID.equals("RECEIVE__b049")) {
            return handleSignal_RECEIVE__b049(_sender, sessionID, _data);
        }
        return TRIGGER_UNKNOWN;
    }

    private int handleSignal_RECEIVE__b054(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_1) {
            no.ntnu.item.arctis.library.proxies.Message _b054_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b045.message = _b054_r0_message;
            _b045.extractMessage(_b045.message);
            _state = s_8;
            return CONSUME_SIGNAL;
        } else if(_state == s_10) {
            no.ntnu.item.arctis.library.proxies.Message _b054_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b045.message = _b054_r0_message;
            _b045.extractMessage(_b045.message);
            _state = s_8;
            return CONSUME_SIGNAL;
        } else if(_state == s_8) {
            no.ntnu.item.arctis.library.proxies.Message _b054_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b045.message = _b054_r0_message;
            _b045.extractMessage(_b045.message);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c2_c2_IM_Service_start(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_0) {
                    _data = ((java.util.Map<String, Object>) _data).get("_data");
            java.util.Vector<no.ntnu.item.arctis.library.objects.user.Group> _b045_start = (java.util.Vector<no.ntnu.item.arctis.library.objects.user.Group>) _data;
            _b045.grps = _b045_start;
            _b046.createServiceSessionID();
            _b047.registerEntry = _b046.createRegisterEntry();
            _b048.registerEntry = _b047.registerEntry;
            _b049.remote = _b048.getRegisterAddress();
            _b049.subscribe();
            scheduler.startTimer(0, "t0", this);
            _state = s_4;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c2_c2_IM_Service_stop(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_4 || _state == s_6 || _state == s_1 || _state == s_8 || _state == s_10) {
            //TERMINATING SESSION VIA regFailed;
            -- sessionCount;
            return TERMINATE_MACHINE;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_SEND__b045(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_8) {
            no.ntnu.item.arctis.library.proxies.Message _b045_r0_msg = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b054.send(_b045_r0_msg);
            _state = s_10;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c2_c2_IM_Service_userAddrUpdate(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_4 || _state == s_1 || _state == s_6 || _state == s_8 || _state == s_10) {
            java.lang.String _b045_userAddrUpdate = (java.lang.String) _data;
            _b045.updateAdd(_b045_userAddrUpdate);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_RECEIVE__b049(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_4) {
            no.ntnu.item.arctis.library.proxies.Message _b049_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            java.lang.String _b048_o2 = _b048.getSignalID(_b049_r0_message);
            if(_b048_o2.equals("failed")) {
                _b049.unsubscribe();
                _state = s_6;
                return CONSUME_SIGNAL;
            } else if(_b048_o2.equals("ok")) {
                _b049.unsubscribe();
                scheduler.sendToParent(this,"_c2_c2_IM_Service_regOk", null);
                _b054.proxySessionID = _b046.serviceSessionID;
                _b054.subscribe();
                _state = s_1;
                return CONSUME_SIGNAL;
            } else {
                _b048.unexpectedSignal(_b048_o2);
                return CONSUME_SIGNAL;
            }
        }
        return DISCARD_SIGNAL;
    }

    public int fireTimer(java.lang.String _timerID){
        if(_timerID.equals("t1")) {
            return handleTimer_t1();
        } else if(_timerID.equals("t0")) {
            return handleTimer_t0();
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t1(){
        if(_state == s_4) {
            _b049.unsubscribe();
            _state = s_6;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t0(){
        if(_state == s_4) {
            _b049.send(_b048.createRegisterMessage());
            scheduler.startTimer(10000, "t1", this);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public java.lang.String getPartName(){
        return null;
    }

    public java.lang.String getId(){
        return this._stateMachineID;
    }
}
