package no.item.ntnu.arctis.examples.cityguide.cityguideserver.component;


public class LocationAwareQuizServiceProxySM extends no.ntnu.item.arctis.runtime.IStateMachine {


    protected no.ntnu.item.arctis.runtime.Scheduler scheduler;
    protected java.lang.String _stateMachineID;
    private final static int s_0 = 0, s_3 = 3, s_1 = 1;
    private no.ntnu.item.arctis.library.discovery.discoverservice.DiscoverService _b010;
    private no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy _b013;
    private no.item.ntnu.arctis.examples.cityguide.locationawarequizserviceproxy.LocationAwareQuizServiceProxy _b009;
    private no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy _b011;
    private static java.util.Hashtable _alias = new java.util.Hashtable();
    private static int sessionCount = 0;

    public LocationAwareQuizServiceProxySM(no.ntnu.item.arctis.runtime.Scheduler scheduler, java.lang.String sessionID, java.lang.String parentSessionID) {
        super(sessionID, parentSessionID);
        this.scheduler = scheduler;
        ++ sessionCount;
    }


    protected void registerAlias(java.lang.String alias, java.lang.String sessionID){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided alias is null", null);
        if(sessionID==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided sessionID is null", null);
        if(_alias.containsKey(alias)) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("A session with alias " + alias + " already exists.", null);
        _alias.put(alias, sessionID);
    }

    public static java.lang.String findSession(java.lang.String alias){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Try to find session for null alias", null);
        String sessionID = (String) _alias.get(alias);
        if(sessionID==null) {
            if(!_alias.contains(alias)) {
        	       no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map does not contain alias " + alias, null);
            } else {
                no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map has a null entry for alias " + alias, null);
            }
        }
return sessionID;
    }

    public int getSessionCount(){
        return sessionCount;
    }

    public static java.util.Collection allSessions(){
        return _alias.values();
    }

    public int fireInitial(){
        _b011 = new no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy("", "");
        _b011.setBlockID("_b011", sessionID);
        _b009 = new no.item.ntnu.arctis.examples.cityguide.locationawarequizserviceproxy.LocationAwareQuizServiceProxy();
        _b009.setBlockID("_b009", sessionID);
        _b013 = new no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy("", "");
        _b013.setBlockID("_b013", sessionID);
        _b010 = new no.ntnu.item.arctis.library.discovery.discoverservice.DiscoverService("quiz");
        _b010.setBlockID("_b010", sessionID);
        _state = s_0;
        return CONSUME_SIGNAL;
    }

    public int fire(java.lang.Object _sender, java.lang.Object sessionID, java.lang.String _signalID, java.lang.Object _data){
        if(_signalID.equals("_c1_c2_Location_Aware_Quiz_Service_Proxy_reqQuiz")) {
            return handleSignal__c1_c2_Location_Aware_Quiz_Service_Proxy_reqQuiz(_sender, sessionID, _data);
        } else if(_signalID.equals("RECEIVE__b011")) {
            return handleSignal_RECEIVE__b011(_sender, sessionID, _data);
        } else if(_signalID.equals("_c1_c2_Location_Aware_Quiz_Service_Proxy_start")) {
            return handleSignal__c1_c2_Location_Aware_Quiz_Service_Proxy_start(_sender, sessionID, _data);
        } else if(_signalID.equals("RECEIVE__b013")) {
            return handleSignal_RECEIVE__b013(_sender, sessionID, _data);
        }
        return TRIGGER_UNKNOWN;
    }

    private int handleSignal__c1_c2_Location_Aware_Quiz_Service_Proxy_reqQuiz(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_1) {
            no.ntnu.item.arctis.library.objects.quiz.Question _b009_reqQuiz = (no.ntnu.item.arctis.library.objects.quiz.Question) _data;
            _b013.send(_b009.createPinMessage(_b009_reqQuiz));
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_RECEIVE__b011(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_3) {
            no.ntnu.item.arctis.library.proxies.Message _b011_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b010.message = _b011_r0_message;
            java.lang.String _b010_o2 = _b010.getSignalID(_b010.message);
            if(_b010_o2.equals("ok")) {
                _b011.unsubscribe();
                no.ntnu.item.arctis.library.proxies.Address _b010_o3 = _b010.extractAddress(_b010.message);
                _b013.remote = _b010_o3;
                _b013.subscribe();
                _b009.found(_b010_o3);
                scheduler.sendToParent(this,"_c1_c2_Location_Aware_Quiz_Service_Proxy_ok", null);
                _state = s_1;
                return CONSUME_SIGNAL;
            } else {
                _b011.unsubscribe();
                _b009.notfound();
                //TERMINATING SESSION VIA failed;
                -- sessionCount;
                return TERMINATE_MACHINE;
            }
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c1_c2_Location_Aware_Quiz_Service_Proxy_start(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_0) {
                    _data = ((java.util.Map<String, Object>) _data).get("_data");
            _b011.remote = _b010.getRegisterAddress();
            _b011.subscribe();
            scheduler.startTimer(0, "t0", this);
            _state = s_3;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_RECEIVE__b013(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_1) {
            no.ntnu.item.arctis.library.proxies.Message _b013_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b009.extractMessage(_b013_r0_message);
            scheduler.sendToParent(this,"_c1_c2_Location_Aware_Quiz_Service_Proxy_ans", null);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public int fireTimer(java.lang.String _timerID){
        if(_timerID.equals("t1")) {
            return handleTimer_t1();
        } else if(_timerID.equals("t0")) {
            return handleTimer_t0();
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t1(){
        if(_state == s_3) {
            _b010.logTimeout();
            _b011.unsubscribe();
            _b009.notfound();
            //TERMINATING SESSION VIA failed;
            -- sessionCount;
            return TERMINATE_MACHINE;
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t0(){
        if(_state == s_3) {
            _b011.send(_b010.createDiscoverMessage());
            scheduler.startTimer(10000, "t1", this);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public java.lang.String getPartName(){
        return null;
    }

    public java.lang.String getId(){
        return this._stateMachineID;
    }
}
