package no.item.ntnu.arctis.examples.cityguide.cityguideserver.component;


public class LoginServiceSM extends no.ntnu.item.arctis.runtime.IStateMachine {


    protected no.ntnu.item.arctis.runtime.Scheduler scheduler;
    protected java.lang.String _stateMachineID;
    private final static int s_0 = 0, s_1 = 1, s_7 = 7, s_4 = 4, s_3 = 3;
    private no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy _b039;
    private no.ntnu.item.arctis.library.discovery.registerservice.RegisterService _b038;
    private no.ntnu.item.arctis.library.discovery.registerandderegisterservice.RegisterandDeregisterService _b037;
    private no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy _b042;
    private no.ntnu.item.arctis.library.proxies.serverproxy.ServerProxy _b044;
    private no.item.ntnu.arctis.examples.cityguide.loginservice.LoginService _b035;
    private no.ntnu.item.arctis.library.discovery.genericservice.GenericService _b036;
    private no.ntnu.item.arctis.library.discovery.deregisterservice.DeregisterService _b041;
    private static java.util.Hashtable _alias = new java.util.Hashtable();
    private static int sessionCount = 0;

    public LoginServiceSM(no.ntnu.item.arctis.runtime.Scheduler scheduler, java.lang.String sessionID, java.lang.String parentSessionID) {
        super(sessionID, parentSessionID);
        this.scheduler = scheduler;
        ++ sessionCount;
    }


    protected void registerAlias(java.lang.String alias, java.lang.String sessionID){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided alias is null", null);
        if(sessionID==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided sessionID is null", null);
        if(_alias.containsKey(alias)) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("A session with alias " + alias + " already exists.", null);
        _alias.put(alias, sessionID);
    }

    public static java.lang.String findSession(java.lang.String alias){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Try to find session for null alias", null);
        String sessionID = (String) _alias.get(alias);
        if(sessionID==null) {
            if(!_alias.contains(alias)) {
        	       no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map does not contain alias " + alias, null);
            } else {
                no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map has a null entry for alias " + alias, null);
            }
        }
return sessionID;
    }

    public int getSessionCount(){
        return sessionCount;
    }

    public static java.util.Collection allSessions(){
        return _alias.values();
    }

    public int fireInitial(){
        _b041 = new no.ntnu.item.arctis.library.discovery.deregisterservice.DeregisterService();
        _b041.setBlockID("_b041", sessionID);
        _b036 = new no.ntnu.item.arctis.library.discovery.genericservice.GenericService("login");
        _b036.setBlockID("_b036", sessionID);
        _b035 = new no.item.ntnu.arctis.examples.cityguide.loginservice.LoginService();
        _b035.setBlockID("_b035", sessionID);
        _b044 = new no.ntnu.item.arctis.library.proxies.serverproxy.ServerProxy();
        _b044.setBlockID("_b044", sessionID);
        _b042 = new no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy("", "");
        _b042.setBlockID("_b042", sessionID);
        _b037 = new no.ntnu.item.arctis.library.discovery.registerandderegisterservice.RegisterandDeregisterService();
        _b037.setBlockID("_b037", sessionID);
        _b038 = new no.ntnu.item.arctis.library.discovery.registerservice.RegisterService();
        _b038.setBlockID("_b038", sessionID);
        _b039 = new no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy("", "");
        _b039.setBlockID("_b039", sessionID);
        _state = s_0;
        return CONSUME_SIGNAL;
    }

    public int fire(java.lang.Object _sender, java.lang.Object sessionID, java.lang.String _signalID, java.lang.Object _data){
        if(_signalID.equals("_c2_c1_Login_Service_stop")) {
            return handleSignal__c2_c1_Login_Service_stop(_sender, sessionID, _data);
        } else if(_signalID.equals("_c2_c1_Login_Service_start")) {
            return handleSignal__c2_c1_Login_Service_start(_sender, sessionID, _data);
        } else if(_signalID.equals("RECEIVE__b044")) {
            return handleSignal_RECEIVE__b044(_sender, sessionID, _data);
        } else if(_signalID.equals("RECEIVE__b039")) {
            return handleSignal_RECEIVE__b039(_sender, sessionID, _data);
        }
        return TRIGGER_UNKNOWN;
    }

    private int handleSignal__c2_c1_Login_Service_stop(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_1 || _state == s_7 || _state == s_4 || _state == s_3) {
            //TERMINATING SESSION VIA regFailed;
            -- sessionCount;
            return TERMINATE_MACHINE;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c2_c1_Login_Service_start(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_0) {
                    _data = ((java.util.Map<String, Object>) _data).get("_data");
            java.util.Vector<no.ntnu.item.arctis.library.objects.user.Player> _b035_start = (java.util.Vector<no.ntnu.item.arctis.library.objects.user.Player>) _data;
            _b035.users = _b035_start;
            _b036.createServiceSessionID();
            _b037.registerEntry = _b036.createRegisterEntry();
            _b038.registerEntry = _b037.registerEntry;
            _b039.remote = _b038.getRegisterAddress();
            _b039.subscribe();
            scheduler.startTimer(0, "t0", this);
            _state = s_1;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_RECEIVE__b044(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_3) {
            no.ntnu.item.arctis.library.proxies.Message _b044_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b035.message = _b044_r0_message;
            no.ntnu.item.arctis.library.proxies.Message _b035_o0 = _b035.extractMessage(_b035.message);
            _b044.send(_b035_o0);
            if(_b035.check(_b035_o0)==true) {
                java.lang.String _b035_o2 = _b035.getCred();
                scheduler.sendToParent(this,"_c2_c1_Login_Service_loginOk", _b035_o2);
                return CONSUME_SIGNAL;
            } else {
                _b035.loginFailed();
                return CONSUME_SIGNAL;
            }
        } else if(_state == s_4) {
            no.ntnu.item.arctis.library.proxies.Message _b044_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b035.message = _b044_r0_message;
            no.ntnu.item.arctis.library.proxies.Message _b035_o0 = _b035.extractMessage(_b035.message);
            _b044.send(_b035_o0);
            if(_b035.check(_b035_o0)==true) {
                java.lang.String _b035_o2 = _b035.getCred();
                scheduler.sendToParent(this,"_c2_c1_Login_Service_loginOk", _b035_o2);
                _state = s_3;
                return CONSUME_SIGNAL;
            } else {
                _b035.loginFailed();
                _state = s_3;
                return CONSUME_SIGNAL;
            }
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_RECEIVE__b039(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_1) {
            no.ntnu.item.arctis.library.proxies.Message _b039_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            java.lang.String _b038_o2 = _b038.getSignalID(_b039_r0_message);
            if(_b038_o2.equals("ok")) {
                _b039.unsubscribe();
                scheduler.sendToParent(this,"_c2_c1_Login_Service_regOk", null);
                _b044.proxySessionID = _b036.serviceSessionID;
                _b044.subscribe();
                _state = s_4;
                return CONSUME_SIGNAL;
            } else if(_b038_o2.equals("failed")) {
                _b039.unsubscribe();
                _state = s_7;
                return CONSUME_SIGNAL;
            } else {
                _b038.unexpectedSignal(_b038_o2);
                return CONSUME_SIGNAL;
            }
        }
        return DISCARD_SIGNAL;
    }

    public int fireTimer(java.lang.String _timerID){
        if(_timerID.equals("t1")) {
            return handleTimer_t1();
        } else if(_timerID.equals("t0")) {
            return handleTimer_t0();
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t1(){
        if(_state == s_1) {
            _b039.unsubscribe();
            _state = s_7;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t0(){
        if(_state == s_1) {
            _b039.send(_b038.createRegisterMessage());
            scheduler.startTimer(10000, "t1", this);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public java.lang.String getPartName(){
        return null;
    }

    public java.lang.String getId(){
        return this._stateMachineID;
    }
}
