package no.item.ntnu.arctis.examples.cityguide.cityguideserver.component;


public class MyAddressServiceProxySM extends no.ntnu.item.arctis.runtime.IStateMachine {


    protected no.ntnu.item.arctis.runtime.Scheduler scheduler;
    protected java.lang.String _stateMachineID;
    private final static int s_0 = 0, s_3 = 3, s_2 = 2;
    private no.item.ntnu.arctis.examples.cityguide.myaddressserviceproxy.MyAddressServiceProxy _b014;
    private no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy _b018;
    private no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy _b016;
    private no.ntnu.item.arctis.library.discovery.discoverservice.DiscoverService _b015;
    private static java.util.Hashtable _alias = new java.util.Hashtable();
    private static int sessionCount = 0;

    public MyAddressServiceProxySM(no.ntnu.item.arctis.runtime.Scheduler scheduler, java.lang.String sessionID, java.lang.String parentSessionID) {
        super(sessionID, parentSessionID);
        this.scheduler = scheduler;
        ++ sessionCount;
    }


    protected void registerAlias(java.lang.String alias, java.lang.String sessionID){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided alias is null", null);
        if(sessionID==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided sessionID is null", null);
        if(_alias.containsKey(alias)) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("A session with alias " + alias + " already exists.", null);
        _alias.put(alias, sessionID);
    }

    public static java.lang.String findSession(java.lang.String alias){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Try to find session for null alias", null);
        String sessionID = (String) _alias.get(alias);
        if(sessionID==null) {
            if(!_alias.contains(alias)) {
        	       no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map does not contain alias " + alias, null);
            } else {
                no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map has a null entry for alias " + alias, null);
            }
        }
return sessionID;
    }

    public int getSessionCount(){
        return sessionCount;
    }

    public static java.util.Collection allSessions(){
        return _alias.values();
    }

    public int fireInitial(){
        _b015 = new no.ntnu.item.arctis.library.discovery.discoverservice.DiscoverService("MyAddress");
        _b015.setBlockID("_b015", sessionID);
        _b016 = new no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy("", "");
        _b016.setBlockID("_b016", sessionID);
        _b018 = new no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy("", "");
        _b018.setBlockID("_b018", sessionID);
        _b014 = new no.item.ntnu.arctis.examples.cityguide.myaddressserviceproxy.MyAddressServiceProxy();
        _b014.setBlockID("_b014", sessionID);
        _state = s_0;
        return CONSUME_SIGNAL;
    }

    public int fire(java.lang.Object _sender, java.lang.Object sessionID, java.lang.String _signalID, java.lang.Object _data){
        if(_signalID.equals("RECEIVE__b018")) {
            return handleSignal_RECEIVE__b018(_sender, sessionID, _data);
        } else if(_signalID.equals("_c1_c1_MyAddress_Service_Proxy_reqAdd")) {
            return handleSignal__c1_c1_MyAddress_Service_Proxy_reqAdd(_sender, sessionID, _data);
        } else if(_signalID.equals("RECEIVE__b016")) {
            return handleSignal_RECEIVE__b016(_sender, sessionID, _data);
        } else if(_signalID.equals("_c1_c1_MyAddress_Service_Proxy_start")) {
            return handleSignal__c1_c1_MyAddress_Service_Proxy_start(_sender, sessionID, _data);
        }
        return TRIGGER_UNKNOWN;
    }

    private int handleSignal_RECEIVE__b018(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_2) {
            no.ntnu.item.arctis.library.proxies.Message _b018_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            scheduler.sendToParent(this,"_c1_c1_MyAddress_Service_Proxy_str", _b014.extractMessage(_b018_r0_message));
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c1_c1_MyAddress_Service_Proxy_reqAdd(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_2) {
            _b018.send(_b014.createPinMessage());
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_RECEIVE__b016(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_3) {
            no.ntnu.item.arctis.library.proxies.Message _b016_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b015.message = _b016_r0_message;
            java.lang.String _b015_o2 = _b015.getSignalID(_b015.message);
            if(_b015_o2.equals("ok")) {
                _b016.unsubscribe();
                no.ntnu.item.arctis.library.proxies.Address _b015_o3 = _b015.extractAddress(_b015.message);
                _b018.remote = _b015_o3;
                _b018.subscribe();
                _b014.found(_b015_o3);
                scheduler.sendToParent(this,"_c1_c1_MyAddress_Service_Proxy_ok", null);
                _state = s_2;
                return CONSUME_SIGNAL;
            } else {
                _b016.unsubscribe();
                _b014.notfound();
                return TERMINATE_MACHINE;
            }
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c1_c1_MyAddress_Service_Proxy_start(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_0) {
                    _data = ((java.util.Map<String, Object>) _data).get("_data");
            _b014.startDiscover();
            _b016.remote = _b015.getRegisterAddress();
            _b016.subscribe();
            scheduler.startTimer(0, "t0", this);
            _state = s_3;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public int fireTimer(java.lang.String _timerID){
        if(_timerID.equals("t1")) {
            return handleTimer_t1();
        } else if(_timerID.equals("t0")) {
            return handleTimer_t0();
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t1(){
        if(_state == s_3) {
            _b015.logTimeout();
            _b016.unsubscribe();
            _b014.notfound();
            return TERMINATE_MACHINE;
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t0(){
        if(_state == s_3) {
            _b016.send(_b015.createDiscoverMessage());
            scheduler.startTimer(10000, "t1", this);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public java.lang.String getPartName(){
        return null;
    }

    public java.lang.String getId(){
        return this._stateMachineID;
    }
}
