package no.item.ntnu.arctis.examples.cityguide.loginservice;

import java.util.Iterator;

import com.thoughtworks.xstream.XStream;

import no.ntnu.item.arctis.library.objects.login.Credentials;
import no.ntnu.item.arctis.library.objects.user.Player;
import no.ntnu.item.arctis.library.proxies.Message;
import no.ntnu.item.arctis.runtime.Block;

public class LoginService extends Block {

	public no.ntnu.item.arctis.library.proxies.Message request;
	public no.ntnu.item.arctis.library.proxies.Message message;
	public java.util.Vector<no.ntnu.item.arctis.library.objects.user.Player> users;

	public Message extractMessage(Message message) {
	
			System.out.println("received message at ACS..."+ message);			
			System.out.println("message sender/receiver: "+ message.getSender() + message.getReceiver());
		
			String pincode = (String) message.getPayload();
			
			String username = pincode.split("#")[0];
			String pass = pincode.split("#")[1];
					
			boolean result = false;
			
			for (Iterator<Player> iterator = users.iterator(); iterator.hasNext();) {
				Player type = (Player) iterator.next();
				if(type.getUserName().equalsIgnoreCase(username) && type.getPassword().equalsIgnoreCase(pass))
				{
					System.out.println("Valid user logging in..");
					result = true;
					continue;
				}
			}
			
			if(!result){
				System.out.println("Invalid user logging in..");
			}
			
			//boolean result = Integer.valueOf(pincode)==1234;		
			Message response = new Message("login"); 
			response.setReceiver(message.getSender().getCopy());
			response.setSender(message.getReceiver().getCopy());	
			response.setPayload(result);
			return response;
	}

	public boolean check(Message message) {
		boolean result = (Boolean) message.getPayload();		
		return result;
	}

	public String getCred() {
			String pincode = (String) this.message.getPayload();
			System.out.println("pincode.split(#)[0] at getCred "+ pincode.split("#")[0]);
			return pincode.split("#")[0];
	}

	public void loginFailed() {
		System.out.println("Login Failed...");
	}

}