package no.item.ntnu.arctis.examples.cityguide.registrysystem.component;


public class ComponentSM extends no.ntnu.item.arctis.runtime.IStateMachine {


    protected no.ntnu.item.arctis.runtime.Scheduler scheduler;
    protected java.lang.String _stateMachineID;
    private final static int s_1 = 1, s_2 = 2, s_3 = 3;
    private no.ntnu.item.arctis.library.proxies.serverproxy.ServerProxy _b002;
    private no.ntnu.item.arctis.library.proxies.actorrouter.ActorRouter _b004;
    private no.ntnu.item.arctis.library.discovery.serviceregistry.ServiceRegistry _b001;
    private no.ntnu.item.arctis.library.proxies.proxyhost.ProxyHost _b003;
    private no.item.ntnu.arctis.examples.cityguide.registrysystem.component.Component _b000;
    private static java.util.Hashtable _alias = new java.util.Hashtable();
    private static int sessionCount = 0;

    public ComponentSM(no.ntnu.item.arctis.runtime.Scheduler scheduler, java.lang.String sessionID, java.lang.String parentSessionID) {
        super(sessionID, parentSessionID);
        this.scheduler = scheduler;
        ++ sessionCount;
    }


    protected void registerAlias(java.lang.String alias, java.lang.String sessionID){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided alias is null", null);
        if(sessionID==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided sessionID is null", null);
        if(_alias.containsKey(alias)) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("A session with alias " + alias + " already exists.", null);
        _alias.put(alias, sessionID);
    }

    public static java.lang.String findSession(java.lang.String alias){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Try to find session for null alias", null);
        String sessionID = (String) _alias.get(alias);
        if(sessionID==null) {
            if(!_alias.contains(alias)) {
        	       no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map does not contain alias " + alias, null);
            } else {
                no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map has a null entry for alias " + alias, null);
            }
        }
return sessionID;
    }

    public int getSessionCount(){
        return sessionCount;
    }

    public static java.util.Collection allSessions(){
        return _alias.values();
    }

    public int fireInitial(){
        _b000 = new no.item.ntnu.arctis.examples.cityguide.registrysystem.component.Component();
        _b000.setBlockID("_b000", sessionID);
        _b003 = new no.ntnu.item.arctis.library.proxies.proxyhost.ProxyHost("Server-129.241.205.88-4445");
        _b003.setBlockID("_b003", sessionID);
        _b001 = new no.ntnu.item.arctis.library.discovery.serviceregistry.ServiceRegistry();
        _b001.setBlockID("_b001", sessionID);
        _b004 = new no.ntnu.item.arctis.library.proxies.actorrouter.ActorRouter();
        _b004.setBlockID("_b004", sessionID);
        _b002 = new no.ntnu.item.arctis.library.proxies.serverproxy.ServerProxy();
        _b002.setBlockID("_b002", sessionID);
        scheduler.startTimer(1000, "t0", this);
        _b000.setRegistryAddress();
        no.ntnu.item.arctis.library.proxies.Address _b000_o1 = _b000.getLocalAddress();
        _b003.local = _b000_o1;
        _b004.startAfRouter(_b003.getProxyType());
        _state = s_1;
        return CONSUME_SIGNAL;
    }

    public int fire(java.lang.Object _sender, java.lang.Object sessionID, java.lang.String _signalID, java.lang.Object _data){
        if(_signalID.equals("RECEIVE__b002")) {
            return handleSignal_RECEIVE__b002(_sender, sessionID, _data);
        } else if(_signalID.equals("OUTBOUND__b003")) {
            return handleSignal_OUTBOUND__b003(_sender, sessionID, _data);
        } else if(_signalID.equals("AFMSG__b004")) {
            return handleSignal_AFMSG__b004(_sender, sessionID, _data);
        }
        return TRIGGER_UNKNOWN;
    }

    private int handleSignal_RECEIVE__b002(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_2) {
            no.ntnu.item.arctis.library.proxies.Message _b002_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b001.message = _b002_r0_message;
            java.lang.String _b001_o0 = _b001.getSignalID();
            if(_b001_o0.equals("deregister")) {
                _b002.send(_b001.deregister(_b001.message));
                _state = s_3;
                return CONSUME_SIGNAL;
            } else if(_b001_o0.equals("discover")) {
                _b002.send(_b001.discover(_b001.message));
                _state = s_3;
                return CONSUME_SIGNAL;
            } else if(_b001_o0.equals("register")) {
                _b002.send(_b001.register(_b001.message));
                _state = s_3;
                return CONSUME_SIGNAL;
            } else {
                _b001.unexpectedSignal(_b001.message);
                _state = s_3;
                return CONSUME_SIGNAL;
            }
        } else if(_state == s_3) {
            no.ntnu.item.arctis.library.proxies.Message _b002_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b001.message = _b002_r0_message;
            java.lang.String _b001_o0 = _b001.getSignalID();
            if(_b001_o0.equals("discover")) {
                _b002.send(_b001.discover(_b001.message));
                return CONSUME_SIGNAL;
            } else if(_b001_o0.equals("register")) {
                _b002.send(_b001.register(_b001.message));
                return CONSUME_SIGNAL;
            } else if(_b001_o0.equals("deregister")) {
                _b002.send(_b001.deregister(_b001.message));
                return CONSUME_SIGNAL;
            } else {
                _b001.unexpectedSignal(_b001.message);
                return CONSUME_SIGNAL;
            }
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_OUTBOUND__b003(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_1 || _state == s_3 || _state == s_2) {
            no.ntnu.item.arctis.library.proxies.Message _b003_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b003.message = _b003_r0_message;
            if(_b003.isLocal()==true) {
                _b003.receive(_b003.message);
                return CONSUME_SIGNAL;
            } else {
                _b004.send2network(_b003.message);
                return CONSUME_SIGNAL;
            }
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_AFMSG__b004(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_2 || _state == s_1 || _state == s_3) {
            no.ntnu.item.arctis.library.proxies.Message _b004_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b003.receive(_b004_r0_message);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public int fireTimer(java.lang.String _timerID){
        if(_timerID.equals("t0")) {
            return handleTimer_t0();
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t0(){
        if(_state == s_1) {
            _b002.proxySessionID = _b001.getRegistrySessionID();
            _b002.subscribe();
            _state = s_2;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public java.lang.String getPartName(){
        return null;
    }

    public java.lang.String getId(){
        return this._stateMachineID;
    }
}
