package no.item.ntnu.arctis.examples.cityguide.grouppositioningservice;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Vector;

import no.ntnu.item.arctis.library.objects.location.Location;
import no.ntnu.item.arctis.library.objects.user.Group;
import no.ntnu.item.arctis.library.objects.user.Player;
import no.ntnu.item.arctis.library.proxies.Message;
import no.ntnu.item.arctis.runtime.Block;

import com.thoughtworks.xstream.XStream;

public class GroupPositioningService extends Block {

	public no.ntnu.item.arctis.library.proxies.Message request;
	public no.ntnu.item.arctis.library.proxies.Message message;
	public java.util.Vector<no.ntnu.item.arctis.library.objects.user.Group> grps;
	public java.util.HashMap<String, no.ntnu.item.arctis.library.objects.location.Location> usersLocations = 
			new HashMap<String, Location>();
	

	public Message createMessage(String loc_result) {
	
		System.out.println("creating message at Group Positioning Service");
		Message response = new Message("grouppositioning"); 
			//String loc_result = location.getLatitude()+"_"+location.getLongitude();			
			response.setReceiver(message.getSender().getCopy());
			response.setSender(message.getReceiver().getCopy());	
			response.setPayload(loc_result);
		return response;
	}

	public String getGroupMemberLocations(Message msg) {
	
		//
		String askingUserName = (String)msg.getPayload();
		java.util.Set userSet = new  HashSet<String>();		
		for (Iterator iterator = grps.iterator(); iterator.hasNext();) {
			Group type = (Group) iterator.next();
			Vector<Player> plrs = type.getPlayers();
			
			boolean isInGrp = false;
			for (Iterator iterator2 = plrs.iterator(); iterator2.hasNext();) {
				Player player = (Player) iterator2.next();
				if(player.getUserName().equalsIgnoreCase(askingUserName)){
					isInGrp = true;
					continue;
				}
			}			
			if(isInGrp){				
				for (Iterator iterator2 = plrs.iterator(); iterator2.hasNext();) {
					userSet.add(((Player) iterator2.next()).getUserName());
				}
			}			
		}
		
		java.util.HashMap<String, no.ntnu.item.arctis.library.objects.location.Location> matchesUsersLocations = 
			new HashMap<String, Location>();		
		Iterator<?> i = usersLocations.entrySet().iterator(); 
		while(i.hasNext()) { 
			java.util.Map.Entry<String, no.ntnu.item.arctis.library.objects.location.Location> me = 
			(java.util.Map.Entry)i.next(); 
			if(userSet.contains(me.getKey())){
				matchesUsersLocations.put(me.getKey().toString(), (Location) me.getValue());
			}
		} 
		//	 
		
	
		XStream xstream = new XStream();
		xstream.alias("location", Location.class);
		//xstream.toXML(usersLocations);		
		return ""+xstream.toXML(matchesUsersLocations);
	}

	public void updateGroupMemberLocation(String location) {
		String str[] = location.split("#");
		
		System.out.println("in LocationToStr "+ str[0]+ " "+str[1]+ " " +str[2]);
				
		usersLocations.put(str[0], new  Location(Double.valueOf(str[1]), Double.valueOf(str[2])));
	}
}
