package no.item.ntnu.arctis.examples.cityguide.myaddressserviceproxy;

import no.ntnu.item.arctis.runtime.Block;

import org.apache.log4j.xml.DOMConfigurator;
import no.ntnu.item.arctis.library.proxies.Address;
import no.ntnu.item.arctis.library.proxies.Message;

public class MyAddressServiceProxy extends Block {

	static org.apache.log4j.Logger logger = org.apache.log4j.Logger.getLogger("MyAddressServiceProxy.Class");
	
	public no.ntnu.item.arctis.library.proxies.Message message;

	public void found(Address addr) {
		System.out.println("MyAddress service is found.."+addr.toString());
		logger.warn("> "+ "in found, MyAddress service is found.."+addr.toString());
	}

	public void notfound() {
			System.out.println("MyAddress service is not found..");
			logger.warn("> "+ "in nofound, MyAddress service is no found..");
	}

	public Message createPinMessage() {
		System.out.println("creating pin msg at MyAddress Service proxy");
		logger.warn("> "+ "in createPinMessage, creating pin msg at MyAddress Service proxy..");
		
		Message m = new Message("MyAddress Proxy");
		m.setPayload("");
		return m;
	}

	public String extractMessage(Message msg) {
	
		System.out.println("received message from MyAddress Server at MyAddress proxy......"+msg);
		
		
		if (msg.getPayload() instanceof String){	
			String  str = (String)  msg.getPayload();
			Address s = msg.getSender().getCopy();
			System.out.println("Sender Address is ......"+s);
			
			return str;
		}
		else {
			// to do
			return (String) msg.getPayload();
		}
	}

	public void startDiscover() {
			DOMConfigurator.configure("log4j.xml");
			logger.warn("> "+ "in startDiscover, starting to discover MyAdrress Service");
	}
	
}