package no.ntnu.item.arctis.examples.android.cityguide.cityguideapp.app;


public class AndroidMapUISM extends no.ntnu.item.arctis.runtime.IStateMachine {


    protected no.ntnu.item.arctis.runtime.Scheduler scheduler;
    protected java.lang.String _stateMachineID;
    private final static int s_0 = 0, s_3 = 3, s_2 = 2, s_4 = 4;
    private no.ntnu.item.arctis.examples.android.cityguide.androidmapui.AndroidMapUI _b033;
    private static java.util.Hashtable _alias = new java.util.Hashtable();
    private static int sessionCount = 0;

    public AndroidMapUISM(no.ntnu.item.arctis.runtime.Scheduler scheduler, java.lang.String sessionID, java.lang.String parentSessionID) {
        super(sessionID, parentSessionID);
        this.scheduler = scheduler;
        ++ sessionCount;
    }


    protected void registerAlias(java.lang.String alias, java.lang.String sessionID){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided alias is null", null);
        if(sessionID==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided sessionID is null", null);
        if(_alias.containsKey(alias)) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("A session with alias " + alias + " already exists.", null);
        _alias.put(alias, sessionID);
    }

    public static java.lang.String findSession(java.lang.String alias){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Try to find session for null alias", null);
        String sessionID = (String) _alias.get(alias);
        if(sessionID==null) {
            if(!_alias.contains(alias)) {
        	       no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map does not contain alias " + alias, null);
            } else {
                no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map has a null entry for alias " + alias, null);
            }
        }
return sessionID;
    }

    public int getSessionCount(){
        return sessionCount;
    }

    public static java.util.Collection allSessions(){
        return _alias.values();
    }

    public int fireInitial(){
        _b033 = new no.ntnu.item.arctis.examples.android.cityguide.androidmapui.AndroidMapUI();
        _b033.setBlockID("_b033", sessionID);
        _state = s_0;
        return CONSUME_SIGNAL;
    }

    public int fire(java.lang.Object _sender, java.lang.Object sessionID, java.lang.String _signalID, java.lang.Object _data){
        if(_signalID.equals("_c2_c2_Android_Map_UI_location")) {
            return handleSignal__c2_c2_Android_Map_UI_location(_sender, sessionID, _data);
        } else if(_signalID.equals("REQ_GRP_LOC__b033")) {
            return handleSignal_REQ_GRP_LOC__b033(_sender, sessionID, _data);
        } else if(_signalID.equals("_c2_c2_Android_Map_UI_msg")) {
            return handleSignal__c2_c2_Android_Map_UI_msg(_sender, sessionID, _data);
        } else if(_signalID.equals("_c2_c2_Android_Map_UI_stop")) {
            return handleSignal__c2_c2_Android_Map_UI_stop(_sender, sessionID, _data);
        } else if(_signalID.equals("EXIT_FROM_SYSTEM__b033")) {
            return handleSignal_EXIT_FROM_SYSTEM__b033(_sender, sessionID, _data);
        } else if(_signalID.equals("GRP_CHAT__b033")) {
            return handleSignal_GRP_CHAT__b033(_sender, sessionID, _data);
        } else if(_signalID.equals("START_CHAT__b033")) {
            return handleSignal_START_CHAT__b033(_sender, sessionID, _data);
        } else if(_signalID.equals("CREATED__b033")) {
            return handleSignal_CREATED__b033(_sender, sessionID, _data);
        } else if(_signalID.equals("_c2_c2_Android_Map_UI_respGrpLoc")) {
            return handleSignal__c2_c2_Android_Map_UI_respGrpLoc(_sender, sessionID, _data);
        } else if(_signalID.equals("_c2_c2_Android_Map_UI_start")) {
            return handleSignal__c2_c2_Android_Map_UI_start(_sender, sessionID, _data);
        } else if(_signalID.equals("_c2_c2_Android_Map_UI_answered")) {
            return handleSignal__c2_c2_Android_Map_UI_answered(_sender, sessionID, _data);
        }
        return TRIGGER_UNKNOWN;
    }

    private int handleSignal__c2_c2_Android_Map_UI_location(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_4 || _state == s_3 || _state == s_2) {
            android.location.Location _b033_location = (android.location.Location) _data;
            _b033.updateLocation(_b033.loc);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_REQ_GRP_LOC__b033(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_4 || _state == s_2) {
            scheduler.sendToParent(this,"_c2_c2_Android_Map_UI_reqGrpLoc", null);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c2_c2_Android_Map_UI_msg(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_3 || _state == s_2 || _state == s_4) {
            java.lang.String _b033_msg = (java.lang.String) _data;
            _b033.updateMsg(_b033_msg);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c2_c2_Android_Map_UI_stop(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_3 || _state == s_4 || _state == s_2) {
            scheduler.sendToParent(this,"_c2_c2_Android_Map_UI_stopped", null);
            //TERMINATING SESSION VIA stopped;
            -- sessionCount;
            return TERMINATE_MACHINE;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_EXIT_FROM_SYSTEM__b033(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_2 || _state == s_4) {
            scheduler.sendToParent(this,"_c2_c2_Android_Map_UI_stopped", null);
            //TERMINATING SESSION VIA stopped;
            -- sessionCount;
            return TERMINATE_MACHINE;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_GRP_CHAT__b033(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_2 || _state == s_4) {
            scheduler.sendToParent(this,"_c2_c2_Android_Map_UI_startGrpChat", null);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_START_CHAT__b033(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_4 || _state == s_2) {
            java.lang.Object _b033_r3_name = (java.lang.Object) _data;
            scheduler.sendToParent(this,"_c2_c2_Android_Map_UI_startChat", _b033.testName(_b033_r3_name));
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_CREATED__b033(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_4) {
            android.app.Activity _b033_r0_act = (android.app.Activity) _data;
            _b033.act = _b033_r0_act;
            _state = s_2;
            return CONSUME_SIGNAL;
        } else if(_state == s_3) {
            android.app.Activity _b033_r0_act = (android.app.Activity) _data;
            _b033.act = _b033_r0_act;
            _state = s_2;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c2_c2_Android_Map_UI_respGrpLoc(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_4 || _state == s_3 || _state == s_2) {
            java.lang.String _b033_respGrpLoc = (java.lang.String) _data;
            _b033.updateGrpLoc(_b033_respGrpLoc);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c2_c2_Android_Map_UI_start(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_0) {
                    _data = ((java.util.Map<String, Object>) _data).get("_data");
            _b033.startMapActivity();
            _state = s_3;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c2_c2_Android_Map_UI_answered(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_2) {
            _b033.startMapActivity();
            _state = s_4;
            return CONSUME_SIGNAL;
        } else if(_state == s_4 || _state == s_3) {
            _b033.startMapActivity();
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public int fireTimer(java.lang.String _timerID){
                return DISCARD_SIGNAL;
    }

    public java.lang.String getPartName(){
        return null;
    }

    public java.lang.String getId(){
        return this._stateMachineID;
    }
}
