package no.ntnu.item.arctis.examples.android.cityguide.cityguideapp.app;


public class GroupChatServiceProxySM extends no.ntnu.item.arctis.runtime.IStateMachine {


    protected no.ntnu.item.arctis.runtime.Scheduler scheduler;
    protected java.lang.String _stateMachineID;
    private final static int s_0 = 0, s_2 = 2, s_3 = 3;
    private no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy _b063;
    private no.ntnu.item.arctis.library.discovery.discoverservice.DiscoverService _b062;
    private no.ntnu.item.arctis.examples.android.cityguide.groupchatserviceproxy.GroupChatServiceProxy _b060;
    private no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy _b061;
    private static java.util.Hashtable _alias = new java.util.Hashtable();
    private static int sessionCount = 0;

    public GroupChatServiceProxySM(no.ntnu.item.arctis.runtime.Scheduler scheduler, java.lang.String sessionID, java.lang.String parentSessionID) {
        super(sessionID, parentSessionID);
        this.scheduler = scheduler;
        ++ sessionCount;
    }


    protected void registerAlias(java.lang.String alias, java.lang.String sessionID){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided alias is null", null);
        if(sessionID==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided sessionID is null", null);
        if(_alias.containsKey(alias)) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("A session with alias " + alias + " already exists.", null);
        _alias.put(alias, sessionID);
    }

    public static java.lang.String findSession(java.lang.String alias){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Try to find session for null alias", null);
        String sessionID = (String) _alias.get(alias);
        if(sessionID==null) {
            if(!_alias.contains(alias)) {
        	       no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map does not contain alias " + alias, null);
            } else {
                no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map has a null entry for alias " + alias, null);
            }
        }
return sessionID;
    }

    public int getSessionCount(){
        return sessionCount;
    }

    public static java.util.Collection allSessions(){
        return _alias.values();
    }

    public int fireInitial(){
        _b061 = new no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy("", "");
        _b061.setBlockID("_b061", sessionID);
        _b060 = new no.ntnu.item.arctis.examples.android.cityguide.groupchatserviceproxy.GroupChatServiceProxy();
        _b060.setBlockID("_b060", sessionID);
        _b062 = new no.ntnu.item.arctis.library.discovery.discoverservice.DiscoverService("GroupChat");
        _b062.setBlockID("_b062", sessionID);
        _b063 = new no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy("", "");
        _b063.setBlockID("_b063", sessionID);
        _state = s_0;
        return CONSUME_SIGNAL;
    }

    public int fire(java.lang.Object _sender, java.lang.Object sessionID, java.lang.String _signalID, java.lang.Object _data){
        if(_signalID.equals("_c2_c5_c1_GroupChat_Service_Proxy_send")) {
            return handleSignal__c2_c5_c1_GroupChat_Service_Proxy_send(_sender, sessionID, _data);
        } else if(_signalID.equals("_c2_c5_c1_GroupChat_Service_Proxy_start")) {
            return handleSignal__c2_c5_c1_GroupChat_Service_Proxy_start(_sender, sessionID, _data);
        } else if(_signalID.equals("RECEIVE__b063")) {
            return handleSignal_RECEIVE__b063(_sender, sessionID, _data);
        } else if(_signalID.equals("RECEIVE__b061")) {
            return handleSignal_RECEIVE__b061(_sender, sessionID, _data);
        }
        return TRIGGER_UNKNOWN;
    }

    private int handleSignal__c2_c5_c1_GroupChat_Service_Proxy_send(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_3) {
            no.ntnu.item.arctis.library.objects.quiz.InstantMessage _b060_send = (no.ntnu.item.arctis.library.objects.quiz.InstantMessage) _data;
            _b061.send(_b060.createPinMessage(_b060_send));
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c2_c5_c1_GroupChat_Service_Proxy_start(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_0) {
                    _data = ((java.util.Map<String, Object>) _data).get("_data");
            _b063.remote = _b062.getRegisterAddress();
            _b063.subscribe();
            scheduler.startTimer(0, "t0", this);
            _state = s_2;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_RECEIVE__b063(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_2) {
            no.ntnu.item.arctis.library.proxies.Message _b063_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b062.message = _b063_r0_message;
            java.lang.String _b062_o2 = _b062.getSignalID(_b062.message);
            if(_b062_o2.equals("ok")) {
                _b063.unsubscribe();
                no.ntnu.item.arctis.library.proxies.Address _b062_o3 = _b062.extractAddress(_b062.message);
                _b061.remote = _b062_o3;
                _b061.subscribe();
                _b060.found(_b062_o3);
                _state = s_3;
                return CONSUME_SIGNAL;
            } else {
                _b063.unsubscribe();
                _b060.notfound();
                scheduler.sendToParent(this,"_c2_c5_c1_GroupChat_Service_Proxy_failed", null);
                //TERMINATING SESSION VIA failed;
                -- sessionCount;
                return TERMINATE_MACHINE;
            }
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_RECEIVE__b061(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_3) {
            no.ntnu.item.arctis.library.proxies.Message _b061_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b060.extractMessage(_b061_r0_message);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public int fireTimer(java.lang.String _timerID){
        if(_timerID.equals("t1")) {
            return handleTimer_t1();
        } else if(_timerID.equals("t0")) {
            return handleTimer_t0();
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t1(){
        if(_state == s_2) {
            _b062.logTimeout();
            _b063.unsubscribe();
            _b060.notfound();
            scheduler.sendToParent(this,"_c2_c5_c1_GroupChat_Service_Proxy_failed", null);
            //TERMINATING SESSION VIA failed;
            -- sessionCount;
            return TERMINATE_MACHINE;
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t0(){
        if(_state == s_2) {
            _b063.send(_b062.createDiscoverMessage());
            scheduler.startTimer(10000, "t1", this);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public java.lang.String getPartName(){
        return null;
    }

    public java.lang.String getId(){
        return this._stateMachineID;
    }
}
