package no.ntnu.item.arctis.examples.android.cityguide.cityguideapp.app;


public class IMAppSM extends no.ntnu.item.arctis.runtime.IStateMachine {


    protected no.ntnu.item.arctis.runtime.Scheduler scheduler;
    protected java.lang.String _stateMachineID;
    private final static int s_0 = 0, s_27 = 27, s_1 = 1, s_11 = 11, s_19 = 19, s_6 = 6, s_2 = 2, s_4 = 4, s_3 = 3, s_12 = 12, s_16 = 16, 
        s_21 = 21, s_22 = 22, s_18 = 18, s_7 = 7, s_20 = 20, s_29 = 29, s_26 = 26;
    private java.lang.String _c2_c4_IM_App_c1;
    private no.ntnu.item.arctis.library.android.notification.Notification _b055;
    private no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy _b052;
    private no.ntnu.item.arctis.library.discovery.registerandderegisterservice.RegisterandDeregisterService _b047;
    private no.ntnu.item.arctis.examples.android.cityguide.imapp.IMApp _b039;
    private no.ntnu.item.arctis.library.discovery.registerservice.RegisterService _b048;
    private no.ntnu.item.arctis.library.proxies.serverproxy.ServerProxy _b054;
    private no.ntnu.item.arctis.library.discovery.deregisterservice.DeregisterService _b051;
    private no.ntnu.item.arctis.examples.android.cityguide.myaddressservice.MyAddressService _b045;
    private no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy _b049;
    private no.ntnu.item.arctis.library.discovery.genericservice.GenericService _b046;
    private no.ntnu.item.arctis.examples.android.cityguide.instantmessagingui.InstantMessagingUI _b056;
    private static java.util.Hashtable _alias = new java.util.Hashtable();
    private static int sessionCount = 0;

    public IMAppSM(no.ntnu.item.arctis.runtime.Scheduler scheduler, java.lang.String sessionID, java.lang.String parentSessionID) {
        super(sessionID, parentSessionID);
        this.scheduler = scheduler;
        ++ sessionCount;
    }


    protected void registerAlias(java.lang.String alias, java.lang.String sessionID){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided alias is null", null);
        if(sessionID==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided sessionID is null", null);
        if(_alias.containsKey(alias)) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("A session with alias " + alias + " already exists.", null);
        _alias.put(alias, sessionID);
    }

    public static java.lang.String findSession(java.lang.String alias){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Try to find session for null alias", null);
        String sessionID = (String) _alias.get(alias);
        if(sessionID==null) {
            if(!_alias.contains(alias)) {
        	       no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map does not contain alias " + alias, null);
            } else {
                no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map has a null entry for alias " + alias, null);
            }
        }
return sessionID;
    }

    public int getSessionCount(){
        return sessionCount;
    }

    public static java.util.Collection allSessions(){
        return _alias.values();
    }

    public int fireInitial(){
        _b056 = new no.ntnu.item.arctis.examples.android.cityguide.instantmessagingui.InstantMessagingUI();
        _b056.setBlockID("_b056", sessionID);
        _b046 = new no.ntnu.item.arctis.library.discovery.genericservice.GenericService("MyAddress");
        _b046.setBlockID("_b046", sessionID);
        _b049 = new no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy("", "");
        _b049.setBlockID("_b049", sessionID);
        _b045 = new no.ntnu.item.arctis.examples.android.cityguide.myaddressservice.MyAddressService();
        _b045.setBlockID("_b045", sessionID);
        _b051 = new no.ntnu.item.arctis.library.discovery.deregisterservice.DeregisterService();
        _b051.setBlockID("_b051", sessionID);
        _b054 = new no.ntnu.item.arctis.library.proxies.serverproxy.ServerProxy();
        _b054.setBlockID("_b054", sessionID);
        _b048 = new no.ntnu.item.arctis.library.discovery.registerservice.RegisterService();
        _b048.setBlockID("_b048", sessionID);
        _b039 = new no.ntnu.item.arctis.examples.android.cityguide.imapp.IMApp();
        _b039.setBlockID("_b039", sessionID);
        _b047 = new no.ntnu.item.arctis.library.discovery.registerandderegisterservice.RegisterandDeregisterService();
        _b047.setBlockID("_b047", sessionID);
        _b052 = new no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy("", "");
        _b052.setBlockID("_b052", sessionID);
        _b055 = new no.ntnu.item.arctis.library.android.notification.Notification("Notification", true);
        _b055.setBlockID("_b055", sessionID);
        _state = s_0;
        return CONSUME_SIGNAL;
    }

    public int fire(java.lang.Object _sender, java.lang.Object sessionID, java.lang.String _signalID, java.lang.Object _data){
        if(_signalID.equals("NOTIFICATION_PRESSED__b055")) {
            return handleSignal_NOTIFICATION_PRESSED__b055(_sender, sessionID, _data);
        } else if(_signalID.equals("RECEIVE__b054")) {
            return handleSignal_RECEIVE__b054(_sender, sessionID, _data);
        } else if(_signalID.equals("_c2_c4_IM_App_start")) {
            return handleSignal__c2_c4_IM_App_start(_sender, sessionID, _data);
        } else if(_signalID.equals("NOTIFICATION_CLEARED__b055")) {
            return handleSignal_NOTIFICATION_CLEARED__b055(_sender, sessionID, _data);
        } else if(_signalID.equals("EXIT__b056")) {
            return handleSignal_EXIT__b056(_sender, sessionID, _data);
        } else if(_signalID.equals("RECEIVE__b049")) {
            return handleSignal_RECEIVE__b049(_sender, sessionID, _data);
        } else if(_signalID.equals("SHOW__b056")) {
            return handleSignal_SHOW__b056(_sender, sessionID, _data);
        } else if(_signalID.equals("_c2_c4_c1_IM_Service_Proxy_failed")) {
            return handleSignal__c2_c4_c1_IM_Service_Proxy_failed(_sender, sessionID, _data);
        } else if(_signalID.equals("SEND__b056")) {
            return handleSignal_SEND__b056(_sender, sessionID, _data);
        } else if(_signalID.equals("_c2_c4_IM_App_stop")) {
            return handleSignal__c2_c4_IM_App_stop(_sender, sessionID, _data);
        } else if(_signalID.equals("_c2_c4_IM_App_init")) {
            return handleSignal__c2_c4_IM_App_init(_sender, sessionID, _data);
        } else if(_signalID.equals("_c2_c4_IM_App_startFrmMap")) {
            return handleSignal__c2_c4_IM_App_startFrmMap(_sender, sessionID, _data);
        } else if(_signalID.equals("CREATED__b056")) {
            return handleSignal_CREATED__b056(_sender, sessionID, _data);
        }
        return TRIGGER_UNKNOWN;
    }

    private int handleSignal_NOTIFICATION_PRESSED__b055(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_6) {
            _b056.receivedMsg = _b039.replyMsg;
            if(_b056.checkPart()==true) {
                _b056.otherMessages();
                _state = s_19;
                return CONSUME_SIGNAL;
            } else {
                _b056.startActivity();
                _state = s_19;
                return CONSUME_SIGNAL;
            }
        } else if(_state == s_1) {
            _b056.receivedMsg = _b039.replyMsg;
            if(_b056.checkPart()==true) {
                _b056.otherMessages();
                _state = s_11;
                return CONSUME_SIGNAL;
            } else {
                _b056.startActivity();
                _state = s_19;
                return CONSUME_SIGNAL;
            }
        } else if(_state == s_4) {
            _b056.receivedMsg = _b039.replyMsg;
            if(_b056.checkPart()==true) {
                _b056.otherMessages();
                _state = s_3;
                return CONSUME_SIGNAL;
            } else {
                _b056.startActivity();
                _state = s_21;
                return CONSUME_SIGNAL;
            }
        } else if(_state == s_7) {
            _state = s_22;
            return CONSUME_SIGNAL;
        } else if(_state == s_18) {
            _b056.receivedMsg = _b039.replyMsg;
            if(_b056.checkPart()==true) {
                _b056.otherMessages();
                _state = s_21;
                return CONSUME_SIGNAL;
            } else {
                _b056.startActivity();
                _state = s_21;
                return CONSUME_SIGNAL;
            }
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_RECEIVE__b054(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_16) {
            no.ntnu.item.arctis.library.proxies.Message _b054_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b045.message = _b054_r0_message;
            if(_b045.show(_b045.message)==true) {
                _b039.replyMsg = _b039.replyValue(_b045.message);
                _b055.displayNotification(_b039.replyMsg);
                _state = s_7;
                return CONSUME_SIGNAL;
            } else {
                no.ntnu.item.arctis.library.proxies.Message _b045_o1 = _b045.createMessage(_b045.message);
                _b054.send(_b045_o1);
                scheduler.startTimer(500000, "t1", this);
                _state = s_22;
                return CONSUME_SIGNAL;
            }
        } else if(_state == s_3) {
            no.ntnu.item.arctis.library.proxies.Message _b054_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b045.message = _b054_r0_message;
            if(_b045.show(_b045.message)==true) {
                _b039.replyMsg = _b039.replyValue(_b045.message);
                _b055.displayNotification(_b039.replyMsg);
                _state = s_4;
                return CONSUME_SIGNAL;
            } else {
                no.ntnu.item.arctis.library.proxies.Message _b045_o1 = _b045.createMessage(_b045.message);
                _b054.send(_b045_o1);
                scheduler.startTimer(500000, "t1", this);
                return CONSUME_SIGNAL;
            }
        } else if(_state == s_19) {
            no.ntnu.item.arctis.library.proxies.Message _b054_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b045.message = _b054_r0_message;
            if(_b045.show(_b045.message)==true) {
                _b039.replyMsg = _b039.replyValue(_b045.message);
                _b055.displayNotification(_b039.replyMsg);
                _state = s_6;
                return CONSUME_SIGNAL;
            } else {
                no.ntnu.item.arctis.library.proxies.Message _b045_o1 = _b045.createMessage(_b045.message);
                _b054.send(_b045_o1);
                scheduler.startTimer(500000, "t1", this);
                return CONSUME_SIGNAL;
            }
        } else if(_state == s_1) {
            no.ntnu.item.arctis.library.proxies.Message _b054_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b045.message = _b054_r0_message;
            if(_b045.show(_b045.message)==true) {
                _b039.replyMsg = _b039.replyValue(_b045.message);
                return CONSUME_SIGNAL;
            } else {
                no.ntnu.item.arctis.library.proxies.Message _b045_o1 = _b045.createMessage(_b045.message);
                _b054.send(_b045_o1);
                scheduler.restartTimer(500000, "t1", this);
                return CONSUME_SIGNAL;
            }
        } else if(_state == s_22) {
            no.ntnu.item.arctis.library.proxies.Message _b054_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b045.message = _b054_r0_message;
            if(_b045.show(_b045.message)==true) {
                _b039.replyMsg = _b039.replyValue(_b045.message);
                _b055.displayNotification(_b039.replyMsg);
                _state = s_7;
                return CONSUME_SIGNAL;
            } else {
                no.ntnu.item.arctis.library.proxies.Message _b045_o1 = _b045.createMessage(_b045.message);
                _b054.send(_b045_o1);
                scheduler.restartTimer(500000, "t1", this);
                return CONSUME_SIGNAL;
            }
        } else if(_state == s_20) {
            no.ntnu.item.arctis.library.proxies.Message _b054_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b045.message = _b054_r0_message;
            if(_b045.show(_b045.message)==true) {
                _b039.replyMsg = _b039.replyValue(_b045.message);
                _b055.displayNotification(_b039.replyMsg);
                _state = s_1;
                return CONSUME_SIGNAL;
            } else {
                no.ntnu.item.arctis.library.proxies.Message _b045_o1 = _b045.createMessage(_b045.message);
                _b054.send(_b045_o1);
                scheduler.startTimer(500000, "t1", this);
                _state = s_11;
                return CONSUME_SIGNAL;
            }
        } else if(_state == s_11) {
            no.ntnu.item.arctis.library.proxies.Message _b054_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b045.message = _b054_r0_message;
            if(_b045.show(_b045.message)==true) {
                _b039.replyMsg = _b039.replyValue(_b045.message);
                _b055.displayNotification(_b039.replyMsg);
                _state = s_1;
                return CONSUME_SIGNAL;
            } else {
                no.ntnu.item.arctis.library.proxies.Message _b045_o1 = _b045.createMessage(_b045.message);
                _b054.send(_b045_o1);
                scheduler.restartTimer(500000, "t1", this);
                return CONSUME_SIGNAL;
            }
        } else if(_state == s_4 || _state == s_6 || _state == s_7 || _state == s_18) {
            no.ntnu.item.arctis.library.proxies.Message _b054_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b045.message = _b054_r0_message;
            if(_b045.show(_b045.message)==true) {
                _b039.replyMsg = _b039.replyValue(_b045.message);
                return CONSUME_SIGNAL;
            } else {
                no.ntnu.item.arctis.library.proxies.Message _b045_o1 = _b045.createMessage(_b045.message);
                _b054.send(_b045_o1);
                scheduler.startTimer(500000, "t1", this);
                return CONSUME_SIGNAL;
            }
        } else if(_state == s_2) {
            no.ntnu.item.arctis.library.proxies.Message _b054_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b045.message = _b054_r0_message;
            if(_b045.show(_b045.message)==true) {
                _b039.replyMsg = _b039.replyValue(_b045.message);
                _b055.displayNotification(_b039.replyMsg);
                _state = s_4;
                return CONSUME_SIGNAL;
            } else {
                no.ntnu.item.arctis.library.proxies.Message _b045_o1 = _b045.createMessage(_b045.message);
                _b054.send(_b045_o1);
                scheduler.startTimer(500000, "t1", this);
                _state = s_3;
                return CONSUME_SIGNAL;
            }
        } else if(_state == s_12) {
            no.ntnu.item.arctis.library.proxies.Message _b054_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b045.message = _b054_r0_message;
            if(_b045.show(_b045.message)==true) {
                _b039.replyMsg = _b039.replyValue(_b045.message);
                _b055.displayNotification(_b039.replyMsg);
                _state = s_18;
                return CONSUME_SIGNAL;
            } else {
                no.ntnu.item.arctis.library.proxies.Message _b045_o1 = _b045.createMessage(_b045.message);
                _b054.send(_b045_o1);
                scheduler.startTimer(500000, "t1", this);
                _state = s_21;
                return CONSUME_SIGNAL;
            }
        } else if(_state == s_29) {
            no.ntnu.item.arctis.library.proxies.Message _b054_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b045.message = _b054_r0_message;
            if(_b045.show(_b045.message)==true) {
                _b039.replyMsg = _b039.replyValue(_b045.message);
                _b055.displayNotification(_b039.replyMsg);
                _state = s_6;
                return CONSUME_SIGNAL;
            } else {
                no.ntnu.item.arctis.library.proxies.Message _b045_o1 = _b045.createMessage(_b045.message);
                _b054.send(_b045_o1);
                scheduler.startTimer(500000, "t1", this);
                _state = s_19;
                return CONSUME_SIGNAL;
            }
        } else if(_state == s_21) {
            no.ntnu.item.arctis.library.proxies.Message _b054_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b045.message = _b054_r0_message;
            if(_b045.show(_b045.message)==true) {
                _b039.replyMsg = _b039.replyValue(_b045.message);
                _b055.displayNotification(_b039.replyMsg);
                _state = s_18;
                return CONSUME_SIGNAL;
            } else {
                no.ntnu.item.arctis.library.proxies.Message _b045_o1 = _b045.createMessage(_b045.message);
                _b054.send(_b045_o1);
                scheduler.startTimer(500000, "t1", this);
                return CONSUME_SIGNAL;
            }
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c2_c4_IM_App_start(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_0) {
                    _data = ((java.util.Map<String, Object>) _data).get("_data");
            _b046.createServiceSessionID();
            _b047.registerEntry = _b046.createRegisterEntry();
            _b048.registerEntry = _b047.registerEntry;
            _b049.remote = _b048.getRegisterAddress();
            _b049.subscribe();
            scheduler.startTimer(0, "t0", this);
            _state = s_27;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_NOTIFICATION_CLEARED__b055(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_4) {
            _state = s_3;
            return CONSUME_SIGNAL;
        } else if(_state == s_18) {
            _state = s_21;
            return CONSUME_SIGNAL;
        } else if(_state == s_6) {
            _state = s_19;
            return CONSUME_SIGNAL;
        } else if(_state == s_7) {
            _state = s_22;
            return CONSUME_SIGNAL;
        } else if(_state == s_1) {
            _state = s_11;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_EXIT__b056(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_18) {
            _b056.destroyAct();
            scheduler.restartTimer(500, "t2", this);
            _state = s_7;
            return CONSUME_SIGNAL;
        } else if(_state == s_21) {
            _b056.destroyAct();
            scheduler.restartTimer(500, "t2", this);
            _state = s_22;
            return CONSUME_SIGNAL;
        } else if(_state == s_12) {
            _b056.destroyAct();
            scheduler.restartTimer(500, "t2", this);
            _state = s_16;
            return CONSUME_SIGNAL;
        } else if(_state == s_3) {
            _b056.destroyAct();
            scheduler.startTimer(500, "t2", this);
            _state = s_22;
            return CONSUME_SIGNAL;
        } else if(_state == s_2) {
            _b056.destroyAct();
            scheduler.restartTimer(500, "t2", this);
            _state = s_16;
            return CONSUME_SIGNAL;
        } else if(_state == s_4) {
            _b056.destroyAct();
            scheduler.startTimer(500, "t2", this);
            _state = s_7;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_RECEIVE__b049(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_27) {
            no.ntnu.item.arctis.library.proxies.Message _b049_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            java.lang.String _b048_o2 = _b048.getSignalID(_b049_r0_message);
            if(_b048_o2.equals("failed")) {
                _b049.unsubscribe();
                _state = s_26;
                return CONSUME_SIGNAL;
            } else if(_b048_o2.equals("ok")) {
                _b049.unsubscribe();
                _b045.registerOk();
                scheduler.sendToParent(this,"_c2_c4_IM_App_regOK", null);
                _b054.proxySessionID = _b046.serviceSessionID;
                _b054.subscribe();
                _state = s_16;
                return CONSUME_SIGNAL;
            } else {
                _b048.unexpectedSignal(_b048_o2);
                return CONSUME_SIGNAL;
            }
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_SHOW__b056(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_12 || _state == s_4) {
            scheduler.startTimer(500, "t3", this);
            return CONSUME_SIGNAL;
        } else if(_state == s_18 || _state == s_2 || _state == s_3 || _state == s_21) {
            scheduler.restartTimer(500, "t3", this);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c2_c4_c1_IM_Service_Proxy_failed(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_26 || _state == s_0 || _state == s_27) {
            //TERMINATING SESSION VIA failed;
            -- sessionCount;
            return CONSUME_SIGNAL;
        } else if(_state == s_11 || _state == s_16 || _state == s_1 || _state == s_19 || _state == s_12 || _state == s_3 || _state == s_7 || _state == s_2 || _state == s_22 || _state == s_18 || _state == s_4 || _state == s_29 || _state == s_21 || _state == s_20 || _state == s_6) {
            //TERMINATING SESSION VIA failed;
            -- sessionCount;
            return TERMINATE_MACHINE;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_SEND__b056(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_12 || _state == s_18 || _state == s_4 || _state == s_21 || _state == s_2 || _state == s_3) {
            no.ntnu.item.arctis.library.objects.quiz.InstantMessage _b056_r1_msg = (no.ntnu.item.arctis.library.objects.quiz.InstantMessage) _data;
            _b039.msg = _b056_r1_msg;
                        scheduler.sendToSession(this, _c2_c4_IM_App_c1, "_c2_c4_c1_IM_Service_Proxy_send", _b039.msg);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c2_c4_IM_App_stop(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_6 || _state == s_19 || _state == s_11 || _state == s_22 || _state == s_3 || _state == s_16 || _state == s_2 || _state == s_18 || _state == s_4 || _state == s_21 || _state == s_7 || _state == s_29 || _state == s_1 || _state == s_20 || _state == s_12) {
            //TERMINATING SESSION VIA cancel;
            -- sessionCount;
            return TERMINATE_MACHINE;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c2_c4_IM_App_init(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_22) {
            no.ntnu.item.arctis.library.objects.login.Credentials _b039_init = (no.ntnu.item.arctis.library.objects.login.Credentials) _data;
            _b039.cred = _b039_init;
            _c2_c4_IM_App_c1 = scheduler.createFreshSessionID();
                    java.util.Map<String, Object> _c2_c4_IM_App_c1_data = new java.util.HashMap<String,Object>();
                    _c2_c4_IM_App_c1_data.put("_data", _b039.cred);
                    scheduler.sendToSession(this, _c2_c4_IM_App_c1, "_c2_c4_c1_IM_Service_Proxy_start", _c2_c4_IM_App_c1_data);
            _b056.cred = _b039.cred;
            _state = s_11;
            return CONSUME_SIGNAL;
        } else if(_state == s_7) {
            no.ntnu.item.arctis.library.objects.login.Credentials _b039_init = (no.ntnu.item.arctis.library.objects.login.Credentials) _data;
            _b039.cred = _b039_init;
            _c2_c4_IM_App_c1 = scheduler.createFreshSessionID();
                    java.util.Map<String, Object> _c2_c4_IM_App_c1_data = new java.util.HashMap<String,Object>();
                    _c2_c4_IM_App_c1_data.put("_data", _b039.cred);
                    scheduler.sendToSession(this, _c2_c4_IM_App_c1, "_c2_c4_c1_IM_Service_Proxy_start", _c2_c4_IM_App_c1_data);
            _b056.cred = _b039.cred;
            _state = s_1;
            return CONSUME_SIGNAL;
        } else if(_state == s_11 || _state == s_18 || _state == s_6 || _state == s_2 || _state == s_3 || _state == s_19 || _state == s_21 || _state == s_20 || _state == s_12 || _state == s_1 || _state == s_4 || _state == s_29) {
            no.ntnu.item.arctis.library.objects.login.Credentials _b039_init = (no.ntnu.item.arctis.library.objects.login.Credentials) _data;
            _b039.cred = _b039_init;
            _c2_c4_IM_App_c1 = scheduler.createFreshSessionID();
                    java.util.Map<String, Object> _c2_c4_IM_App_c1_data = new java.util.HashMap<String,Object>();
                    _c2_c4_IM_App_c1_data.put("_data", _b039.cred);
                    scheduler.sendToSession(this, _c2_c4_IM_App_c1, "_c2_c4_c1_IM_Service_Proxy_start", _c2_c4_IM_App_c1_data);
            return CONSUME_SIGNAL;
        } else if(_state == s_16) {
            no.ntnu.item.arctis.library.objects.login.Credentials _b039_init = (no.ntnu.item.arctis.library.objects.login.Credentials) _data;
            _b039.cred = _b039_init;
            _c2_c4_IM_App_c1 = scheduler.createFreshSessionID();
                    java.util.Map<String, Object> _c2_c4_IM_App_c1_data = new java.util.HashMap<String,Object>();
                    _c2_c4_IM_App_c1_data.put("_data", _b039.cred);
                    scheduler.sendToSession(this, _c2_c4_IM_App_c1, "_c2_c4_c1_IM_Service_Proxy_start", _c2_c4_IM_App_c1_data);
            _b056.cred = _b039.cred;
            _state = s_20;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c2_c4_IM_App_startFrmMap(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_3) {
            java.lang.Object _b039_startFrmMap = (java.lang.Object) _data;
            _b056.part = _b039_startFrmMap;
            _b056.startActivity();
            _state = s_21;
            return CONSUME_SIGNAL;
        } else if(_state == s_4) {
            java.lang.Object _b039_startFrmMap = (java.lang.Object) _data;
            _b056.part = _b039_startFrmMap;
            _b056.startActivity();
            _state = s_18;
            return CONSUME_SIGNAL;
        } else if(_state == s_21 || _state == s_6 || _state == s_29 || _state == s_19 || _state == s_18 || _state == s_12) {
            java.lang.Object _b039_startFrmMap = (java.lang.Object) _data;
            _b056.part = _b039_startFrmMap;
            _b056.startActivity();
            return CONSUME_SIGNAL;
        } else if(_state == s_22 || _state == s_7 || _state == s_16) {
            java.lang.Object _b039_startFrmMap = (java.lang.Object) _data;
            return CONSUME_SIGNAL;
        } else if(_state == s_11) {
            java.lang.Object _b039_startFrmMap = (java.lang.Object) _data;
            _b056.part = _b039_startFrmMap;
            _b056.startActivity();
            _state = s_19;
            return CONSUME_SIGNAL;
        } else if(_state == s_1) {
            java.lang.Object _b039_startFrmMap = (java.lang.Object) _data;
            _b056.part = _b039_startFrmMap;
            _b056.startActivity();
            _state = s_6;
            return CONSUME_SIGNAL;
        } else if(_state == s_20) {
            java.lang.Object _b039_startFrmMap = (java.lang.Object) _data;
            _b056.part = _b039_startFrmMap;
            _b056.startActivity();
            _state = s_29;
            return CONSUME_SIGNAL;
        } else if(_state == s_2) {
            java.lang.Object _b039_startFrmMap = (java.lang.Object) _data;
            _b056.part = _b039_startFrmMap;
            _b056.startActivity();
            _state = s_12;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_CREATED__b056(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_29) {
            android.app.Activity _b056_r0_act = (android.app.Activity) _data;
            _b056.activity = _b056_r0_act;
            _b056.setUsername();
            _b056.setChatPartnerName();
            _state = s_2;
            return CONSUME_SIGNAL;
        } else if(_state == s_12) {
            android.app.Activity _b056_r0_act = (android.app.Activity) _data;
            _b056.activity = _b056_r0_act;
            _b056.setUsername();
            _b056.setChatPartnerName();
            _state = s_2;
            return CONSUME_SIGNAL;
        } else if(_state == s_21) {
            android.app.Activity _b056_r0_act = (android.app.Activity) _data;
            _b056.activity = _b056_r0_act;
            _b056.setUsername();
            _b056.setChatPartnerName();
            _state = s_3;
            return CONSUME_SIGNAL;
        } else if(_state == s_6) {
            android.app.Activity _b056_r0_act = (android.app.Activity) _data;
            _b056.activity = _b056_r0_act;
            _b056.setUsername();
            _b056.setChatPartnerName();
            _state = s_4;
            return CONSUME_SIGNAL;
        } else if(_state == s_18) {
            android.app.Activity _b056_r0_act = (android.app.Activity) _data;
            _b056.activity = _b056_r0_act;
            _b056.setUsername();
            _b056.setChatPartnerName();
            _state = s_4;
            return CONSUME_SIGNAL;
        } else if(_state == s_19) {
            android.app.Activity _b056_r0_act = (android.app.Activity) _data;
            _b056.activity = _b056_r0_act;
            _b056.setUsername();
            _b056.setChatPartnerName();
            _state = s_3;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public int fireTimer(java.lang.String _timerID){
        if(_timerID.equals("t3")) {
            return handleTimer_t3();
        } else if(_timerID.equals("t2")) {
            return handleTimer_t2();
        } else if(_timerID.equals("t1")) {
            return handleTimer_t1();
        } else if(_timerID.equals("t0")) {
            return handleTimer_t0();
        } else if(_timerID.equals("t4")) {
            return handleTimer_t4();
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t3(){
        if(_state == s_4 || _state == s_12 || _state == s_18 || _state == s_2 || _state == s_3 || _state == s_21) {
            _b056.showFirstReply();
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t2(){
        if(_state == s_21 || _state == s_11 || _state == s_2 || _state == s_19 || _state == s_12 || _state == s_4 || _state == s_18 || _state == s_29 || _state == s_20 || _state == s_3 || _state == s_6 || _state == s_1) {
            return CONSUME_SIGNAL;
        } else if(_state == s_7) {
            _b056.cred = _b039.cred;
            _state = s_1;
            return CONSUME_SIGNAL;
        } else if(_state == s_16) {
            _b056.cred = _b039.cred;
            _state = s_20;
            return CONSUME_SIGNAL;
        } else if(_state == s_22) {
            _b056.cred = _b039.cred;
            _state = s_11;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t1(){
        if(_state == s_22 || _state == s_1 || _state == s_3 || _state == s_7 || _state == s_6 || _state == s_4 || _state == s_18 || _state == s_21 || _state == s_11 || _state == s_19) {
            no.ntnu.item.arctis.library.proxies.Message _b045_o1 = _b045.createMessage(_b045.message);
            _b054.send(_b045_o1);
            scheduler.restartTimer(500000, "t1", this);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t0(){
        if(_state == s_27) {
            _b049.send(_b048.createRegisterMessage());
            scheduler.startTimer(10000, "t4", this);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t4(){
        if(_state == s_27) {
            _b049.unsubscribe();
            _state = s_26;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public java.lang.String getPartName(){
        return null;
    }

    public java.lang.String getId(){
        return this._stateMachineID;
    }
}
