package no.ntnu.item.arctis.examples.android.cityguide.cityguideapp.app;


public class LocationServiceSM extends no.ntnu.item.arctis.runtime.IStateMachine {


    protected no.ntnu.item.arctis.runtime.Scheduler scheduler;
    protected java.lang.String _stateMachineID;
    private final static int s_0 = 0, s_3 = 3, s_7 = 7, s_4 = 4, s_10 = 10, s_5 = 5;
    private no.ntnu.item.arctis.library.discovery.registerandderegisterservice.RegisterandDeregisterService _b013;
    private no.ntnu.item.arctis.examples.android.cityguide.getperiodiclocationupdates.GetPeriodicLocationUpdates _b021;
    private no.ntnu.item.arctis.library.discovery.deregisterservice.DeregisterService _b017;
    private no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy _b018;
    private no.ntnu.item.arctis.examples.android.cityguide.locationservice.LocationService _b011;
    private no.ntnu.item.arctis.library.proxies.serverproxy.ServerProxy _b020;
    private no.ntnu.item.arctis.library.discovery.genericservice.GenericService _b012;
    private no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy _b015;
    private no.ntnu.item.arctis.library.discovery.registerservice.RegisterService _b014;
    private static java.util.Hashtable _alias = new java.util.Hashtable();
    private static int sessionCount = 0;

    public LocationServiceSM(no.ntnu.item.arctis.runtime.Scheduler scheduler, java.lang.String sessionID, java.lang.String parentSessionID) {
        super(sessionID, parentSessionID);
        this.scheduler = scheduler;
        ++ sessionCount;
    }


    protected void registerAlias(java.lang.String alias, java.lang.String sessionID){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided alias is null", null);
        if(sessionID==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided sessionID is null", null);
        if(_alias.containsKey(alias)) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("A session with alias " + alias + " already exists.", null);
        _alias.put(alias, sessionID);
    }

    public static java.lang.String findSession(java.lang.String alias){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Try to find session for null alias", null);
        String sessionID = (String) _alias.get(alias);
        if(sessionID==null) {
            if(!_alias.contains(alias)) {
        	       no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map does not contain alias " + alias, null);
            } else {
                no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map has a null entry for alias " + alias, null);
            }
        }
return sessionID;
    }

    public int getSessionCount(){
        return sessionCount;
    }

    public static java.util.Collection allSessions(){
        return _alias.values();
    }

    public int fireInitial(){
        _b014 = new no.ntnu.item.arctis.library.discovery.registerservice.RegisterService();
        _b014.setBlockID("_b014", sessionID);
        _b015 = new no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy("", "");
        _b015.setBlockID("_b015", sessionID);
        _b012 = new no.ntnu.item.arctis.library.discovery.genericservice.GenericService("location");
        _b012.setBlockID("_b012", sessionID);
        _b020 = new no.ntnu.item.arctis.library.proxies.serverproxy.ServerProxy();
        _b020.setBlockID("_b020", sessionID);
        _b011 = new no.ntnu.item.arctis.examples.android.cityguide.locationservice.LocationService();
        _b011.setBlockID("_b011", sessionID);
        _b018 = new no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy("", "");
        _b018.setBlockID("_b018", sessionID);
        _b017 = new no.ntnu.item.arctis.library.discovery.deregisterservice.DeregisterService();
        _b017.setBlockID("_b017", sessionID);
        _b021 = new no.ntnu.item.arctis.examples.android.cityguide.getperiodiclocationupdates.GetPeriodicLocationUpdates();
        _b021.setBlockID("_b021", sessionID);
        _b013 = new no.ntnu.item.arctis.library.discovery.registerandderegisterservice.RegisterandDeregisterService();
        _b013.setBlockID("_b013", sessionID);
        _state = s_0;
        return CONSUME_SIGNAL;
    }

    public int fire(java.lang.Object _sender, java.lang.Object sessionID, java.lang.String _signalID, java.lang.Object _data){
        if(_signalID.equals("LOCATION_CHANGED__b021")) {
            return handleSignal_LOCATION_CHANGED__b021(_sender, sessionID, _data);
        } else if(_signalID.equals("RECEIVE__b020")) {
            return handleSignal_RECEIVE__b020(_sender, sessionID, _data);
        } else if(_signalID.equals("LOCATION_NOT_FOUND__b021")) {
            return handleSignal_LOCATION_NOT_FOUND__b021(_sender, sessionID, _data);
        } else if(_signalID.equals("RECEIVE__b015")) {
            return handleSignal_RECEIVE__b015(_sender, sessionID, _data);
        } else if(_signalID.equals("_c2_c0_Location_Service_stop")) {
            return handleSignal__c2_c0_Location_Service_stop(_sender, sessionID, _data);
        } else if(_signalID.equals("_c2_c0_Location_Service_register")) {
            return handleSignal__c2_c0_Location_Service_register(_sender, sessionID, _data);
        }
        return TRIGGER_UNKNOWN;
    }

    private int handleSignal_LOCATION_CHANGED__b021(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_5 || _state == s_10) {
            android.location.Location _b021_r0_loc = (android.location.Location) _data;
            _b020.send(_b011.createMessage(_b021_r0_loc));
            scheduler.sendToParent(this,"_c2_c0_Location_Service_loc", _b021_r0_loc);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_RECEIVE__b020(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_4) {
            no.ntnu.item.arctis.library.proxies.Message _b020_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b011.message = _b020_r0_message;
            _b021.startLocationService();
            _state = s_10;
            return CONSUME_SIGNAL;
        } else if(_state == s_10 || _state == s_5) {
            no.ntnu.item.arctis.library.proxies.Message _b020_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b011.message = _b020_r0_message;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_LOCATION_NOT_FOUND__b021(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_10) {
            _state = s_5;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_RECEIVE__b015(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_3) {
            no.ntnu.item.arctis.library.proxies.Message _b015_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            java.lang.String _b014_o2 = _b014.getSignalID(_b015_r0_message);
            if(_b014_o2.equals("failed")) {
                _b015.unsubscribe();
                _b011.registerFail();
                _state = s_7;
                return CONSUME_SIGNAL;
            } else if(_b014_o2.equals("ok")) {
                _b015.unsubscribe();
                _b011.registerOk();
                scheduler.sendToParent(this,"_c2_c0_Location_Service_regOk", null);
                _b020.proxySessionID = _b012.serviceSessionID;
                _b020.subscribe();
                _state = s_4;
                return CONSUME_SIGNAL;
            } else {
                _b014.unexpectedSignal(_b014_o2);
                return CONSUME_SIGNAL;
            }
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c2_c0_Location_Service_stop(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_7 || _state == s_10 || _state == s_3 || _state == s_5 || _state == s_4) {
            scheduler.sendToParent(this,"_c2_c0_Location_Service_regFailed", null);
            //TERMINATING SESSION VIA regFailed;
            -- sessionCount;
            return TERMINATE_MACHINE;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c2_c0_Location_Service_register(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_0) {
                    _data = ((java.util.Map<String, Object>) _data).get("_data");
            _b012.createServiceSessionID();
            _b013.registerEntry = _b012.createRegisterEntry();
            _b014.registerEntry = _b013.registerEntry;
            _b015.remote = _b014.getRegisterAddress();
            _b015.subscribe();
            scheduler.startTimer(0, "t0", this);
            _state = s_3;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public int fireTimer(java.lang.String _timerID){
        if(_timerID.equals("t1")) {
            return handleTimer_t1();
        } else if(_timerID.equals("t0")) {
            return handleTimer_t0();
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t1(){
        if(_state == s_3) {
            _b015.unsubscribe();
            _b011.registerFail();
            _state = s_7;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t0(){
        if(_state == s_3) {
            _b015.send(_b014.createRegisterMessage());
            scheduler.startTimer(10000, "t1", this);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public java.lang.String getPartName(){
        return null;
    }

    public java.lang.String getId(){
        return this._stateMachineID;
    }
}
