package no.ntnu.item.arctis.examples.android.cityguide.grouppositioningserviceproxy;

import no.ntnu.item.arctis.library.proxies.Address;
import no.ntnu.item.arctis.library.proxies.Message;
import no.ntnu.item.arctis.runtime.Block;

public class GroupPositioningServiceProxy extends Block{
	

	public no.ntnu.item.arctis.library.proxies.Message message;
	public no.ntnu.item.arctis.library.objects.login.Credentials cred;

	public void found(Address addr) {
		System.out.println("Group Positioning Service is found.."+addr.toString());
	}

	public void notfound() {
			System.out.println("Group Positioning Service is not found..");
	}

	public Message createPinMessage() {
		System.out.println("creating pin msg at Group Positioning Service proxy");
		Message m = new Message("grouppositioning");
		m.setPayload(""+cred.getUserName());
		return m;
	}

	public String extractMessage(Message msg) {
	
		System.out.println("received message from Server at Group Positioning Service proxy......"+msg);
		
		//Location loc = new Location();
		
		if (msg.getPayload() instanceof String){	
			String  str = (String)  msg.getPayload();
			
			return str;
			
			/*
			// not get the location 
			double latitude = Double.valueOf(str.split("_")[0]);
			double longitude = Double.valueOf(str.split("_")[1]);
			
			System.out.println("after parsing in extractMessage of Group Positioning Service Proxy.. "+ "lat lon "+ latitude + " "+ longitude);
			
			loc.setLatitude(latitude);
			loc.setLongitude(longitude);
			return loc;
			 */
		}
		else {
			// to do
			return (String) msg.getPayload();
		}
	}

}