package no.ntnu.item.arctis.examples.android.cityguide.serverconnectiondialog;

import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.view.KeyEvent;
import no.ntnu.item.arctis.examples.android.cityguide.getperiodiclocationupdates.LocationService;
import no.ntnu.item.arctis.library.proxies.actorrouter.android.ActorframeContainer;
import no.ntnu.item.arctis.runtime.Block;
import no.ntnu.item.arctis.runtime.android.AndroidBlock;

public class ServerConnectionDialog extends AndroidBlock {

	private static ServerConnectionDialog serverConnectionDialog;
	private static ProgressDialog processDialog;
	
	public android.app.Activity act;

	public ServerConnectionDialog() {
		serverConnectionDialog = this;
	}

	public static ServerConnectionDialog getInstance(){
		return serverConnectionDialog;
	}

	public void startDialog() {
		android.content.Intent intent = new android.content.Intent((android.content.Context)getProperty("androidContext"), ServerConnectionActivity.class);
		intent.setFlags(android.content.Intent.FLAG_ACTIVITY_NEW_TASK);
		((android.content.Context)getProperty("androidContext")).startActivity(intent);

	}

	public void closeDialog() {

		System.out.println("Connection Established and Closing Server Connection Dialog..");
		
		this.processDialog.dismiss();
		((ServerConnectionActivity)act).getServerConnDialog().dismiss();
		act.finish();

		return ;
	}

	public void sendFromActivityToBlock(String signal, Object data, Object act){
		this.act = (ServerConnectionActivity)act;
		sendToBlock(signal,data);
	}

	public void backKeyClicked(String signal, Object act){
		this.act = (ServerConnectionActivity)act;
		sendToBlock(signal);
	}

	public void exitFromDialog() {
		System.out.println("Exiting from Server Connection Dialog..");

		/*	
		if(ActorframeContainer.getContext() !=null){
			ActorframeContainer.getContext().killActorFrameModel();
			ActorframeContainer.getContext().stopSelf();	
		}

		if(LocationService.getInstance() !=null){
			LocationService.getInstance().stopSelf();
		}	*/

		//android.os.Process.killProcess(android.os.Process.myPid());

		act.finish();
		
		android.os.Process.killProcess(android.os.Process.myPid());
		
	}

	public void closeProgressDialog() {
	}

	public String showProgressDialog(String str) {
		
		if(str!=null){setProperty("server-ip-address", str);}
		else {setProperty("server-ip-address", "");}
		
		Runnable r = new Runnable() {		
			@Override
			public void run() {
				processDialog = ProgressDialog.show(act, "","Please wait, connecting to server...", true);
				
				processDialog.setOnKeyListener(new DialogInterface.OnKeyListener() {
					
					@Override
					public boolean onKey(DialogInterface dialog, int keyCode, KeyEvent event) {
						// TODO Auto-generated method stub
						switch (keyCode) {
						case KeyEvent.KEYCODE_MENU:	
						case KeyEvent.KEYCODE_BACK:
							if(processDialog.isShowing()){
								System.out.println("Exit Progress Dialog?");   	
								sendToBlock("BACK");
								processDialog.dismiss();
							}
							break;
						} 
						return false;
					}
				});
			}
		};
		getHandler().post(r);

		return str;
	}

}
