package no.ntnu.item.arctis.library.proxies.actorrouter.android;


import java.io.FileNotFoundException;
import java.io.InputStream;

import android.util.Log;

import no.tellu.common.application.Application;
import no.tellu.common.javaframe.ApplicationSpec;
import no.tellu.j2se.actorframe.ActorSpecParserAndroid;

public class UserApplication extends Application{
	public UserApplication(InputStream inp) throws FileNotFoundException {
		try{
			ApplicationSpec spec = new ApplicationSpec();
	        ActorSpecParserAndroid.parseXml(inp, spec);
	        setApplicationSpec(spec);
	        Log.v("UserApplication","Application configured");
        } 
		catch(Exception e){
			Log.e("UserApplication", "FAILED TO CONFIGRE APPLICATION");
			Log.e("UserApplication", e.toString());
			
		}		
	}
	
	
	// constructor added for new spec
	public UserApplication(ApplicationSpec newSpec){
		setApplicationSpec(newSpec);
	}
}
