package no.ntnu.item.arctis.examples.android.cityguide.cityguideapp.app;

import android.location.Location;
import no.ntnu.item.arctis.library.objects.login.Credentials;
import no.ntnu.item.arctis.library.proxies.Address;
import no.ntnu.item.arctis.runtime.android.AndroidBlock;

public class App extends AndroidBlock {



	public void setRegistryAddress() {
		Address registry = new Address();
		registry.setPort("52000");
		registry.setIP("localhost");
		registry.setSessionID("registry");
		setProperty("register-address", registry);
	}

	public Address getLocalAddress() {
		Address local = new Address();
		local.setPort("52000");
		local.setIP("localhost");
		setProperty("local-address", local);
		return local;
	}

	public void setAndroidContext() {
		System.out.println("Setting android context...");
		android.content.Context context = getContext();
		setProperty("androidContext", context);
	}

	public void registerOk() {
		System.out.println("City Guide App, Register OK..");
	}

}