 package no.ntnu.item.arctis.examples.android.cityguide.instantmessagingui;


import no.ntnu.item.arctis.library.objects.quiz.InstantMessage;
import no.ntnu.item.arctis.runtime.android.AndroidBlock;

public class InstantMessagingUI extends AndroidBlock {
      
   

      private static InstantMessagingUI instantMessagingUI;
	  public android.app.Activity activity;
	public no.ntnu.item.arctis.library.objects.login.Credentials cred;
	public java.lang.Object part;
	public java.lang.String receivedMsg;
	public boolean isFirst = true;
	public java.util.HashMap<java.lang.String,java.lang.String> sessionCheck;
	

	  public InstantMessagingUI(){
	   
	   instantMessagingUI = this;
	}

	  public static InstantMessagingUI getInstance(){
		return instantMessagingUI;
	}
	
	public void sendFromActivityToBlock(String signal, Object data){
		sendToBlock(signal,data);
	}

	public void sendFromActivityToBlock(String signal){
		sendToBlock(signal);
	}

	public void startActivity() {
	System.out.println("in startActivity..");

		android.content.Intent intent = new android.content.Intent((android.content.Context)getProperty("androidContext"), MessagingActivity.class);
		intent.setFlags(android.content.Intent.FLAG_ACTIVITY_NEW_TASK);
		((android.content.Context) getProperty("androidContext")).startActivity(intent);
		
	}

	public void updateMessageHistory(InstantMessage msg) {
	System.out.println("Reply message displaying..");
	// update IM with new message from other player.
		MessagingActivity vs = (MessagingActivity)this.activity;
		vs.showNewMessage(msg);
	}

	public void cred() {
	}

	public void setUsername() {
	    String user = cred.getUserName();
		MessagingActivity us = (MessagingActivity)this.activity;
		us.parseUsername(user);
	}

	public void fetchGroupMembers(String xlm) {
	}

	public void setChatPartnerName() {
	if(part==null){
	String str[] = receivedMsg.split("#");
	System.out.println("Alternate   "+str[0] + str[1] +str[2]);
	String partner = str[0];
	MessagingActivity ws = (MessagingActivity)this.activity;
	 ws.parseChatPartner(partner);
	 
	   InstantMessagingUI.getInstance().sendFromActivityToBlock("SHOW");
	}
	
	 String chatpartner = (String) part;
	 MessagingActivity ws = (MessagingActivity)this.activity;
	 ws.parseChatPartner(chatpartner);
	}

	public void showFirstReply() {
	
	// update IM with new message from other player.
	//String str[] = receivedMsg.split("#");
	/*InstantMessage msg = new InstantMessage();
	msg.setMessageText(str[2]);*/
	//System.out.println("FirstReply message displaying.."+str[2]);
		MessagingActivity vs = (MessagingActivity)this.activity;
		vs.replyMessage(receivedMsg);
	}

	public Boolean checkPart() {
	if(activity!=null) return true;
		
		else return false;
	
	/*if(part==null){
	return true;
	}
	return false;*/
	}

	/*public void toggleIsFirst() {
	isFirst= false;
	}*/

	public void otherMessages() {
	System.out.println("Subsequent messages displaying..");
	// update IM with new message from other player.
	String str[] = receivedMsg.split("#");
	InstantMessage msg = new InstantMessage();
	msg.setMessageText(str[2]);
		MessagingActivity vs = (MessagingActivity)this.activity;
		vs.showNewMessage(msg);
	}

	public void destroyAct() {
	this.activity.finish();
	activity=null;
	part=null;
	}

}
