package no.ntnu.item.arctis.examples.android.cityguide.loginserviceproxy;

import no.ntnu.item.arctis.library.proxies.Address;
import no.ntnu.item.arctis.library.proxies.Message;
import no.ntnu.item.arctis.runtime.Block;

public class LoginServiceProxy extends Block {

	

	public no.ntnu.item.arctis.library.proxies.Message message;

	public void found(Address addr) {
		System.out.println("Login service is found.."+addr.toString());
	}

	public void notfound() {
			System.out.println("Login service is not found..");
	}

	public Message createPinMessage(String pincode) {
		System.out.println("creating pin msg at Login service proxy");
		Message m = new Message("login");
		m.setPayload(pincode);
		return m;
	}

	public boolean extractMessage(Message msg) {
	
		System.out.println("received message from Login Server at Login service proxy......"+msg);
		
		if (msg.getPayload() instanceof String){	
			String  str = (String)  msg.getPayload();
			if(str.equalsIgnoreCase("true")) {
				return true;
			} else {
				return false;
			}
		}
		else {
			return (Boolean) msg.getPayload();
		}
	}

}
