package no.ntnu.item.arctis.library.android.location.gpsstatus;

import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import android.content.Context;
import android.location.LocationManager;
import android.location.LocationProvider;

public class GPSStatus extends AndroidBlock {

	public LocationManager locManager;
	private LocationProvider locationProvider;

	public boolean isGPSEnabled() {
		return locManager.isProviderEnabled(LocationManager.GPS_PROVIDER);
	}

	public boolean isSupported() {
		locManager = (LocationManager) getContext().getSystemService(Context.LOCATION_SERVICE);
		locationProvider = locManager.getProvider(LocationManager.GPS_PROVIDER);
		if (locationProvider != null) {
			return true;
		} else {
			return false;
		}
	}
}