package no.ntnu.item.arctis.library.android.location.isgpsenabled;

import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import android.content.Context;
import android.location.LocationManager;
import android.location.LocationProvider;

public class IsGPSEnabled extends AndroidBlock {

	public LocationManager locManager;
	private LocationProvider locationProvider;

	public boolean isGPSEnabled() {
		if (locManager.isProviderEnabled("gps")) {
			return true;
		} else {
			return false;
		}
	}

	public boolean isSupported() {
		locManager = (LocationManager) getContext().getSystemService(Context.LOCATION_SERVICE);
		locationProvider = locManager.getProvider("gps");
		if (locationProvider != null) {
			return true;
		} else {
			return false;
		}
	}
}