package no.ntnu.item.arctis.library.android.checkconnection;

import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import android.content.Context;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;

public class CheckConnection extends AndroidBlock {

	public boolean isConnected() {
		ConnectivityManager c = (ConnectivityManager) getContext().getSystemService(Context.CONNECTIVITY_SERVICE);
		for (NetworkInfo n : c.getAllNetworkInfo()) {
			if (n.isConnected()) {
				return true;
			}
		}
		return false;
	}

}
