package no.ntnu.item.arctis.library.android.loginui;

import no.ntnu.item.arctis.android.R;
import no.ntnu.item.arctis.library.android.alc.ArctisAndroidActivity;
import android.content.SharedPreferences;
import android.content.pm.ActivityInfo;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.view.Window;
import android.widget.CheckBox;
import android.widget.TextView;

public class LoginUIActivity extends ArctisAndroidActivity {
	
	public void onCreate(Bundle savedInstanceState) {
		setTheme(android.R.style.Theme_Dialog);
		requestWindowFeature(Window.FEATURE_NO_TITLE);
		setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
		setContentView(no.ntnu.item.arctis.android.R.layout.login);
		
		TextView username = (TextView) findViewById(R.id.loginDialogUsername);
		TextView password = (TextView) findViewById(R.id.loginDialogPassword);
		CheckBox savePassword = (CheckBox) findViewById(R.id.loginDialogSavePassword);
		
		SharedPreferences prefs = PreferenceManager.getDefaultSharedPreferences(this);
		username.setText(prefs.getString(LoginUI.USERNAME_KEY, ""));
		password.setText(prefs.getString(LoginUI.PASSWORD_KEY, ""));
		savePassword.setChecked(prefs.contains(LoginUI.PASSWORD_KEY) && prefs.getString(LoginUI.PASSWORD_KEY, "").length() > 0);
		
		super.onCreate(savedInstanceState);
	}

}
