package no.ntnu.item.arctis.library.android.sendemail;

import no.ntnu.item.arctis.library.objects.email.Email;
import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import android.content.Intent;

public class SendEmail extends AndroidBlock {

	public void sendEmail(Email email) {
		Intent emailIntent = new Intent(android.content.Intent.ACTION_SEND);
		emailIntent.putExtra(android.content.Intent.EXTRA_EMAIL, email.to);
		emailIntent.putExtra(android.content.Intent.EXTRA_SUBJECT, email.subject);
		emailIntent.putExtra(android.content.Intent.EXTRA_TEXT, email.body);
		emailIntent.setType("text/plain");
		getContext().startActivity(emailIntent);
		// startActivity(Intent.createChooser(emailIntent,
		// "Send error report..."));
	}

}
