package no.ntnu.item.arctis.library.android.speech4;

import java.util.HashMap;

import android.speech.tts.TextToSpeech;

import no.ntnu.item.arctis.runtime.android.AndroidBlock;

public class Speech4 extends AndroidBlock {

	public android.speech.tts.TextToSpeech engine;

	public void speak(final java.lang.String text) {
		engine = new TextToSpeech(getContext(), new TextToSpeech.OnInitListener() {
			public void onInit(int status) {
				if (status == TextToSpeech.SUCCESS) {
					HashMap<String, String> params = new HashMap<String, String>();
					params.put(TextToSpeech.Engine.KEY_PARAM_UTTERANCE_ID, blockID);
					engine.speak(text, TextToSpeech.QUEUE_ADD, params);
				} else {
					log("Speech synthesis failed.");
				}
			}
		});
	}
}