package no.ntnu.item.arctis.library.android.startactivity;

import no.ntnu.item.arctis.runtime.AbstractRuntime;
import no.ntnu.item.arctis.runtime.IArctisBuildingBlock;
import android.content.Context;
import android.content.Intent;

public class StartActivity implements IArctisBuildingBlock {

	private String blockID;

	public void setBlockID(String blockID) {
		this.blockID = blockID;
	}

	public void startActivity(Class<?> activityClass) {
		Context context = (Context) AbstractRuntime.getRuntime(blockID).getContext("Android");
		Intent intent = new Intent(context, activityClass);
		context.startActivity(intent);
	}
}