package no.item.ntnu.arctis.examples.cityguide.cityguideserver.component;


public class Block_AddressServiceProxySM extends no.ntnu.item.arctis.runtime.IStateMachine {


    protected no.ntnu.item.arctis.runtime.Scheduler scheduler;
    protected java.lang.String _stateMachineID;
    private final static int s_0 = 0, s_3 = 3, s_2 = 2;
    private no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy _b020;
    private no.item.ntnu.arctis.examples.cityguide.block_addressserviceproxy.Block_AddressServiceProxy _b019;
    private no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy _b022;
    private no.ntnu.item.arctis.library.discovery.discoverservice.DiscoverService _b021;
    private static java.util.Hashtable _alias = new java.util.Hashtable();
    private static int sessionCount = 0;

    public Block_AddressServiceProxySM(no.ntnu.item.arctis.runtime.Scheduler scheduler, java.lang.String sessionID, java.lang.String parentSessionID) {
        super(sessionID, parentSessionID);
        this.scheduler = scheduler;
        ++ sessionCount;
    }


    protected void registerAlias(java.lang.String alias, java.lang.String sessionID){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided alias is null", null);
        if(sessionID==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided sessionID is null", null);
        if(_alias.containsKey(alias)) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("A session with alias " + alias + " already exists.", null);
        _alias.put(alias, sessionID);
    }

    public static java.lang.String findSession(java.lang.String alias){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Try to find session for null alias", null);
        String sessionID = (String) _alias.get(alias);
        if(sessionID==null) {
            if(!_alias.contains(alias)) {
        	       no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map does not contain alias " + alias, null);
            } else {
                no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map has a null entry for alias " + alias, null);
            }
        }
return sessionID;
    }

    public int getSessionCount(){
        return sessionCount;
    }

    public static java.util.Collection allSessions(){
        return _alias.values();
    }

    public int fireInitial(){
        _b021 = new no.ntnu.item.arctis.library.discovery.discoverservice.DiscoverService("Block_Address");
        _b021.setBlockID("_b021", sessionID);
        _b022 = new no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy("", "");
        _b022.setBlockID("_b022", sessionID);
        _b019 = new no.item.ntnu.arctis.examples.cityguide.block_addressserviceproxy.Block_AddressServiceProxy();
        _b019.setBlockID("_b019", sessionID);
        _b020 = new no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy("", "");
        _b020.setBlockID("_b020", sessionID);
        _state = s_0;
        return CONSUME_SIGNAL;
    }

    public int fire(java.lang.Object _sender, java.lang.Object sessionID, java.lang.String _signalID, java.lang.Object _data){
        if(_signalID.equals("RECEIVE__b020")) {
            return handleSignal_RECEIVE__b020(_sender, sessionID, _data);
        } else if(_signalID.equals("_c1_c3_Block_Address_Service_Proxy_reqAdd")) {
            return handleSignal__c1_c3_Block_Address_Service_Proxy_reqAdd(_sender, sessionID, _data);
        } else if(_signalID.equals("RECEIVE__b022")) {
            return handleSignal_RECEIVE__b022(_sender, sessionID, _data);
        } else if(_signalID.equals("_c1_c3_Block_Address_Service_Proxy_start")) {
            return handleSignal__c1_c3_Block_Address_Service_Proxy_start(_sender, sessionID, _data);
        }
        return TRIGGER_UNKNOWN;
    }

    private int handleSignal_RECEIVE__b020(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_2) {
            no.ntnu.item.arctis.library.proxies.Message _b020_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            scheduler.sendToParent(this,"_c1_c3_Block_Address_Service_Proxy_str", _b019.extractMessage(_b020_r0_message));
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c1_c3_Block_Address_Service_Proxy_reqAdd(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_2) {
            _b020.send(_b019.createPinMessage());
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_RECEIVE__b022(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_3) {
            no.ntnu.item.arctis.library.proxies.Message _b022_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b021.message = _b022_r0_message;
            java.lang.String _b021_o2 = _b021.getSignalID(_b021.message);
            if(_b021_o2.equals("ok")) {
                _b022.unsubscribe();
                no.ntnu.item.arctis.library.proxies.Address _b021_o3 = _b021.extractAddress(_b021.message);
                _b020.remote = _b021_o3;
                _b020.subscribe();
                _b019.found(_b021_o3);
                scheduler.sendToParent(this,"_c1_c3_Block_Address_Service_Proxy_ok", null);
                _state = s_2;
                return CONSUME_SIGNAL;
            } else {
                _b022.unsubscribe();
                _b019.notfound();
                return TERMINATE_MACHINE;
            }
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c1_c3_Block_Address_Service_Proxy_start(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_0) {
                    _data = ((java.util.Map<String, Object>) _data).get("_data");
            _b019.startDiscover();
            _b022.remote = _b021.getRegisterAddress();
            _b022.subscribe();
            scheduler.startTimer(0, "t0", this);
            _state = s_3;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public int fireTimer(java.lang.String _timerID){
        if(_timerID.equals("t1")) {
            return handleTimer_t1();
        } else if(_timerID.equals("t0")) {
            return handleTimer_t0();
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t1(){
        if(_state == s_3) {
            _b021.logTimeout();
            _b022.unsubscribe();
            _b019.notfound();
            return TERMINATE_MACHINE;
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t0(){
        if(_state == s_3) {
            _b022.send(_b021.createDiscoverMessage());
            scheduler.startTimer(10000, "t1", this);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public java.lang.String getPartName(){
        return null;
    }

    public java.lang.String getId(){
        return this._stateMachineID;
    }
}
