package no.item.ntnu.arctis.examples.cityguide.cityguideserver.component;


public class GroupChatServiceSM extends no.ntnu.item.arctis.runtime.IStateMachine {


    protected no.ntnu.item.arctis.runtime.Scheduler scheduler;
    protected java.lang.String _stateMachineID;
    private final static int s_0 = 0, s_4 = 4, s_2 = 2, s_7 = 7, s_3 = 3;
    private no.ntnu.item.arctis.library.discovery.genericservice.GenericService _b056;
    private no.ntnu.item.arctis.library.proxies.serverproxy.ServerProxy _b064;
    private no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy _b059;
    private no.ntnu.item.arctis.library.discovery.deregisterservice.DeregisterService _b061;
    private no.item.ntnu.arctis.examples.cityguide.groupchatservice.GroupChatService _b055;
    private no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy _b062;
    private no.ntnu.item.arctis.library.discovery.registerandderegisterservice.RegisterandDeregisterService _b057;
    private no.ntnu.item.arctis.library.discovery.registerservice.RegisterService _b058;
    private static java.util.Hashtable _alias = new java.util.Hashtable();
    private static int sessionCount = 0;

    public GroupChatServiceSM(no.ntnu.item.arctis.runtime.Scheduler scheduler, java.lang.String sessionID, java.lang.String parentSessionID) {
        super(sessionID, parentSessionID);
        this.scheduler = scheduler;
        ++ sessionCount;
    }


    protected void registerAlias(java.lang.String alias, java.lang.String sessionID){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided alias is null", null);
        if(sessionID==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided sessionID is null", null);
        if(_alias.containsKey(alias)) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("A session with alias " + alias + " already exists.", null);
        _alias.put(alias, sessionID);
    }

    public static java.lang.String findSession(java.lang.String alias){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Try to find session for null alias", null);
        String sessionID = (String) _alias.get(alias);
        if(sessionID==null) {
            if(!_alias.contains(alias)) {
        	       no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map does not contain alias " + alias, null);
            } else {
                no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map has a null entry for alias " + alias, null);
            }
        }
return sessionID;
    }

    public int getSessionCount(){
        return sessionCount;
    }

    public static java.util.Collection allSessions(){
        return _alias.values();
    }

    public int fireInitial(){
        _b058 = new no.ntnu.item.arctis.library.discovery.registerservice.RegisterService();
        _b058.setBlockID("_b058", sessionID);
        _b057 = new no.ntnu.item.arctis.library.discovery.registerandderegisterservice.RegisterandDeregisterService();
        _b057.setBlockID("_b057", sessionID);
        _b062 = new no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy("", "");
        _b062.setBlockID("_b062", sessionID);
        _b055 = new no.item.ntnu.arctis.examples.cityguide.groupchatservice.GroupChatService();
        _b055.setBlockID("_b055", sessionID);
        _b061 = new no.ntnu.item.arctis.library.discovery.deregisterservice.DeregisterService();
        _b061.setBlockID("_b061", sessionID);
        _b059 = new no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy("", "");
        _b059.setBlockID("_b059", sessionID);
        _b064 = new no.ntnu.item.arctis.library.proxies.serverproxy.ServerProxy();
        _b064.setBlockID("_b064", sessionID);
        _b056 = new no.ntnu.item.arctis.library.discovery.genericservice.GenericService("GroupChat");
        _b056.setBlockID("_b056", sessionID);
        _state = s_0;
        return CONSUME_SIGNAL;
    }

    public int fire(java.lang.Object _sender, java.lang.Object sessionID, java.lang.String _signalID, java.lang.Object _data){
        if(_signalID.equals("RECEIVE__b059")) {
            return handleSignal_RECEIVE__b059(_sender, sessionID, _data);
        } else if(_signalID.equals("_c2_c3_GroupChat_Service_start")) {
            return handleSignal__c2_c3_GroupChat_Service_start(_sender, sessionID, _data);
        } else if(_signalID.equals("SEND__b055")) {
            return handleSignal_SEND__b055(_sender, sessionID, _data);
        } else if(_signalID.equals("RECEIVE__b064")) {
            return handleSignal_RECEIVE__b064(_sender, sessionID, _data);
        } else if(_signalID.equals("_c2_c3_GroupChat_Service_stop")) {
            return handleSignal__c2_c3_GroupChat_Service_stop(_sender, sessionID, _data);
        } else if(_signalID.equals("_c2_c3_GroupChat_Service_userGrpChtBlockID")) {
            return handleSignal__c2_c3_GroupChat_Service_userGrpChtBlockID(_sender, sessionID, _data);
        }
        return TRIGGER_UNKNOWN;
    }

    private int handleSignal_RECEIVE__b059(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_4) {
            no.ntnu.item.arctis.library.proxies.Message _b059_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            java.lang.String _b058_o2 = _b058.getSignalID(_b059_r0_message);
            if(_b058_o2.equals("failed")) {
                _b059.unsubscribe();
                _state = s_3;
                return CONSUME_SIGNAL;
            } else if(_b058_o2.equals("ok")) {
                _b059.unsubscribe();
                scheduler.sendToParent(this,"_c2_c3_GroupChat_Service_regOk", null);
                _b064.proxySessionID = _b056.serviceSessionID;
                _b064.subscribe();
                _state = s_2;
                return CONSUME_SIGNAL;
            } else {
                _b058.unexpectedSignal(_b058_o2);
                return CONSUME_SIGNAL;
            }
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c2_c3_GroupChat_Service_start(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_0) {
                    _data = ((java.util.Map<String, Object>) _data).get("_data");
            java.util.Vector<no.ntnu.item.arctis.library.objects.user.Group> _b055_start = (java.util.Vector<no.ntnu.item.arctis.library.objects.user.Group>) _data;
            _b055.grps = _b055_start;
            _b056.createServiceSessionID();
            _b057.registerEntry = _b056.createRegisterEntry();
            _b058.registerEntry = _b057.registerEntry;
            _b059.remote = _b058.getRegisterAddress();
            _b059.subscribe();
            scheduler.startTimer(0, "t0", this);
            _state = s_4;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_SEND__b055(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_7) {
            no.ntnu.item.arctis.library.proxies.Message _b055_r0_msg = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b064.send(_b055_r0_msg);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_RECEIVE__b064(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_2) {
            no.ntnu.item.arctis.library.proxies.Message _b064_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b055.message = _b064_r0_message;
            _b055.multicastMessage(_b055.message);
            _state = s_7;
            return CONSUME_SIGNAL;
        } else if(_state == s_7) {
            no.ntnu.item.arctis.library.proxies.Message _b064_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b055.message = _b064_r0_message;
            _b055.multicastMessage(_b055.message);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c2_c3_GroupChat_Service_stop(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_7 || _state == s_2 || _state == s_3 || _state == s_4) {
            //TERMINATING SESSION VIA regFailed;
            -- sessionCount;
            return TERMINATE_MACHINE;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c2_c3_GroupChat_Service_userGrpChtBlockID(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_3 || _state == s_2 || _state == s_4 || _state == s_7) {
            java.lang.String _b055_userGrpChtBlockID = (java.lang.String) _data;
            _b055.updateBlockAddr(_b055_userGrpChtBlockID);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public int fireTimer(java.lang.String _timerID){
        if(_timerID.equals("t1")) {
            return handleTimer_t1();
        } else if(_timerID.equals("t0")) {
            return handleTimer_t0();
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t1(){
        if(_state == s_4) {
            _b059.unsubscribe();
            _state = s_3;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t0(){
        if(_state == s_4) {
            _b059.send(_b058.createRegisterMessage());
            scheduler.startTimer(10000, "t1", this);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public java.lang.String getPartName(){
        return null;
    }

    public java.lang.String getId(){
        return this._stateMachineID;
    }
}
