package no.item.ntnu.arctis.examples.cityguide.cityguideserver.component;


public class LocationServiceProxySM extends no.ntnu.item.arctis.runtime.IStateMachine {


    protected no.ntnu.item.arctis.runtime.Scheduler scheduler;
    protected java.lang.String _stateMachineID;
    private final static int s_0 = 0, s_1 = 1, s_3 = 3;
    private no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy _b008;
    private no.item.ntnu.arctis.examples.cityguide.locationserviceproxy.LocationServiceProxy _b004;
    private no.ntnu.item.arctis.library.discovery.discoverservice.DiscoverService _b005;
    private no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy _b006;
    private static java.util.Hashtable _alias = new java.util.Hashtable();
    private static int sessionCount = 0;

    public LocationServiceProxySM(no.ntnu.item.arctis.runtime.Scheduler scheduler, java.lang.String sessionID, java.lang.String parentSessionID) {
        super(sessionID, parentSessionID);
        this.scheduler = scheduler;
        ++ sessionCount;
    }


    protected void registerAlias(java.lang.String alias, java.lang.String sessionID){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided alias is null", null);
        if(sessionID==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided sessionID is null", null);
        if(_alias.containsKey(alias)) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("A session with alias " + alias + " already exists.", null);
        _alias.put(alias, sessionID);
    }

    public static java.lang.String findSession(java.lang.String alias){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Try to find session for null alias", null);
        String sessionID = (String) _alias.get(alias);
        if(sessionID==null) {
            if(!_alias.contains(alias)) {
        	       no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map does not contain alias " + alias, null);
            } else {
                no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map has a null entry for alias " + alias, null);
            }
        }
return sessionID;
    }

    public int getSessionCount(){
        return sessionCount;
    }

    public static java.util.Collection allSessions(){
        return _alias.values();
    }

    public int fireInitial(){
        _b006 = new no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy("", "");
        _b006.setBlockID("_b006", sessionID);
        _b005 = new no.ntnu.item.arctis.library.discovery.discoverservice.DiscoverService("location");
        _b005.setBlockID("_b005", sessionID);
        _b004 = new no.item.ntnu.arctis.examples.cityguide.locationserviceproxy.LocationServiceProxy();
        _b004.setBlockID("_b004", sessionID);
        _b008 = new no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy("", "");
        _b008.setBlockID("_b008", sessionID);
        _state = s_0;
        return CONSUME_SIGNAL;
    }

    public int fire(java.lang.Object _sender, java.lang.Object sessionID, java.lang.String _signalID, java.lang.Object _data){
        if(_signalID.equals("RECEIVE__b006")) {
            return handleSignal_RECEIVE__b006(_sender, sessionID, _data);
        } else if(_signalID.equals("RECEIVE__b008")) {
            return handleSignal_RECEIVE__b008(_sender, sessionID, _data);
        } else if(_signalID.equals("_c1_c0_Location_Service_Proxy_reqLoc")) {
            return handleSignal__c1_c0_Location_Service_Proxy_reqLoc(_sender, sessionID, _data);
        } else if(_signalID.equals("_c1_c0_Location_Service_Proxy_start")) {
            return handleSignal__c1_c0_Location_Service_Proxy_start(_sender, sessionID, _data);
        }
        return TRIGGER_UNKNOWN;
    }

    private int handleSignal_RECEIVE__b006(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_1) {
            no.ntnu.item.arctis.library.proxies.Message _b006_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b005.message = _b006_r0_message;
            java.lang.String _b005_o2 = _b005.getSignalID(_b005.message);
            if(_b005_o2.equals("ok")) {
                _b006.unsubscribe();
                no.ntnu.item.arctis.library.proxies.Address _b005_o3 = _b005.extractAddress(_b005.message);
                _b008.remote = _b005_o3;
                _b008.subscribe();
                _b004.found(_b005_o3);
                scheduler.sendToParent(this,"_c1_c0_Location_Service_Proxy_ok", null);
                _state = s_3;
                return CONSUME_SIGNAL;
            } else {
                _b006.unsubscribe();
                _b004.notfound();
                scheduler.sendToParent(this,"_c1_c0_Location_Service_Proxy_nok", null);
                return TERMINATE_MACHINE;
            }
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_RECEIVE__b008(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_3) {
            no.ntnu.item.arctis.library.proxies.Message _b008_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            scheduler.sendToParent(this,"_c1_c0_Location_Service_Proxy_loc", _b004.extractMessage(_b008_r0_message));
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c1_c0_Location_Service_Proxy_reqLoc(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_3) {
            _b008.send(_b004.createPinMessage());
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c1_c0_Location_Service_Proxy_start(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_0) {
                    _data = ((java.util.Map<String, Object>) _data).get("_data");
            _b004.startDiscover();
            _b006.remote = _b005.getRegisterAddress();
            _b006.subscribe();
            scheduler.startTimer(0, "t0", this);
            _state = s_1;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public int fireTimer(java.lang.String _timerID){
        if(_timerID.equals("t1")) {
            return handleTimer_t1();
        } else if(_timerID.equals("t0")) {
            return handleTimer_t0();
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t1(){
        if(_state == s_1) {
            _b005.logTimeout();
            _b006.unsubscribe();
            _b004.notfound();
            scheduler.sendToParent(this,"_c1_c0_Location_Service_Proxy_nok", null);
            return TERMINATE_MACHINE;
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t0(){
        if(_state == s_1) {
            _b006.send(_b005.createDiscoverMessage());
            scheduler.startTimer(10000, "t1", this);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public java.lang.String getPartName(){
        return null;
    }

    public java.lang.String getId(){
        return this._stateMachineID;
    }
}
