package no.ntnu.item.arctis.library.proxies.actorrouter;



import no.ntnu.item.arctis.runtime.Block;
import no.tellu.common.javaframe.ActorAddress;

/*
 * This class is inherits from ActorSM, and implicitly also from StateMachine
 * which implements the MessageDrivenBean interface. You need not bother about the
 * details to this, because it is taken care of by the ActorFrame platform. The 
 * persistent data in the entity bean must have a local declaration here, and
 * the methods getData and storeData must retrieve the data from the Entity bean.
 */

public class RouterSM extends no.tellu.common.actorframe.ActorSM {

	public Block runtime ;
	
	public ActorAddress registryAddr = new ActorAddress("/routerRegistry", "Router");
	
	private static RouterSM routerSM;
	
	public RouterSM() {
	   super() ;
		myCompositeState = new RouterCS();
	}
	
   /**
    * Called if an sub type is initiated. Then the default constructor should 
    * not be used because new Composite state will be created
    */
    public RouterSM (String s) {
        super();
    }
    

    /**
     * Called when immediate after this actor instance has been created.
     * May be used for initiation of local data in instance. Note that other inner
     * actor or other statically initiated actors has not yet been created.
     */
    @Override
	protected void initInstance() {
        super.initInstance();    
        
        routerSM = this;
	}
    
    public static RouterSM getInstance(){
    	return routerSM;
    }
} 
