package no.item.ntnu.arctis.examples.cityguide.groupmanager;

import no.ntnu.item.arctis.library.objects.login.Credentials;
import no.ntnu.item.arctis.library.objects.user.Group;
import no.ntnu.item.arctis.library.objects.user.Player;
import no.ntnu.item.arctis.runtime.Block;

public class GroupManager extends Block {

	public java.util.Vector<Player> users;
	public java.util.Vector<Group> groups;
	

	public void startGM() {
		System.out.println("startGM..");
		
		LoadUserConfiguration conf = new LoadUserConfiguration();
		this.users = conf.getPlayers();
		this.groups = conf.getGroups();
	}


	public String uLoggedIn(Credentials cred) {
		return cred.getUserName();
	}


	public void loginRegistered() {
		System.out.println("Login Service is Registered..");
	}


	public void grpPosRegistered() {
			System.out.println("Group Positioning Service is Registered..");
	}


	public void imRegistered() {
	System.out.println("IM Service is Registered..");
	}


	public void grpChatRegistered() {
	
	System.out.println("Group Chat Service is Registered..");
	}


	
}
