package no.item.ntnu.arctis.examples.cityguide.locationawarequizserviceproxy;

import no.ntnu.item.arctis.library.objects.location.Location;
import no.ntnu.item.arctis.library.objects.quiz.Answer;
import no.ntnu.item.arctis.library.objects.quiz.Question;
import no.ntnu.item.arctis.library.proxies.Address;
import no.ntnu.item.arctis.library.proxies.Message;
import no.ntnu.item.arctis.runtime.Block;

public class LocationAwareQuizServiceProxy extends Block{



	public no.ntnu.item.arctis.library.proxies.Message message;

	public void found(Address addr) {
		System.out.println("Quiz Service is found.."+addr.toString());
	}

	public void notfound() {
			System.out.println("Quiz Service is not found..");
	}

	public Message createPinMessage(Question q) {
		System.out.println("creating  msg at Quiz pPoxy");
		Message m = new Message("quiz-q");
		m.setPayload(q.getQuestioText());
		return m;
	}

	public Answer extractMessage(Message msg) {
	
		System.out.println("received message from Quiz Server at Quiz proxy......"+msg);
		
		Answer ans = new Answer();
		
		if(msg.getPayload() instanceof String){
			System.out.println("msg.getPayload() instanceof Answer");
			ans.setAnswerText(msg.getPayload().toString());		
		}
		
		return ans;
		

		
		/*if (msg.getPayload() instanceof String){	
			String  str = (String)  msg.getPayload();
			// not get the location 
			double latitude = Double.valueOf(str.split("_")[0]);
			double longitude = Double.valueOf(str.split("_")[1]);
			loc.setLatitude(latitude);
			loc.setLongitude(longitude);
			return loc;
		}
		else {
			// to do
			return (Location) msg.getPayload();
		}*/
	}

}