package no.item.ntnu.arctis.examples.cityguide.quizhandler;

import java.util.List;
import java.util.Vector;

import no.ntnu.item.arctis.library.objects.location.Location;
import no.ntnu.item.arctis.library.objects.quiz.Answer;
import no.ntnu.item.arctis.library.objects.quiz.Game;
import no.ntnu.item.arctis.library.objects.quiz.Question;
import no.ntnu.item.arctis.library.objects.quiz.SessionQuestion;
import no.ntnu.item.arctis.library.objects.quiz.Treasures;
import no.ntnu.item.arctis.runtime.Block;

public class QuizHandler extends Block {

	public boolean isQuizActive;
	public no.ntnu.item.arctis.library.objects.location.Location loc;
	public no.ntnu.item.arctis.library.objects.location.Location loc1;
	public no.ntnu.item.arctis.library.objects.quiz.Game game;
	public int curQIndex = 0;
	public java.util.Vector<SessionQuestion> questions;

	public boolean start() {
		System.out.println("start QuizHandler...");
		return false;
	}

	public Question nextQuestion(int index) {
		System.out.println("nextQuestion..." + index);
		
		SessionQuestion q  = this.questions.get(index);
		
		Question q1 = new Question();
		q1.setQuestioText(q.getQuestionText().elementAt(0));
		System.out.println("q.getQuestionText().get(0) "+ q.getQuestionText().elementAt(0));
		
		return q1;
	}

	public boolean checkAnswer(Answer ans) {
		System.out.println("checkAnswer...");
		return true;
	}

	public boolean isQuestionAtLoc(Location loc) {
		System.out.println("isQuestionAtLoc...");
		
		int x1 = (int) this.loc1.getLatitude();
		int y1 = (int) this.loc1.getLongitude();
	
		for(int i=0; i<this.game.getTreasures().size(); i++){
			Treasures t = game.getTreasures().elementAt(i);
			
			int x11 = Integer.valueOf(Integer.toString(t.getXCoordinate()).substring(0, 2));
			int y11 = Integer.valueOf(Integer.toString(t.getYCoordinate()).substring(0, 2));
			
			if(x11 == x1 & y11 == y1){				
				if(t.getQuestions().size()>0)
				{
					System.out.println("there are questions at the location");
					return true;
				}
			}	
		}
		
		return false;
	}

	public Vector<SessionQuestion> activeQuestions(Location loc) {
		
		
		System.out.println("active questions");

		int x1 = (int) this.loc1.getLatitude();
		int y1 = (int) this.loc1.getLongitude();
	
		for(int i=0; i<this.game.getTreasures().size(); i++){	
			Treasures t = game.getTreasures().elementAt(i);
			
			int x11 = Integer.valueOf(Integer.toString(t.getXCoordinate()).substring(0, 2));
			int y11 = Integer.valueOf(Integer.toString(t.getYCoordinate()).substring(0, 2));
			
			if(x11 == x1 & y11 == y1){	
				if(t.getQuestions().size()>0){
					System.out.println("active questions list at the location");
					return t.getQuestions() ;
				}
			}	
		}
		
		System.out.println("NO active questions list at the location");
		return null;
	}

	public int IncCurIndex() {
		this.curQIndex = this.curQIndex+1;
		return this.curQIndex;
	}

	public boolean checkSize(int n) {
		if (n<=this.questions.size()){
			return true;
		}
		else
			return false;
	}

	public void print() {
		System.out.println("All questions are done...");
	}

}
