package no.ntnu.item.arctis.examples.android.cityguide.cityguideapp;

import android.app.Activity;
import android.content.Intent;
import android.content.pm.ActivityInfo;
import android.os.Bundle;
import no.ntnu.item.arctis.runtime.Logger;

public class StartServiceActivity extends Activity {

    protected void onCreate(Bundle savedInstanceState) {
        System.err.println(" XXXXX onCreate of StartServiceActivity called");
        try {
            super.onCreate(savedInstanceState);
            setVisible(false);
            setTitle("");
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
            Intent intent = new Intent(this, Start.class);
            startService(intent);
            finish();
        } catch (Throwable e) {
            e.printStackTrace();
            Logger logger = Logger.getLogger();
            if(logger!=null) {
            logger.applicationError("Exception in General Start Activity onStart()", e);
        }
        }
    }

}