package no.ntnu.item.arctis.examples.android.cityguide.cityguideapp.app;


public class AppSM extends no.ntnu.item.arctis.runtime.IStateMachine {


    protected no.ntnu.item.arctis.runtime.Scheduler scheduler;
    protected java.lang.String _stateMachineID;
    private final static int s_8 = 8, s_1 = 1, s_3 = 3, s_12 = 12, s_4 = 4, s_5 = 5, s_18 = 18, s_7 = 7, s_13 = 13, s_16 = 16, s_11 = 11, 
        s_14 = 14, s_17 = 17;
    private java.lang.String _City_Guide_App_c1;
    private java.lang.String _City_Guide_App_c2;
    private no.ntnu.item.arctis.examples.android.cityguide.serverconnectiondialog.ServerConnectionDialog _b075;
    private no.ntnu.item.arctis.library.proxies.proxyhost.ProxyHost _b008;
    private no.ntnu.item.arctis.examples.android.cityguide.cityguideapp.app.App _b000;
    private no.ntnu.item.arctis.library.proxies.actorrouter.ActorRouter _b009;
    private static java.util.Hashtable _alias = new java.util.Hashtable();
    private static int sessionCount = 0;

    public AppSM(no.ntnu.item.arctis.runtime.Scheduler scheduler, java.lang.String sessionID, java.lang.String parentSessionID) {
        super(sessionID, parentSessionID);
        this.scheduler = scheduler;
        ++ sessionCount;
    }


    protected void registerAlias(java.lang.String alias, java.lang.String sessionID){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided alias is null", null);
        if(sessionID==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided sessionID is null", null);
        if(_alias.containsKey(alias)) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("A session with alias " + alias + " already exists.", null);
        _alias.put(alias, sessionID);
    }

    public static java.lang.String findSession(java.lang.String alias){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Try to find session for null alias", null);
        String sessionID = (String) _alias.get(alias);
        if(sessionID==null) {
            if(!_alias.contains(alias)) {
        	       no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map does not contain alias " + alias, null);
            } else {
                no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map has a null entry for alias " + alias, null);
            }
        }
return sessionID;
    }

    public int getSessionCount(){
        return sessionCount;
    }

    public static java.util.Collection allSessions(){
        return _alias.values();
    }

    public int fireInitial(){
        _b009 = new no.ntnu.item.arctis.library.proxies.actorrouter.ActorRouter();
        _b009.setBlockID("_b009", sessionID);
        _b000 = new no.ntnu.item.arctis.examples.android.cityguide.cityguideapp.app.App();
        _b000.setBlockID("_b000", sessionID);
        _b008 = new no.ntnu.item.arctis.library.proxies.proxyhost.ProxyHost("AndroidClient-129.241.205.88-4445-5539");
        _b008.setBlockID("_b008", sessionID);
        _b075 = new no.ntnu.item.arctis.examples.android.cityguide.serverconnectiondialog.ServerConnectionDialog();
        _b075.setBlockID("_b075", sessionID);
        _b000.setAndroidContext();
        _b075.startDialog();
        _state = s_8;
        return CONSUME_SIGNAL;
    }

    public int fire(java.lang.Object _sender, java.lang.Object sessionID, java.lang.String _signalID, java.lang.Object _data){
        if(_signalID.equals("AFMSG__b009")) {
            return handleSignal_AFMSG__b009(_sender, sessionID, _data);
        } else if(_signalID.equals("_c1_Login_App_loggedOn")) {
            return handleSignal__c1_Login_App_loggedOn(_sender, sessionID, _data);
        } else if(_signalID.equals("_c2_City_Guide_UI_finished")) {
            return handleSignal__c2_City_Guide_UI_finished(_sender, sessionID, _data);
        } else if(_signalID.equals("SERVER_ADDRESS__b075")) {
            return handleSignal_SERVER_ADDRESS__b075(_sender, sessionID, _data);
        } else if(_signalID.equals("OUTBOUND__b008")) {
            return handleSignal_OUTBOUND__b008(_sender, sessionID, _data);
        } else if(_signalID.equals("BACK__b075")) {
            return handleSignal_BACK__b075(_sender, sessionID, _data);
        } else if(_signalID.equals("_c1_Login_App_cancel")) {
            return handleSignal__c1_Login_App_cancel(_sender, sessionID, _data);
        } else if(_signalID.equals("_c2_City_Guide_UI_regOk")) {
            return handleSignal__c2_City_Guide_UI_regOk(_sender, sessionID, _data);
        }
        return TRIGGER_UNKNOWN;
    }

    private int handleSignal_AFMSG__b009(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_17 || _state == s_18 || _state == s_3 || _state == s_11 || _state == s_4 || _state == s_13 || _state == s_12 || _state == s_14) {
            no.ntnu.item.arctis.library.proxies.Message _b009_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b008.receive(_b009_r0_message);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c1_Login_App_loggedOn(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_13 || _state == s_8) {
            no.ntnu.item.arctis.library.objects.login.Credentials _City_Guide_App_loggedOn = (no.ntnu.item.arctis.library.objects.login.Credentials) _data;
                        scheduler.sendToSession(this, _City_Guide_App_c2, "_c2_City_Guide_UI_loggedIn", _City_Guide_App_loggedOn);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c2_City_Guide_UI_finished(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_13) {
            scheduler.sendToSession(this, _City_Guide_App_c1, "_c1_Login_App_stop", null);
            _b008.stop();
            _state = s_7;
            return CONSUME_SIGNAL;
        } else if(_state == s_8) {
            scheduler.sendToSession(this, _City_Guide_App_c1, "_c1_Login_App_stop", null);
            _state = s_5;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_SERVER_ADDRESS__b075(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_8) {
            java.lang.String _b075_r0_addr = (java.lang.String) _data;
            _b075.showProgressDialog(_b075_r0_addr);
            _b000.setRegistryAddress();
            no.ntnu.item.arctis.library.proxies.Address _b000_o1 = _b000.getLocalAddress();
            _b008.local = _b000_o1;
            _b009.startAfRouter(_b008.getProxyType());
            scheduler.startTimer(10000, "t0", this);
            _state = s_13;
            return CONSUME_SIGNAL;
        } else if(_state == s_16) {
            java.lang.String _b075_r0_addr = (java.lang.String) _data;
            _b075.showProgressDialog(_b075_r0_addr);
            _b000.setRegistryAddress();
            no.ntnu.item.arctis.library.proxies.Address _b000_o1 = _b000.getLocalAddress();
            _b008.local = _b000_o1;
            _b009.startAfRouter(_b008.getProxyType());
            scheduler.startTimer(10000, "t0", this);
            _state = s_3;
            return CONSUME_SIGNAL;
        } else if(_state == s_5) {
            java.lang.String _b075_r0_addr = (java.lang.String) _data;
            _b075.showProgressDialog(_b075_r0_addr);
            _b000.setRegistryAddress();
            no.ntnu.item.arctis.library.proxies.Address _b000_o1 = _b000.getLocalAddress();
            _b008.local = _b000_o1;
            _b009.startAfRouter(_b008.getProxyType());
            scheduler.startTimer(10000, "t0", this);
            _state = s_18;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_OUTBOUND__b008(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_17 || _state == s_12 || _state == s_4 || _state == s_13 || _state == s_3 || _state == s_18 || _state == s_11 || _state == s_14) {
            no.ntnu.item.arctis.library.proxies.Message _b008_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b008.message = _b008_r0_message;
            if(_b008.isLocal()==true) {
                _b008.receive(_b008.message);
                return CONSUME_SIGNAL;
            } else {
                _b009.send2network(_b008.message);
                return CONSUME_SIGNAL;
            }
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_BACK__b075(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_17) {
            _b075.exitFromDialog();
            _state = s_11;
            return CONSUME_SIGNAL;
        } else if(_state == s_16 || _state == s_5 || _state == s_8 || _state == s_7 || _state == s_1) {
            _b075.exitFromDialog();
            return TERMINATE_MACHINE;
        } else if(_state == s_13) {
            _b075.exitFromDialog();
            _state = s_14;
            return CONSUME_SIGNAL;
        } else if(_state == s_3) {
            _b075.exitFromDialog();
            _state = s_12;
            return CONSUME_SIGNAL;
        } else if(_state == s_18) {
            _b075.exitFromDialog();
            _state = s_4;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c1_Login_App_cancel(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_13) {
            _state = s_17;
            return CONSUME_SIGNAL;
        } else if(_state == s_8) {
            _state = s_16;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c2_City_Guide_UI_regOk(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_8 || _state == s_13) {
            _City_Guide_App_c1 = scheduler.createFreshSessionID();
                    java.util.Map<String, Object> _City_Guide_App_c1_data = new java.util.HashMap<String,Object>();
                    scheduler.sendToSession(this, _City_Guide_App_c1, "_c1_Login_App_start", _City_Guide_App_c1_data);
            _b075.closeDialog();
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public int fireTimer(java.lang.String _timerID){
        if(_timerID.equals("t0")) {
            return handleTimer_t0();
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t0(){
        if(_state == s_18 || _state == s_3 || _state == s_13) {
            _City_Guide_App_c2 = scheduler.createFreshSessionID();
                    java.util.Map<String, Object> _City_Guide_App_c2_data = new java.util.HashMap<String,Object>();
                    scheduler.sendToSession(this, _City_Guide_App_c2, "_c2_City_Guide_UI_start", _City_Guide_App_c2_data);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public java.lang.String getPartName(){
        return null;
    }

    public java.lang.String getId(){
        return this._stateMachineID;
    }
}
