package no.ntnu.item.arctis.examples.android.cityguide.cityguideapp.app;


public class GroupPositioningServiceProxySM extends no.ntnu.item.arctis.runtime.IStateMachine {


    protected no.ntnu.item.arctis.runtime.Scheduler scheduler;
    protected java.lang.String _stateMachineID;
    private final static int s_0 = 0, s_1 = 1, s_3 = 3;
    private no.ntnu.item.arctis.examples.android.cityguide.grouppositioningserviceproxy.GroupPositioningServiceProxy _b034;
    private no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy _b036;
    private no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy _b038;
    private no.ntnu.item.arctis.library.discovery.discoverservice.DiscoverService _b035;
    private static java.util.Hashtable _alias = new java.util.Hashtable();
    private static int sessionCount = 0;

    public GroupPositioningServiceProxySM(no.ntnu.item.arctis.runtime.Scheduler scheduler, java.lang.String sessionID, java.lang.String parentSessionID) {
        super(sessionID, parentSessionID);
        this.scheduler = scheduler;
        ++ sessionCount;
    }


    protected void registerAlias(java.lang.String alias, java.lang.String sessionID){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided alias is null", null);
        if(sessionID==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided sessionID is null", null);
        if(_alias.containsKey(alias)) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("A session with alias " + alias + " already exists.", null);
        _alias.put(alias, sessionID);
    }

    public static java.lang.String findSession(java.lang.String alias){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Try to find session for null alias", null);
        String sessionID = (String) _alias.get(alias);
        if(sessionID==null) {
            if(!_alias.contains(alias)) {
        	       no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map does not contain alias " + alias, null);
            } else {
                no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map has a null entry for alias " + alias, null);
            }
        }
return sessionID;
    }

    public int getSessionCount(){
        return sessionCount;
    }

    public static java.util.Collection allSessions(){
        return _alias.values();
    }

    public int fireInitial(){
        _b035 = new no.ntnu.item.arctis.library.discovery.discoverservice.DiscoverService("grouppositioning");
        _b035.setBlockID("_b035", sessionID);
        _b038 = new no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy("", "");
        _b038.setBlockID("_b038", sessionID);
        _b036 = new no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy("", "");
        _b036.setBlockID("_b036", sessionID);
        _b034 = new no.ntnu.item.arctis.examples.android.cityguide.grouppositioningserviceproxy.GroupPositioningServiceProxy();
        _b034.setBlockID("_b034", sessionID);
        _state = s_0;
        return CONSUME_SIGNAL;
    }

    public int fire(java.lang.Object _sender, java.lang.Object sessionID, java.lang.String _signalID, java.lang.Object _data){
        if(_signalID.equals("_c2_c3_Group_Positioning_Service_Proxy_reqLoc")) {
            return handleSignal__c2_c3_Group_Positioning_Service_Proxy_reqLoc(_sender, sessionID, _data);
        } else if(_signalID.equals("RECEIVE__b036")) {
            return handleSignal_RECEIVE__b036(_sender, sessionID, _data);
        } else if(_signalID.equals("RECEIVE__b038")) {
            return handleSignal_RECEIVE__b038(_sender, sessionID, _data);
        } else if(_signalID.equals("_c2_c3_Group_Positioning_Service_Proxy_start")) {
            return handleSignal__c2_c3_Group_Positioning_Service_Proxy_start(_sender, sessionID, _data);
        }
        return TRIGGER_UNKNOWN;
    }

    private int handleSignal__c2_c3_Group_Positioning_Service_Proxy_reqLoc(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_3) {
            _b038.send(_b034.createPinMessage());
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_RECEIVE__b036(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_1) {
            no.ntnu.item.arctis.library.proxies.Message _b036_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b035.message = _b036_r0_message;
            java.lang.String _b035_o2 = _b035.getSignalID(_b035.message);
            if(_b035_o2.equals("ok")) {
                _b036.unsubscribe();
                no.ntnu.item.arctis.library.proxies.Address _b035_o3 = _b035.extractAddress(_b035.message);
                _b038.remote = _b035_o3;
                _b038.subscribe();
                _b034.found(_b035_o3);
                _state = s_3;
                return CONSUME_SIGNAL;
            } else {
                _b036.unsubscribe();
                _b034.notfound();
                //TERMINATING SESSION VIA failed;
                -- sessionCount;
                return TERMINATE_MACHINE;
            }
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_RECEIVE__b038(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_3) {
            no.ntnu.item.arctis.library.proxies.Message _b038_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            scheduler.sendToParent(this,"_c2_c3_Group_Positioning_Service_Proxy_loc", _b034.extractMessage(_b038_r0_message));
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c2_c3_Group_Positioning_Service_Proxy_start(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_0) {
                    _data = ((java.util.Map<String, Object>) _data).get("_data");
            no.ntnu.item.arctis.library.objects.login.Credentials _b034_start = (no.ntnu.item.arctis.library.objects.login.Credentials) _data;
            _b034.cred = _b034_start;
            _b036.remote = _b035.getRegisterAddress();
            _b036.subscribe();
            scheduler.startTimer(0, "t0", this);
            _state = s_1;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public int fireTimer(java.lang.String _timerID){
        if(_timerID.equals("t1")) {
            return handleTimer_t1();
        } else if(_timerID.equals("t0")) {
            return handleTimer_t0();
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t1(){
        if(_state == s_1) {
            _b035.logTimeout();
            _b036.unsubscribe();
            _b034.notfound();
            //TERMINATING SESSION VIA failed;
            -- sessionCount;
            return TERMINATE_MACHINE;
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t0(){
        if(_state == s_1) {
            _b036.send(_b035.createDiscoverMessage());
            scheduler.startTimer(10000, "t1", this);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public java.lang.String getPartName(){
        return null;
    }

    public java.lang.String getId(){
        return this._stateMachineID;
    }
}
