package no.ntnu.item.arctis.examples.android.cityguide.cityguideapp.app;


public class IMServiceProxySM extends no.ntnu.item.arctis.runtime.IStateMachine {


    protected no.ntnu.item.arctis.runtime.Scheduler scheduler;
    protected java.lang.String _stateMachineID;
    private final static int s_0 = 0, s_3 = 3, s_1 = 1;
    private no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy _b044;
    private no.ntnu.item.arctis.library.discovery.discoverservice.DiscoverService _b041;
    private no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy _b042;
    private no.ntnu.item.arctis.examples.android.cityguide.imserviceproxy.IMServiceProxy _b040;
    private static java.util.Hashtable _alias = new java.util.Hashtable();
    private static int sessionCount = 0;

    public IMServiceProxySM(no.ntnu.item.arctis.runtime.Scheduler scheduler, java.lang.String sessionID, java.lang.String parentSessionID) {
        super(sessionID, parentSessionID);
        this.scheduler = scheduler;
        ++ sessionCount;
    }


    protected void registerAlias(java.lang.String alias, java.lang.String sessionID){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided alias is null", null);
        if(sessionID==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided sessionID is null", null);
        if(_alias.containsKey(alias)) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("A session with alias " + alias + " already exists.", null);
        _alias.put(alias, sessionID);
    }

    public static java.lang.String findSession(java.lang.String alias){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Try to find session for null alias", null);
        String sessionID = (String) _alias.get(alias);
        if(sessionID==null) {
            if(!_alias.contains(alias)) {
        	       no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map does not contain alias " + alias, null);
            } else {
                no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map has a null entry for alias " + alias, null);
            }
        }
return sessionID;
    }

    public int getSessionCount(){
        return sessionCount;
    }

    public static java.util.Collection allSessions(){
        return _alias.values();
    }

    public int fireInitial(){
        _b040 = new no.ntnu.item.arctis.examples.android.cityguide.imserviceproxy.IMServiceProxy();
        _b040.setBlockID("_b040", sessionID);
        _b042 = new no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy("", "");
        _b042.setBlockID("_b042", sessionID);
        _b041 = new no.ntnu.item.arctis.library.discovery.discoverservice.DiscoverService("InstantMessaging");
        _b041.setBlockID("_b041", sessionID);
        _b044 = new no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy("", "");
        _b044.setBlockID("_b044", sessionID);
        _state = s_0;
        return CONSUME_SIGNAL;
    }

    public int fire(java.lang.Object _sender, java.lang.Object sessionID, java.lang.String _signalID, java.lang.Object _data){
        if(_signalID.equals("_c2_c4_c1_IM_Service_Proxy_start")) {
            return handleSignal__c2_c4_c1_IM_Service_Proxy_start(_sender, sessionID, _data);
        } else if(_signalID.equals("RECEIVE__b042")) {
            return handleSignal_RECEIVE__b042(_sender, sessionID, _data);
        } else if(_signalID.equals("_c2_c4_c1_IM_Service_Proxy_send")) {
            return handleSignal__c2_c4_c1_IM_Service_Proxy_send(_sender, sessionID, _data);
        } else if(_signalID.equals("RECEIVE__b044")) {
            return handleSignal_RECEIVE__b044(_sender, sessionID, _data);
        }
        return TRIGGER_UNKNOWN;
    }

    private int handleSignal__c2_c4_c1_IM_Service_Proxy_start(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_0) {
                    _data = ((java.util.Map<String, Object>) _data).get("_data");
            no.ntnu.item.arctis.library.objects.login.Credentials _b040_start = (no.ntnu.item.arctis.library.objects.login.Credentials) _data;
            _b040.cred = _b040_start;
            _b042.remote = _b041.getRegisterAddress();
            _b042.subscribe();
            scheduler.startTimer(0, "t0", this);
            _state = s_3;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_RECEIVE__b042(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_3) {
            no.ntnu.item.arctis.library.proxies.Message _b042_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b041.message = _b042_r0_message;
            java.lang.String _b041_o2 = _b041.getSignalID(_b041.message);
            if(_b041_o2.equals("ok")) {
                _b042.unsubscribe();
                no.ntnu.item.arctis.library.proxies.Address _b041_o3 = _b041.extractAddress(_b041.message);
                _b044.remote = _b041_o3;
                _b044.subscribe();
                _b040.found(_b041_o3);
                _state = s_1;
                return CONSUME_SIGNAL;
            } else {
                _b042.unsubscribe();
                _b040.notfound();
                scheduler.sendToParent(this,"_c2_c4_c1_IM_Service_Proxy_failed", null);
                //TERMINATING SESSION VIA failed;
                -- sessionCount;
                return TERMINATE_MACHINE;
            }
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c2_c4_c1_IM_Service_Proxy_send(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_1) {
            no.ntnu.item.arctis.library.objects.quiz.InstantMessage _b040_send = (no.ntnu.item.arctis.library.objects.quiz.InstantMessage) _data;
            _b044.send(_b040.createPinMessage(_b040_send));
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_RECEIVE__b044(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_1) {
            no.ntnu.item.arctis.library.proxies.Message _b044_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b040.extractMessage(_b044_r0_message);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public int fireTimer(java.lang.String _timerID){
        if(_timerID.equals("t1")) {
            return handleTimer_t1();
        } else if(_timerID.equals("t0")) {
            return handleTimer_t0();
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t1(){
        if(_state == s_3) {
            _b041.logTimeout();
            _b042.unsubscribe();
            _b040.notfound();
            scheduler.sendToParent(this,"_c2_c4_c1_IM_Service_Proxy_failed", null);
            //TERMINATING SESSION VIA failed;
            -- sessionCount;
            return TERMINATE_MACHINE;
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t0(){
        if(_state == s_3) {
            _b042.send(_b041.createDiscoverMessage());
            scheduler.startTimer(10000, "t1", this);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public java.lang.String getPartName(){
        return null;
    }

    public java.lang.String getId(){
        return this._stateMachineID;
    }
}
