package no.ntnu.item.arctis.examples.android.cityguide.cityguideapp.app;


public class LocationAwareQuizServiceSM extends no.ntnu.item.arctis.runtime.IStateMachine {


    protected no.ntnu.item.arctis.runtime.Scheduler scheduler;
    protected java.lang.String _stateMachineID;
    private final static int s_17 = 17, s_9 = 9, s_4 = 4, s_13 = 13, s_0 = 0, s_2 = 2, s_16 = 16, s_20 = 20, s_23 = 23, s_14 = 14, s_7 = 7, 
        s_8 = 8;
    private no.ntnu.item.arctis.library.discovery.registerservice.RegisterService _b025;
    private no.ntnu.item.arctis.library.discovery.genericservice.GenericService _b023;
    private no.ntnu.item.arctis.examples.android.cityguide.androidquizui.AndroidQuizUI _b032;
    private no.ntnu.item.arctis.library.discovery.deregisterservice.DeregisterService _b028;
    private no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy _b029;
    private no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy _b026;
    private no.ntnu.item.arctis.examples.android.cityguide.locationawarequizservice.LocationAwareQuizService _b022;
    private no.ntnu.item.arctis.library.discovery.registerandderegisterservice.RegisterandDeregisterService _b024;
    private no.ntnu.item.arctis.library.proxies.serverproxy.ServerProxy _b031;
    private static java.util.Hashtable _alias = new java.util.Hashtable();
    private static int sessionCount = 0;

    public LocationAwareQuizServiceSM(no.ntnu.item.arctis.runtime.Scheduler scheduler, java.lang.String sessionID, java.lang.String parentSessionID) {
        super(sessionID, parentSessionID);
        this.scheduler = scheduler;
        ++ sessionCount;
    }


    protected void registerAlias(java.lang.String alias, java.lang.String sessionID){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided alias is null", null);
        if(sessionID==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided sessionID is null", null);
        if(_alias.containsKey(alias)) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("A session with alias " + alias + " already exists.", null);
        _alias.put(alias, sessionID);
    }

    public static java.lang.String findSession(java.lang.String alias){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Try to find session for null alias", null);
        String sessionID = (String) _alias.get(alias);
        if(sessionID==null) {
            if(!_alias.contains(alias)) {
        	       no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map does not contain alias " + alias, null);
            } else {
                no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map has a null entry for alias " + alias, null);
            }
        }
return sessionID;
    }

    public int getSessionCount(){
        return sessionCount;
    }

    public static java.util.Collection allSessions(){
        return _alias.values();
    }

    public int fireInitial(){
        _b031 = new no.ntnu.item.arctis.library.proxies.serverproxy.ServerProxy();
        _b031.setBlockID("_b031", sessionID);
        _b024 = new no.ntnu.item.arctis.library.discovery.registerandderegisterservice.RegisterandDeregisterService();
        _b024.setBlockID("_b024", sessionID);
        _b022 = new no.ntnu.item.arctis.examples.android.cityguide.locationawarequizservice.LocationAwareQuizService();
        _b022.setBlockID("_b022", sessionID);
        _b026 = new no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy("", "");
        _b026.setBlockID("_b026", sessionID);
        _b029 = new no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy("", "");
        _b029.setBlockID("_b029", sessionID);
        _b028 = new no.ntnu.item.arctis.library.discovery.deregisterservice.DeregisterService();
        _b028.setBlockID("_b028", sessionID);
        _b032 = new no.ntnu.item.arctis.examples.android.cityguide.androidquizui.AndroidQuizUI();
        _b032.setBlockID("_b032", sessionID);
        _b023 = new no.ntnu.item.arctis.library.discovery.genericservice.GenericService("quiz");
        _b023.setBlockID("_b023", sessionID);
        _b025 = new no.ntnu.item.arctis.library.discovery.registerservice.RegisterService();
        _b025.setBlockID("_b025", sessionID);
        _state = s_0;
        return CONSUME_SIGNAL;
    }

    public int fire(java.lang.Object _sender, java.lang.Object sessionID, java.lang.String _signalID, java.lang.Object _data){
        if(_signalID.equals("_c2_c1_Location_Aware_Quiz_Service_register")) {
            return handleSignal__c2_c1_Location_Aware_Quiz_Service_register(_sender, sessionID, _data);
        } else if(_signalID.equals("ANSWER__b032")) {
            return handleSignal_ANSWER__b032(_sender, sessionID, _data);
        } else if(_signalID.equals("RECEIVE__b031")) {
            return handleSignal_RECEIVE__b031(_sender, sessionID, _data);
        } else if(_signalID.equals("_c2_c1_Location_Aware_Quiz_Service_stop")) {
            return handleSignal__c2_c1_Location_Aware_Quiz_Service_stop(_sender, sessionID, _data);
        } else if(_signalID.equals("CONTINUE__b032")) {
            return handleSignal_CONTINUE__b032(_sender, sessionID, _data);
        } else if(_signalID.equals("CREATED__b032")) {
            return handleSignal_CREATED__b032(_sender, sessionID, _data);
        } else if(_signalID.equals("RECEIVE__b026")) {
            return handleSignal_RECEIVE__b026(_sender, sessionID, _data);
        }
        return TRIGGER_UNKNOWN;
    }

    private int handleSignal__c2_c1_Location_Aware_Quiz_Service_register(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_0) {
                    _data = ((java.util.Map<String, Object>) _data).get("_data");
            _b023.createServiceSessionID();
            _b024.registerEntry = _b023.createRegisterEntry();
            _b025.registerEntry = _b024.registerEntry;
            _b026.remote = _b025.getRegisterAddress();
            _b026.subscribe();
            scheduler.startTimer(0, "t0", this);
            _state = s_2;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_ANSWER__b032(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_8) {
            no.ntnu.item.arctis.library.objects.quiz.Answer _b032_r0_ans = (no.ntnu.item.arctis.library.objects.quiz.Answer) _data;
            if(_b032.checkFinished(_b032_r0_ans)==true) {
                _b032.showSummary();
                _state = s_14;
                return CONSUME_SIGNAL;
            } else {
                _b032.incrIndex();
                _b032.updateQuestion(_b032.index);
                return CONSUME_SIGNAL;
            }
        } else if(_state == s_13) {
            no.ntnu.item.arctis.library.objects.quiz.Answer _b032_r0_ans = (no.ntnu.item.arctis.library.objects.quiz.Answer) _data;
            if(_b032.checkFinished(_b032_r0_ans)==true) {
                _b032.showSummary();
                _state = s_14;
                return CONSUME_SIGNAL;
            } else {
                _b032.incrIndex();
                _b032.updateQuestion(_b032.index);
                return CONSUME_SIGNAL;
            }
        } else if(_state == s_9) {
            no.ntnu.item.arctis.library.objects.quiz.Answer _b032_r0_ans = (no.ntnu.item.arctis.library.objects.quiz.Answer) _data;
            if(_b032.checkFinished(_b032_r0_ans)==true) {
                _b032.showSummary();
                _state = s_4;
                return CONSUME_SIGNAL;
            } else {
                _b032.incrIndex();
                _b032.updateQuestion(_b032.index);
                return CONSUME_SIGNAL;
            }
        } else if(_state == s_17) {
            no.ntnu.item.arctis.library.objects.quiz.Answer _b032_r0_ans = (no.ntnu.item.arctis.library.objects.quiz.Answer) _data;
            if(_b032.checkFinished(_b032_r0_ans)==true) {
                _b032.showSummary();
                _state = s_4;
                return CONSUME_SIGNAL;
            } else {
                _b032.incrIndex();
                _b032.updateQuestion(_b032.index);
                return CONSUME_SIGNAL;
            }
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_RECEIVE__b031(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_20) {
            no.ntnu.item.arctis.library.proxies.Message _b031_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b022.message = _b031_r0_message;
            _b032.questions = _b032.initQuestions(_b022.createQuestion(_b022.message));
            if(_b032.checkActExists()==true) {
                _b032.updateQuestion(_b032.index);
                _state = s_9;
                return CONSUME_SIGNAL;
            } else {
                _b032.startActivity();
                _state = s_7;
                return CONSUME_SIGNAL;
            }
        } else if(_state == s_17) {
            no.ntnu.item.arctis.library.proxies.Message _b031_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b022.message = _b031_r0_message;
            _b032.questions = _b032.initQuestions(_b022.createQuestion(_b022.message));
            if(_b032.checkActExists()==true) {
                _b032.updateQuestion(_b032.index);
                return CONSUME_SIGNAL;
            } else {
                _b032.startActivity();
                _state = s_13;
                return CONSUME_SIGNAL;
            }
        } else if(_state == s_7) {
            no.ntnu.item.arctis.library.proxies.Message _b031_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b022.message = _b031_r0_message;
            _b032.questions = _b032.initQuestions(_b022.createQuestion(_b022.message));
            if(_b032.checkActExists()==true) {
                _b032.updateQuestion(_b032.index);
                _state = s_8;
                return CONSUME_SIGNAL;
            } else {
                _b032.startActivity();
                return CONSUME_SIGNAL;
            }
        } else if(_state == s_8 || _state == s_13) {
            no.ntnu.item.arctis.library.proxies.Message _b031_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b022.message = _b031_r0_message;
            _b032.questions = _b032.initQuestions(_b022.createQuestion(_b022.message));
            if(_b032.checkActExists()==true) {
                _b032.updateQuestion(_b032.index);
                return CONSUME_SIGNAL;
            } else {
                _b032.startActivity();
                return CONSUME_SIGNAL;
            }
        } else if(_state == s_14) {
            no.ntnu.item.arctis.library.proxies.Message _b031_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b022.message = _b031_r0_message;
            _b032.questions = _b032.initQuestions(_b022.createQuestion(_b022.message));
            if(_b032.checkActExists()==true) {
                _b032.updateQuestion(_b032.index);
                _state = s_13;
                return CONSUME_SIGNAL;
            } else {
                _b032.startActivity();
                return CONSUME_SIGNAL;
            }
        } else if(_state == s_4) {
            no.ntnu.item.arctis.library.proxies.Message _b031_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b022.message = _b031_r0_message;
            _b032.questions = _b032.initQuestions(_b022.createQuestion(_b022.message));
            if(_b032.checkActExists()==true) {
                _b032.updateQuestion(_b032.index);
                _state = s_17;
                return CONSUME_SIGNAL;
            } else {
                _b032.startActivity();
                _state = s_14;
                return CONSUME_SIGNAL;
            }
        } else if(_state == s_23) {
            no.ntnu.item.arctis.library.proxies.Message _b031_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b022.message = _b031_r0_message;
            _b032.questions = _b032.initQuestions(_b022.createQuestion(_b022.message));
            if(_b032.checkActExists()==true) {
                _b032.updateQuestion(_b032.index);
                _state = s_9;
                return CONSUME_SIGNAL;
            } else {
                _b032.startActivity();
                _state = s_7;
                return CONSUME_SIGNAL;
            }
        } else if(_state == s_9) {
            no.ntnu.item.arctis.library.proxies.Message _b031_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b022.message = _b031_r0_message;
            _b032.questions = _b032.initQuestions(_b022.createQuestion(_b022.message));
            if(_b032.checkActExists()==true) {
                _b032.updateQuestion(_b032.index);
                return CONSUME_SIGNAL;
            } else {
                _b032.startActivity();
                _state = s_8;
                return CONSUME_SIGNAL;
            }
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c2_c1_Location_Aware_Quiz_Service_stop(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_20 || _state == s_8 || _state == s_13 || _state == s_16 || _state == s_23 || _state == s_4 || _state == s_9 || _state == s_2 || _state == s_7 || _state == s_17 || _state == s_14) {
            scheduler.sendToParent(this,"_c2_c1_Location_Aware_Quiz_Service_regFailed", null);
            //TERMINATING SESSION VIA regFailed;
            -- sessionCount;
            return TERMINATE_MACHINE;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_CONTINUE__b032(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_13) {
            no.ntnu.item.arctis.library.objects.quiz.Answer _b032_o6 = _b032.qaFinished();
            _b031.send(_b022.createMessage(_b032_o6));
            scheduler.sendToParent(this,"_c2_c1_Location_Aware_Quiz_Service_answered", null);
            _state = s_8;
            return CONSUME_SIGNAL;
        } else if(_state == s_17) {
            no.ntnu.item.arctis.library.objects.quiz.Answer _b032_o6 = _b032.qaFinished();
            _b031.send(_b022.createMessage(_b032_o6));
            scheduler.sendToParent(this,"_c2_c1_Location_Aware_Quiz_Service_answered", null);
            _state = s_9;
            return CONSUME_SIGNAL;
        } else if(_state == s_14) {
            no.ntnu.item.arctis.library.objects.quiz.Answer _b032_o6 = _b032.qaFinished();
            _b031.send(_b022.createMessage(_b032_o6));
            scheduler.sendToParent(this,"_c2_c1_Location_Aware_Quiz_Service_answered", null);
            _state = s_7;
            return CONSUME_SIGNAL;
        } else if(_state == s_4) {
            no.ntnu.item.arctis.library.objects.quiz.Answer _b032_o6 = _b032.qaFinished();
            _b031.send(_b022.createMessage(_b032_o6));
            scheduler.sendToParent(this,"_c2_c1_Location_Aware_Quiz_Service_answered", null);
            _state = s_23;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_CREATED__b032(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_14) {
            android.app.Activity _b032_r1_act = (android.app.Activity) _data;
            _b032.activity = _b032_r1_act;
            _b032.updateQuestion(_b032.index);
            _state = s_17;
            return CONSUME_SIGNAL;
        } else if(_state == s_8) {
            android.app.Activity _b032_r1_act = (android.app.Activity) _data;
            _b032.activity = _b032_r1_act;
            _b032.updateQuestion(_b032.index);
            _state = s_9;
            return CONSUME_SIGNAL;
        } else if(_state == s_7) {
            android.app.Activity _b032_r1_act = (android.app.Activity) _data;
            _b032.activity = _b032_r1_act;
            _b032.updateQuestion(_b032.index);
            _state = s_9;
            return CONSUME_SIGNAL;
        } else if(_state == s_13) {
            android.app.Activity _b032_r1_act = (android.app.Activity) _data;
            _b032.activity = _b032_r1_act;
            _b032.updateQuestion(_b032.index);
            _state = s_17;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_RECEIVE__b026(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_2) {
            no.ntnu.item.arctis.library.proxies.Message _b026_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            java.lang.String _b025_o2 = _b025.getSignalID(_b026_r0_message);
            if(_b025_o2.equals("failed")) {
                _b026.unsubscribe();
                _b022.registerFail();
                _state = s_16;
                return CONSUME_SIGNAL;
            } else if(_b025_o2.equals("ok")) {
                _b026.unsubscribe();
                _b032.startUI();
                _b022.registered();
                scheduler.sendToParent(this,"_c2_c1_Location_Aware_Quiz_Service_regOk", null);
                _b031.proxySessionID = _b023.serviceSessionID;
                _b031.subscribe();
                _state = s_20;
                return CONSUME_SIGNAL;
            } else {
                _b025.unexpectedSignal(_b025_o2);
                return CONSUME_SIGNAL;
            }
        }
        return DISCARD_SIGNAL;
    }

    public int fireTimer(java.lang.String _timerID){
        if(_timerID.equals("t1")) {
            return handleTimer_t1();
        } else if(_timerID.equals("t0")) {
            return handleTimer_t0();
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t1(){
        if(_state == s_2) {
            _b026.unsubscribe();
            _b022.registerFail();
            _state = s_16;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t0(){
        if(_state == s_2) {
            _b026.send(_b025.createRegisterMessage());
            scheduler.startTimer(10000, "t1", this);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public java.lang.String getPartName(){
        return null;
    }

    public java.lang.String getId(){
        return this._stateMachineID;
    }
}
