package no.ntnu.item.arctis.examples.android.cityguide.cityguideapp.app;


public class LoginAppSM extends no.ntnu.item.arctis.runtime.IStateMachine {


    protected no.ntnu.item.arctis.runtime.Scheduler scheduler;
    protected java.lang.String _stateMachineID;
    private final static int s_0 = 0, s_6 = 6, s_2 = 2, s_7 = 7, s_12 = 12, s_3 = 3, s_4 = 4;
    private no.ntnu.item.arctis.examples.android.cityguide.loginserviceproxy.LoginServiceProxy _b003;
    private no.ntnu.item.arctis.examples.android.cityguide.loginapp.LoginApp _b001;
    private no.ntnu.item.arctis.library.discovery.discoverservice.DiscoverService _b004;
    private no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy _b007;
    private no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy _b005;
    private no.ntnu.item.arctis.examples.android.cityguide.androidloginui.AndroidLoginUI _b002;
    private static java.util.Hashtable _alias = new java.util.Hashtable();
    private static int sessionCount = 0;

    public LoginAppSM(no.ntnu.item.arctis.runtime.Scheduler scheduler, java.lang.String sessionID, java.lang.String parentSessionID) {
        super(sessionID, parentSessionID);
        this.scheduler = scheduler;
        ++ sessionCount;
    }


    protected void registerAlias(java.lang.String alias, java.lang.String sessionID){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided alias is null", null);
        if(sessionID==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Provided sessionID is null", null);
        if(_alias.containsKey(alias)) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("A session with alias " + alias + " already exists.", null);
        _alias.put(alias, sessionID);
    }

    public static java.lang.String findSession(java.lang.String alias){
        if(alias==null) no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Try to find session for null alias", null);
        String sessionID = (String) _alias.get(alias);
        if(sessionID==null) {
            if(!_alias.contains(alias)) {
        	       no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map does not contain alias " + alias, null);
            } else {
                no.ntnu.item.arctis.runtime.Logger.getLogger().applicationError("Session map has a null entry for alias " + alias, null);
            }
        }
return sessionID;
    }

    public int getSessionCount(){
        return sessionCount;
    }

    public static java.util.Collection allSessions(){
        return _alias.values();
    }

    public int fireInitial(){
        _b002 = new no.ntnu.item.arctis.examples.android.cityguide.androidloginui.AndroidLoginUI();
        _b002.setBlockID("_b002", sessionID);
        _b005 = new no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy("", "");
        _b005.setBlockID("_b005", sessionID);
        _b007 = new no.ntnu.item.arctis.library.proxies.clientproxy.ClientProxy("", "");
        _b007.setBlockID("_b007", sessionID);
        _b004 = new no.ntnu.item.arctis.library.discovery.discoverservice.DiscoverService("login");
        _b004.setBlockID("_b004", sessionID);
        _b001 = new no.ntnu.item.arctis.examples.android.cityguide.loginapp.LoginApp();
        _b001.setBlockID("_b001", sessionID);
        _b003 = new no.ntnu.item.arctis.examples.android.cityguide.loginserviceproxy.LoginServiceProxy();
        _b003.setBlockID("_b003", sessionID);
        _state = s_0;
        return CONSUME_SIGNAL;
    }

    public int fire(java.lang.Object _sender, java.lang.Object sessionID, java.lang.String _signalID, java.lang.Object _data){
        if(_signalID.equals("_c1_Login_App_stop")) {
            return handleSignal__c1_Login_App_stop(_sender, sessionID, _data);
        } else if(_signalID.equals("RECEIVE__b005")) {
            return handleSignal_RECEIVE__b005(_sender, sessionID, _data);
        } else if(_signalID.equals("_c1_Login_App_start")) {
            return handleSignal__c1_Login_App_start(_sender, sessionID, _data);
        } else if(_signalID.equals("RECEIVE__b007")) {
            return handleSignal_RECEIVE__b007(_sender, sessionID, _data);
        } else if(_signalID.equals("CANCEL__b002")) {
            return handleSignal_CANCEL__b002(_sender, sessionID, _data);
        } else if(_signalID.equals("LOGIN__b002")) {
            return handleSignal_LOGIN__b002(_sender, sessionID, _data);
        }
        return TRIGGER_UNKNOWN;
    }

    private int handleSignal__c1_Login_App_stop(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_3 || _state == s_7 || _state == s_6 || _state == s_12 || _state == s_2 || _state == s_4) {
            scheduler.sendToParent(this,"_c1_Login_App_cancel", null);
            //TERMINATING SESSION VIA cancel;
            -- sessionCount;
            return TERMINATE_MACHINE;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_RECEIVE__b005(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_6) {
            no.ntnu.item.arctis.library.proxies.Message _b005_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            _b004.message = _b005_r0_message;
            java.lang.String _b004_o2 = _b004.getSignalID(_b004.message);
            if(_b004_o2.equals("ok")) {
                _b005.unsubscribe();
                no.ntnu.item.arctis.library.proxies.Address _b004_o3 = _b004.extractAddress(_b004.message);
                _b007.remote = _b004_o3;
                _b007.subscribe();
                _b003.found(_b004_o3);
                _b002.startUI();
                _state = s_2;
                return CONSUME_SIGNAL;
            } else {
                _b005.unsubscribe();
                _b003.notfound();
                //TERMINATING SESSION VIA failed;
                -- sessionCount;
                return TERMINATE_MACHINE;
            }
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal__c1_Login_App_start(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_0) {
                    _data = ((java.util.Map<String, Object>) _data).get("_data");
            _b005.remote = _b004.getRegisterAddress();
            _b005.subscribe();
            scheduler.startTimer(0, "t0", this);
            scheduler.startTimer(5000, "t1", this);
            _state = s_6;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_RECEIVE__b007(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_2) {
            no.ntnu.item.arctis.library.proxies.Message _b007_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            if(_b003.extractMessage(_b007_r0_message)==true) {
                _b002.closeUI();
                scheduler.sendToParent(this,"_c1_Login_App_loggedOn", _b002.cred);
                //TERMINATING SESSION VIA loggedOn;
                -- sessionCount;
                return TERMINATE_MACHINE;
            } else {
                _b002.reLogin(_b001.failed());
                _state = s_7;
                return CONSUME_SIGNAL;
            }
        } else if(_state == s_7) {
            no.ntnu.item.arctis.library.proxies.Message _b007_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            if(_b003.extractMessage(_b007_r0_message)==true) {
                _b002.closeUI();
                scheduler.sendToParent(this,"_c1_Login_App_loggedOn", _b002.cred);
                //TERMINATING SESSION VIA loggedOn;
                -- sessionCount;
                return TERMINATE_MACHINE;
            } else {
                _b002.reLogin(_b001.failed());
                return CONSUME_SIGNAL;
            }
        } else if(_state == s_3) {
            no.ntnu.item.arctis.library.proxies.Message _b007_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            if(_b003.extractMessage(_b007_r0_message)==true) {
                _b002.closeUI();
                scheduler.sendToParent(this,"_c1_Login_App_loggedOn", _b002.cred);
                //TERMINATING SESSION VIA loggedOn;
                -- sessionCount;
                return TERMINATE_MACHINE;
            } else {
                _b002.reLogin(_b001.failed());
                _state = s_7;
                return CONSUME_SIGNAL;
            }
        } else if(_state == s_4) {
            no.ntnu.item.arctis.library.proxies.Message _b007_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            if(_b003.extractMessage(_b007_r0_message)==true) {
                return CONSUME_SIGNAL;
            } else {
                _b001.failed();
                return CONSUME_SIGNAL;
            }
        } else if(_state == s_12) {
            no.ntnu.item.arctis.library.proxies.Message _b007_r0_message = (no.ntnu.item.arctis.library.proxies.Message) _data;
            if(_b003.extractMessage(_b007_r0_message)==true) {
                _b002.closeUI();
                scheduler.sendToParent(this,"_c1_Login_App_loggedOn", _b002.cred);
                //TERMINATING SESSION VIA loggedOn;
                -- sessionCount;
                return TERMINATE_MACHINE;
            } else {
                _b002.reLogin(_b001.failed());
                _state = s_7;
                return CONSUME_SIGNAL;
            }
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_CANCEL__b002(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_7) {
            _state = s_4;
            return CONSUME_SIGNAL;
        } else if(_state == s_3) {
            _state = s_4;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleSignal_LOGIN__b002(java.lang.Object _sender, java.lang.Object sessionID, java.lang.Object _data){
        if(_state == s_7) {
            no.ntnu.item.arctis.library.objects.login.Credentials _b002_r0_cred = (no.ntnu.item.arctis.library.objects.login.Credentials) _data;
            _b002.cred = _b002_r0_cred;
            _b007.send(_b003.createPinMessage(_b001.cast(_b002.cred)));
            _state = s_3;
            return CONSUME_SIGNAL;
        } else if(_state == s_2) {
            no.ntnu.item.arctis.library.objects.login.Credentials _b002_r0_cred = (no.ntnu.item.arctis.library.objects.login.Credentials) _data;
            _b002.cred = _b002_r0_cred;
            _b007.send(_b003.createPinMessage(_b001.cast(_b002.cred)));
            _state = s_12;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public int fireTimer(java.lang.String _timerID){
        if(_timerID.equals("t2")) {
            return handleTimer_t2();
        } else if(_timerID.equals("t1")) {
            return handleTimer_t1();
        } else if(_timerID.equals("t0")) {
            return handleTimer_t0();
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t2(){
        if(_state == s_6) {
            _b004.logTimeout();
            _b005.unsubscribe();
            _b003.notfound();
            //TERMINATING SESSION VIA failed;
            -- sessionCount;
            return TERMINATE_MACHINE;
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t1(){
        if(_state == s_6 || _state == s_4) {
            _b001.timeout();
            return CONSUME_SIGNAL;
        } else if(_state == s_7) {
            _b002.reLogin(_b001.timeout());
            return CONSUME_SIGNAL;
        } else if(_state == s_2) {
            _b002.reLogin(_b001.timeout());
            _state = s_7;
            return CONSUME_SIGNAL;
        } else if(_state == s_3) {
            _b002.reLogin(_b001.timeout());
            _state = s_7;
            return CONSUME_SIGNAL;
        } else if(_state == s_12) {
            _b002.reLogin(_b001.timeout());
            _state = s_7;
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    private int handleTimer_t0(){
        if(_state == s_6) {
            _b005.send(_b004.createDiscoverMessage());
            scheduler.startTimer(10000, "t2", this);
            return CONSUME_SIGNAL;
        }
        return DISCARD_SIGNAL;
    }

    public java.lang.String getPartName(){
        return null;
    }

    public java.lang.String getId(){
        return this._stateMachineID;
    }
}
