package no.ntnu.item.arctis.examples.android.cityguide.cityguideui;

import no.ntnu.item.arctis.examples.android.cityguide.getperiodiclocationupdates.LocationService;
import no.ntnu.item.arctis.library.proxies.actorrouter.android.ActorframeContainer;
import no.ntnu.item.arctis.runtime.Block;

public class CityGuideUI extends Block {

	public String LocFailed() {
		String msg = "Location Service Registration Failed";
		System.out.println("msg");
		return msg;
	}

	public String QuizFailed() {
			String msg = "Quiz Service Registration Failed";
			System.out.println(msg);
			return msg;
	}

	public void stop() {
		System.out.println("Stopping City Guide System...");		
		ActorframeContainer.getContext().killActorFrameModel();
		ActorframeContainer.getContext().stopSelf();		 	 
		LocationService.getInstance().stopSelf();	
		
		android.os.Process.killProcess(android.os.Process.myPid());
	}

	public String registerOk() {
		String msg = "City Guide Registration is OK, you can play it now.";
		System.out.println(msg);
		return msg;
	}

	
}