package no.ntnu.item.arctis.examples.android.cityguide.imserviceproxy;

import no.ntnu.item.arctis.library.objects.quiz.InstantMessage;
import no.ntnu.item.arctis.library.proxies.Address;
import no.ntnu.item.arctis.library.proxies.Message;
import no.ntnu.item.arctis.runtime.Block;

public class IMServiceProxy extends Block {

	
	public no.ntnu.item.arctis.library.proxies.Message message;
	public no.ntnu.item.arctis.library.objects.login.Credentials cred;
	public void found(Address addr) {
		System.out.println("IM service is found.."+addr.toString());
	}

	public void notfound() {
			System.out.println("IM service is not found..");
	}

	public Message createPinMessage(InstantMessage pin) {
		System.out.println("Sending message to IM service");
		Message m = new Message("IM");
			
		m.setPayload(pin);
		
	
		return m;
	}

	public InstantMessage extractMessage(Message msg) {
	
		System.out.println("received message from IM Server at IM service proxy......"+msg);
		InstantMessage m = new InstantMessage();
		m.setMessageText((String) msg.getPayload());
		return m;
	}
}