package no.ntnu.item.arctis.examples.android.cityguide.groupchatserviceproxy;

import no.ntnu.item.arctis.library.objects.quiz.InstantMessage;
import no.ntnu.item.arctis.library.proxies.Address;
import no.ntnu.item.arctis.library.proxies.Message;
import no.ntnu.item.arctis.runtime.Block;

public class GroupChatServiceProxy extends Block {

	
	public void found(Address addr) {
		System.out.println("GroupChat service is found.."+addr.toString());
	}

	public void notfound() {
			System.out.println("GroupChat service is not found..");
	}

	public Message createPinMessage(InstantMessage pin) {
		System.out.println("Sending message to GroupChat service");
		Message m = new Message("GroupChat");
			
		m.setPayload(pin);
		
	
		return m;
	}

	public InstantMessage extractMessage(Message msg) {
	
		System.out.println("received message from GroupChat Server at GroupChat service proxy......"+msg);
		InstantMessage m = new InstantMessage();
		m.setMessageText((String) msg.getPayload());
		return m;
	}

}
