package no.ntnu.item.arctis.examples.android.cityguide.locationawarequizservice;


import android.location.Location;
import no.ntnu.item.arctis.library.objects.quiz.Answer;
import no.ntnu.item.arctis.library.objects.quiz.Question;

import no.ntnu.item.arctis.library.proxies.Message;
import no.ntnu.item.arctis.runtime.Block;

public class LocationAwareQuizService extends Block {
	public no.ntnu.item.arctis.library.proxies.Message request;
	public no.ntnu.item.arctis.library.proxies.Message message;

	public Message createMessage(Answer ans) {
	
		System.out.println("creating message at quiz service");
		Message response = new Message("quiz-a"); 
		
			// TODO create answer
			String loc_result = ans.getAnswerText(); //location.getLatitude()+"_"+location.getLongitude();		
			
			response.setReceiver(message.getSender().getCopy());
			response.setSender(message.getReceiver().getCopy());	
			
			response.setPayload(ans.getAnswerText()) ; //(loc_result);
			
		return response;
	}

	public Question createQuestion(Message message) {
		Question ques = new Question();
		
		// TODO create question
		System.out.println("creating Question from Message..");
		
				
		if(message.getPayload() instanceof String){
			System.out.println("message.getPayload() instanceof Question");
			
			System.out.println("printing questionss..." + message.getPayload().toString() );
			
			ques.setQuestioText(message.getPayload().toString());
		}
		
		return ques;
	}

	public void registered() {
		System.out.println("Quiz Service is Regitered..");
	}

	public void registerFail() {
			System.out.println("Quiz Service Registration Failed..");
	}
}