package no.ntnu.item.arctis.examples.android.cityguide.locationservice;

import android.location.Location;
import no.ntnu.item.arctis.library.proxies.Message;
import no.ntnu.item.arctis.runtime.Block;

public class LocationService extends Block {
	public no.ntnu.item.arctis.library.proxies.Message request;
	public no.ntnu.item.arctis.library.proxies.Message message;

	public Message createMessage(Location location) {
	
		System.out.println("creating message at location service");
		Message response = new Message("location"); 
			String loc_result = location.getLatitude()+"_"+location.getLongitude();			
			response.setReceiver(message.getSender().getCopy());
			response.setSender(message.getReceiver().getCopy());	
			response.setPayload(loc_result);
		return response;
	}

	public void registerOk() {
		System.out.println("Location Service is Registered..");
	}

	public void registerFail() {
			System.out.println("Location Service is Registration Failed..");
	}
}