package no.ntnu.item.arctis.examples.android.cityguide.messagehandler;

import no.ntnu.item.arctis.library.objects.quiz.InstantMessage;
import no.ntnu.item.arctis.runtime.Block;

public class MessageHandler extends Block {

    private static MessageHandler messageHandler;
	public java.lang.String receivedMsg;
	public java.lang.Object part;
	public no.ntnu.item.arctis.library.objects.login.Credentials cred;
	public android.app.Activity activity;
	
	public MessageHandler(){
	messageHandler = this;
	}
	 public static MessageHandler getInstance(){
		return messageHandler;
	}
	
	public void sendFromActivityToBlock(String signal, Object data){
		sendToBlock(signal,data);
	}

	public void sendFromActivityToBlock(String signal){
		sendToBlock(signal);
	}
	
	public void setUsername() {
	    String user = cred.getUserName();
		MessagingActivity us = (MessagingActivity)this.activity;
		us.parseUsername(user);
	}
	
	public void setChatPartnerName() {
	if(part==null){
	String str[] = receivedMsg.split("#");
	System.out.println("Alternate   "+str[0] + str[1] +str[2]);
	String partner = str[0];
	MessagingActivity ws = (MessagingActivity)this.activity;
	 ws.parseChatPartner(partner);
	}
	
	 String chatpartner = (String) part;
	 MessagingActivity ws = (MessagingActivity)this.activity;
	 ws.parseChatPartner(chatpartner);
	}
	
	
	public void updateMessageHistory(InstantMessage msg) {
	System.out.println("Reply message displaying..");
	// update IM with new message from other player.
		MessagingActivity vs = (MessagingActivity)this.activity;
		vs.showNewMessage(msg);
	}
	
	public void showFirstReply() {
	
	// update IM with new message from other player.
	String str[] = receivedMsg.split("#");
	InstantMessage msg = new InstantMessage();
	msg.setMessageText(str[2]);
	System.out.println("FirstReply message displaying.."+str[2]);
		MessagingActivity vs = (MessagingActivity)this.activity;
		vs.showNewMessage(msg);
	}
	

}
