package no.ntnu.item.arctis.library.android.location.getcurrentlocation3;

import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import android.content.Intent;

public class GetCurrentLocation3 extends AndroidBlock {

	public android.content.Intent serviceIntent;

	public Class getLocationService() {
		return TheCurrentLocationService.class;
	}

	public Intent configureServiceIntent(Class theService) {
		serviceIntent = new Intent(getContext(), theService);
		serviceIntent.putExtra("BLOCK_ID", blockID);
		return serviceIntent;
	}

	public void startService() {
		getContext().startService(serviceIntent);
	}

	public void stopService() {
		getContext().stopService(serviceIntent);
	}

}