package no.ntnu.item.arctis.library.android.alc5;

import no.ntnu.item.arctis.runtime.AbstractRuntime;
import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import android.content.Intent;

public class ALC5 extends AndroidBlock {

public static final String BLOCK_ID_EXTRA_KEY = "BLOCK_ID";
	public android.app.Activity activity;

	public void startActivity(Class myActivity) {
		// create an intent to start the provided Activity
		Intent intent = new Intent(getContext(), myActivity);
		// add this block ID as extra, since the activity class uses it to send
		// signals
		intent.putExtra(BLOCK_ID_EXTRA_KEY, blockID);
		String wrapping = (String) AbstractRuntime.getRuntime(blockID).getContext("wrapping");
		if(wrapping!=null && wrapping.equalsIgnoreCase("service")) {
			intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
		}
		// the activity with the intent
		getContext().startActivity(intent);
	}

	public void finish() {
		activity.finish();
	}
}