package no.ntnu.item.arctis.library.android.androidmarket;

import android.content.Intent;
import android.net.Uri;
import no.ntnu.item.arctis.runtime.AbstractRuntime;
import no.ntnu.item.arctis.runtime.android.AndroidBlock;

public class AndroidMarket extends AndroidBlock {

	public void openMarketURI(String packageName) {
		Uri uri = Uri.parse("market://search?q=pname:" + packageName);
        Intent intent = new Intent(Intent.ACTION_VIEW, uri);
        String wrapping = (String) AbstractRuntime.getRuntime().getContext("wrapping");
		if(wrapping!=null && wrapping.equalsIgnoreCase("service")) {
			intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
		}
        getContext().startActivity(intent);
	}

}
