package no.ntnu.item.arctis.library.android.broadcastreceiver2;

import no.ntnu.item.arctis.runtime.AbstractRuntime;
import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;

public class BroadcastReceiver2 extends AndroidBlock {

	private android.content.BroadcastReceiver br;

	public void removeRegistration() {
		getContext().unregisterReceiver(br);
	}

	public void initializeReceiver(String[] input) {
		br = new android.content.BroadcastReceiver() {
			public void onReceive(Context context, Intent intent) {
				sendToBlock("INTENT_ARRIVED", intent);
			}
		};
		IntentFilter filter = new IntentFilter();
		for (String string : input) {
			filter.addAction(string);
		}
		getContext().registerReceiver(br, filter);
	}
}