package no.ntnu.item.arctis.library.android.startinvisibleactivity;

import no.ntnu.item.arctis.runtime.AbstractRuntime;
import no.ntnu.item.arctis.runtime.android.AndroidBlock;
import no.ntnu.item.arctis.runtime.android.InvisibleActivity;
import android.content.Intent;

public class StartInvisibleActivity extends AndroidBlock {

	public void startActivity() {
		Intent intent = new Intent(getContext(), InvisibleActivity.class);
		intent.putExtra(InvisibleActivity.BLOCK_ID_EXTRA_KEY, blockID);
		intent.putExtra(InvisibleActivity.SESSION_ID_EXTRA_KEY, sessionID);
		//getContext().startActivity(intent);
		String wrapping = (String) AbstractRuntime.getRuntime().getContext("wrapping");
		if(wrapping!=null && wrapping.equalsIgnoreCase("service")) {
			intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
		}
		getCurrentActivityContext().startActivity(intent);
	}

}