package no.ntnu.item.arctis.library.swing.logindialog;

import java.awt.GridLayout;

import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;

import no.ntnu.item.arctis.library.objects.login.Credentials;
import no.ntnu.item.arctis.runtime.Block;

public class LoginDialog extends Block {

	public void openDialog() {
		JPanel connectionPanel;
		JLabel userNameLabel = new JLabel("Username:   ", JLabel.RIGHT);
		JTextField userNameField = new JTextField(30);
		JLabel passwordLabel = new JLabel("Password:   ", JLabel.RIGHT);
		JTextField passwordField = new JPasswordField(30);
		connectionPanel = new JPanel(false);
		connectionPanel.setLayout(new BoxLayout(connectionPanel, BoxLayout.X_AXIS));
		JPanel namePanel = new JPanel(false);
		namePanel.setLayout(new GridLayout(0, 1));
		namePanel.add(userNameLabel);
		namePanel.add(passwordLabel);
		JPanel fieldPanel = new JPanel(false);
		fieldPanel.setLayout(new GridLayout(0, 1));
		fieldPanel.add(userNameField);
		fieldPanel.add(passwordField);
		connectionPanel.add(namePanel);
		connectionPanel.add(fieldPanel);

		int result = JOptionPane.showOptionDialog(null, connectionPanel, "Login", JOptionPane.OK_CANCEL_OPTION, JOptionPane.PLAIN_MESSAGE, null,
				new String[] { "Login", "Cancel" }, "Login");
		if (result == 0) {
			Credentials credentials = new Credentials(userNameField.getText(), passwordField.getText());
			sendToBlock("LOGIN", credentials);
		} else {
			sendToBlock("CANCEL");
		}
	}

	public static void main(String[] args) {
		LoginDialog l = new LoginDialog();
		l.openDialog();
	}

}
